program DUG8;
(* PROCESAR INICIALIZACIONES Y NODOS *)
uses
  Dialogs,
  ug1 in 'Ug1.pas',
  ug2 in 'Ug2.pas',
  ug3 in 'Ug3.pas',
  ug4 in 'Ug4.pas',
  ug5 in 'Ug5.pas',
  ug6 in 'Ug6.pas',
  ug7 in 'Ug7.pas';

VAR YEAR,MONTH,DAY,DIASEM:WORD; cfi,cri,cnumde:st10; numde, ibarra:integer;

procedure prinet; (* procesar inicializaciones y nodos *)
(**********************************************************ENCNOD *)
(*********************************************************VERPARE *)
procedure verpare; (*ver si es nodo o palabra reservada *)
begin
 butanod;
 if not bc then error('node name used as identifier');
 verpar; (*ver si es palabra reservada*)
end;
(*********************************************************ENCNOD********)
procedure encnod(beg:boolean); (*encabezamiento nodo,label beg si begin*)
begin
 inser(fosa[61],'*',nod^[jn].nom,ren1,0); tranlin(4,true);(*encab. proc.*)
 (*delphi 1.11.00*) ren1:='var icopy: integer;';
                    tranlin(4,true); {por si hay, debe ser local}
 if nod^[jn].plab<>nil then
  begin
   ren1:='label '; tranlin(4,true);
   plab:=nod^[jn].plab; maome:=',';
   while plab<>nil do
    begin if plab^.pls=nil then maome:=';' ;
     ren1:=plab^.nom+maome; tranlin(4,false); plab:=plab^.pls
    end
  end;
 recid;
 if nom='VAR'
  then
   begin    (*recoger variables locales*)
    huboVarNodeG:=true;  //02.07.2002
    ki:=m;                     (*28/3/1998*)
    prog:=nod^[jn].nom;
    bencpf:=false; bprocp:=true; bvprocp:=false; bfunp:=false;
    ptra:=4; btran:=true;
    bprovln:=true;     (*30/4/1997*)
    provar;
    recid;
    bprovln:=false;    (*30/4/1997*)
    if (ch=':') and (pl^.con[k+1]=':')
     then begin tranhas(k,ptra); k:=k+2; ki:=k end
     else error(':: expected');
     bencpf:=true; bprocp:=false;
     limpbuf(ptra);
   end
  else k:=m;

 if beg then begin ren1:=fosa[20]; tranlin(4,true) end;
end;
(*********************************************************** PRIN *)
procedure prin; (* procesar nodos tipo I *)
begin bnst:=true;buse:=false;
 encnod(true);

 inser(fosa[15],'*',cjn,ren1,0); tranlin(4,true); (* new(p*#) etc. *)
 (*increm. numero de mensaje y ponerlo en _px^.number y numero en
 _px^.nor*)
 inser(fosa[137],'*',cjn,ren1,0); inser(ren1,'%',cjn,ren1,0);

 tranlin(4,true);
 inser(fosa[336],'*',cjn,ren1,0); tranlin(4,true);

 if nod^[jn].est then
 begin
  inser(fosa[113],'*',nod^[jn].cnes,ren1,0);tranlin(4,true); (*estad.*)
 end;
 inser(fosa[67],'*',cjn,ren1,0); tranlin(4,true); (* poner seg ofs *)

 while lb<lbf do begin  IF W THEN WRITELN('PROC.CODIGO LIN ',LB);
 prins;{recid;k:=m} end;

 {if not buse then ren1:='use:=1;'; tranlin(4,false);} (*defecto use:=1*)
 if bnst and (nod^[jn].sub>1)
  then error('Node I multiple without SENDTO');
 if bnst then  (* si no hay SENDTO gen.envio aut.a n.suc.con act.*)
  geans(true); ren1:=fosa[21]; tranlin(4,false); (* finaliz. end end; *)
end;

(*********************************************************** PRLI *)
procedure prli; (* procesar nodo tipo L *)
begin bnflo:=true;
 encnod(true);
 inser(fosa[35],'*',cnel,ren1,0);tranlin(4,true);
 ren1:=fosa[36]; tranlin(4,true); (* while *)
 if nod^[jn].antc then gllc; (* si es sucesor de nodo C gen.llamada *)
 inser(fosa[25],'*',cnel,ren1,0);tranlin(4,false); (* _extr de el *)
 ren1:=fosa[26]; tranlin(4,false); (* et uprv *)
 ren1:=fosa[52]; tranlin(4,false); (* _acc:=true *)
 bextr:=false; (* para no extraer en SENDTO *)

 while lb<lbf do begin prins; {recid;k:=m} end;

 ren1:=fosa[33]; tranlin(4,false); (* upvr *)
 if bnflo then
  begin (* no hubo LIFO FIFO u ORDER, paso automatico a IL *)
   (*????? solo si hubo sendto*)
   ren1:=fosa[48]; tranlin(4,true);  (* if _acc then *)
   inser(fosa[18],'.',cnil,ren1,0);tranlin(4,false) ; (* agr fin de il *)
  end;
 inser(fosa[87],'.',cnel,ren1,0); tranlin(4,false);(* end while:_px..end *)
 ren1:=fosa[21]; tranlin(4,false); (* end del prli *)
end;


(*********************************************************** PRRE *)

procedure prre; (* procesar nodo tipo R *)
begin
buse:=false;(* no aparecio USE *)
bnpree:=true; (* por ahora no PREEMPTION *)
 encnod(false);   (*proc.etc sin begin*)
 inser(fosa[174],'/',cjn,ren1,0); tranlin(4,true); (* enc. y RELEASE *)
 ren1:=fosa[138]; tranlin(4,false); (* poner _fre:=true *)
 inser(fosa[31],'*',cnil,ren1,0);tranlin(4,true); (*extr.de il*)
 ren1:=fosa[32]; tranlin(4,true); (*para usar use y demas *)
 recid;
 if nom<>'RELEASE'(* si no hay RELEASE envio aut.sin act.*)
 then
  begin           (*siempre que haya sucesores!!*)
   k:=m; if nod^[jn].apns<>nil then geans(false)
  end

  else (* pero si hay RELEASE *)
   begin ki:=k; bnst:=true;(* act.var.*)
    if nod^[jn].apns=nil then error('RELEASE without succesor node');
    brelea:=true;
    prins;(* procesar instruccion del RELEASE debe tener SENDTO*)
    brelea:=false;
    tranhas(k,ptra); ki:=k; (* completar transmision del RELEASE *)
    if bnst then geans(true);
   end;
   ren1:=fosa[245]; tranlin(4,true); (* if _fre then begin *)
  gefre(jn); (* generar instrucciones de liberacion de recurso *)

  ren1:=fosa[44]; tranlin(4,false); (* end del RELEASE *)
inser(fosa[35],'*',cnel,ren1,0);tranlin(4,true); (* _px:=_fl[]  *)
inser(fosa[36],'*',nomr,ren1,0); tranlin(4,true);(*while _px free*)
inser(fosa[37],'*',cnel,ren1,0); tranlin(4,true);(*_px exal uprv *)
ren1:=fosa[52]; tranlin(4,false);  (* acc true *)
ren1:=fosa[229]; tranlin(ptra,false); (* _sta:=false *)

bnsend:=true; (*en nodo R parte no RELEASE no vale SENDTO, a no ser que
                haya PREEMPTION*)
while lb<lbf do begin prins end; (* si STOPALL , _acc:=false *)
                                 (* si REMA , brem:=true,etc.*)


{inser(fosa[187],'*',nomr,ren1,0);tranlin(4,true); (*if 1 0 _use 1 0 *)
inser(fosa[188],'*',nomr,ren1,0);tranlin(4,false);(* si no _use=use *)

ren1:='_use:=use;'; tranlin(4,false); }
inser(fosa[38],'*',nomr,ren1,0);tranlin(4,true); (*if_use>free, acc false*)
ren1:=fosa[46]; tranlin(4,false); (* if _acc  then begin  *)
inser(fosa[42],'*',cnel,ren1,0);tranlin(4,false); (* extr de el,pon.tiempos*)
ren1:=fosa[230]; tranlin(4,true);
inser(fosa[60],'*',cjn,ren1,0);tranlin(4,false); (*;afel else px^.x:=-1*)
ren1:=fosa[33]; tranlin(4,false); (* upvr *)
inser(fosa[18],'.',cnil,ren1,0);tranlin(4,false); (* agregar a il *)
inser(fosa[43],'*',nomr,ren1,0);tranlin(4,false); (* aj  free *)
acesura(jn);       (* estadistica anterior del u_nxx *)
inser(fosa[176],'*',nomr,ren1,0);tranlin(4,false); (* aj used *)
acesurp(163); (* estadistica posterior del u_nxx *)
ren1:=fosa[21]; tranlin(4,false); (* end del if _acc then .. *)
inser(fosa[231],'*',cnel,ren1,0); tranlin(4,false);(* fin while: end *)
if bnpree then  (*si no hubo PREEMPT,si no recurso para revi.de EL *)
 inser(fosa[276],'*',nomr,ren1,0) else ren1:='_px:=_px^.p;';
 tranlin(4,true);
ren1:=fosa[21]; tranlin(ptra,true);
ren1:=fosa[21]; tranlin(4,false);  (* end; del procedure *)
brem:=false; bnsend:=false;
end;

(*********************************************************** PRGA *)
procedure prga; (* procesar nodo tipo G *)
begin
 encnod(true);
 if huboVarNodeG then begin recid; k:=m; end; //02.07.2002
 if nom<>'STATE' // 01.03.2002
 then
  begin  //18.6.2002 correccin de reparacin
   k:= m; //recid // k:=m //01.03.2002  (No aceptaba var local)
  end
  else
   begin recid;
    ki:=k;       (*!!!!!!!!!! igual que el DONODE !!!!!!!!!*)
    bstate:=true;
    inser(fosa[178],'/',cjn,ren1,0);tranlin(4,true);(* if _n=# ci1=1 ino=iev*)
    prins; (*procesar la instr. del STATE *) tranhas(k,4); ki:=k;
    ren1:=fosa[21]; tranlin(4,true); (* end; del if _nc=# and ci1= ... *)
    bstate:=false
   end;
  (* procesar parte REVIEW !!!!! debe haber texto !!!*)
bnst:=true;            (* por ahora no hay SENDTO *)
inser(fosa[24] ,'*',cnel,ren1,0); tranlin(4,true);(*_px:=_el[]while_px<>*)
inser(fosa[309],'*',cnel,ren1,0); tranlin(4,true);
inser(fosa[37],'*',cnel,ren1,0); tranlin(4,true);(*_exal uprv acc:=fals*)
ren1:='_besc:=false; SENT:=false;'; tranlin(4,false);
ren1:=fosa[40]; tranlin(4,false);
bextr:=true; (* para extraer en SENDTO y GO *)

while lb<lbf do begin IF W THEN WRITELN('PROC.CODIGO LIN ',LB);

prins;{recid;k:=m} end; (* codigo.del nodo G,SENDTO pone _acc false *)

{ren1:=fosa[204]; tranlin(4,false); (* if _acc not sync then begin  *)
inser(fosa[49],'.',cnel,ren1,0);tranlin(4,false);
geans(true); (* envio automatico con actualizacion *)
ren1:=fosa[21]; tranlin(4,false); (* end del if _acc then .. *)

(************?? actualizar el que queda detenido ??????????? *)
inser(fosa[134],'&',cnel,ren1,0); tranlin(4,false);(*rep o sig endif *)
 }

ren1:=fosa[204]; tranlin(4,false); (* if _acc not sync then begin  *)
inser(fosa[134],'&',cnel,ren1,0); tranlin(4,false);(*rep o sig endif *)
ren1:=fosa[44]; tranlin(4,false);  (* end; del while y procedure *)
bextr:=false;
end;

(************************************************************ PRDE *)
procedure prde; (* procesar nodo tipo D *)
begin
 encnod(false);
 if nod^[jn].NANT=1 then  (* hay un solo antecesor *)
   begin bnst:=true; ren1:=fosa[20]; tranlin(4,true);
    nom2:=csub; (*busel (bulesu) exige subindice en nom2*)
    busel(jn,nod^[jn].apna^.num,cnel,false); (* poner el en cnel *)
    inser(fosa[35],'*',cnel,ren1,0);tranlin(4,true);
    ren1:=fosa[36]; tranlin(4,true); (* while *)
    inser(fosa[25],'*',cnel,ren1,0);tranlin(4,true); (* _px _extr de el *)
    ren1:=fosa[32]; tranlin(4,false); (* uprv(_px^.r,etc.) *)
    while lb<lbf do begin prins;{recid;k:=m} end;
    if bnst then error('SENDTO not found in type D node');
    inser(fosa[87],'.',cnel,ren1,0); tranlin(4,false);(* end while: end *)
    ren1:=fosa[21]; tranlin(4,false)  (* end; del proc. D sin SELECT*)
   end (* del caso una sola lista (sin SELECT) *)
  else (* hay varias listas de entrada, debe haber SELECT *)
   begin (* hay SELECT, procesarlo; generar procedimiento en modnet*)

     nsel:=0; (* contar numero de SELECT *)
    rewrite(modaux);  (* para escribir texto del nodo D en modaux *)
    cend:=1;          (* para contar los end requeridos *)
    str(nod^[jn].sub-1,cind); ptra:=5;btran:=true;
    ren1:=fosa[20]; tranlin(ptra,true); (* begin del proc. texto D *)
    while lb<lbf do begin prins;recid;k:=m end; (* instrucc. de nodo D *)
    if nsel=0 then
      error('SELECT missing in type D node with many antecesors');
    ren1:=fosa[21]; tranlin(ptra,true); (* end del proc. texto D *)
    limpbuf(ptra);
    closeFile(modaux); reset(modaux);
    limpbuf(4); (* limpiar buffer 4 *)
    while not eof(modaux) do
     begin readln(modaux,ren);
     writeln(modnet,ren)
    end;
    closeFile(modaux); ptra:=4;
   end (* del else caso con SELECT *)
end;


(*********************************************************** PREX *)
procedure prex; (* procesar nodo tipo E *)
begin
 encnod(true);
 inser(fosa[35],'*',cnel,ren1,0);tranlin(4,true);
 ren1:=fosa[36]; tranlin(4,true); (* while *)
 inser(fosa[25],'*',cnel,ren1,0);tranlin(4,true); (* _px _extr de el *)
 ren1:=fosa[32]; tranlin(4,false); (* uprv(_px^.r,etc.) *)
 if nod^[jn].est then
  begin
   inser(fosa[154],'*',nod^[jn].cnes,ren1,0); tranlin(4,false); (*est.tm.*)
   inser(fosa[480],'%',nod^[jn].cnes,ren1,0); tranlin(4,false); (*est.t2.*)
   inser(fosa[482],'*',nod^[jn].cnes,ren1,0); tranlin(4,false); (*est.t1*)
   inser(fosa[483],'*',nod^[jn].cnes,ren1,0); tranlin(4,false); (*est.tx*)
  end;
 while lb<lbf do begin prins;{recid;k:=m} end;
 ren1:=fosa[66]; tranlin(4,false); (* elim(_px^.,etc.r) dispose *)
 inser(fosa[87],'.',cnel,ren1,0); tranlin(4,false);(* end while: end *)
 ren1:=fosa[21]; tranlin(4,false)  (* end; del procedure *)
end;

(*********************************************************** PRSC *)

procedure prsc; (* procesar nodo de simulacion continua *)
begin
 metod:=1; bnodc:=true;
 chuk:=nod^[jn].nom;  (*nombre del nodo para abreviar*)
 encnod(true);
 inser(fosa[268],'/',cjn,ren1,0);
 inser(ren1,'*',chuk,ren1,0); tranlin(4,true); (*if _n=#nodo *)
 inser(fosa[270],'*',chuk,ren1,0); tranlin(4,true); (*_dt:=time- *)
 ren1:=fosa[326]; tranlin(4,true);  (*repeat _dta:=_dt *)
 inser(fosa[270],'*',chuk,ren1,0); tranlin(4,true); (*_dt:=time- *)
 ren1:=fosa[274]; tranlin(4,true);  (* if _dt<>0 begin proces. de instr.*)

    (* proc. instr. calc.m,n  y generar lineas del case de _ff y _rkf*)
 while lb<lbf do begin prins end;

 inser(fosa[327],'*',chuk,ren1,0);
 tranlin(ptra,true); (* _tc_*:=_tc_*+_dt *)
 ren1:=fosa[30]; tranlin(4,true); (*begin end por si se agregan metodos*)
 inser(fosa[328],'*',chuk,ren1,0); tranlin(4,true);
 inser(fosa[329],'*',chuk,ren1,0); tranlin(4,true); (*until _tc_*=time *)

 inser(fosa[330],'*',chuk,ren1,0); tranlin(ptra,true); (*if ino0 _bitrue *)
 str(n,cnm1);
 inser(fosa[262],'*',cnm1,ren1,0);   (*numero de nodos*)
 tranlin(4,true); (*if ino=0 then  _k=#n-1;swt:=true *)
 inser(fosa[331],'*',chuk,ren1,0); tranlin(4,true);
 inser(fosa[332],'*',chuk,ren1,0); tranlin(4,true);
 inser(fosa[261],'/',cjn,ren1,0);
 inser(ren1,'*',chuk,ren1,0); tranlin(4,true);
 ren1:=fosa[30]; tranlin(4,true);
 ren1:=fosa[44]; tranlin(4,true);
 bnodc:=false;
end;
(*********************************************************** PRAU *)
procedure prau; (*procesar nodo autonomo*)
begin encnod(true);
{ inser(fosa[178],'/',cjn,ren1,0); tranlin(4,true); (*if n cic1 ino=iev *)
 }
 while lb<lbf do begin prins end;
 ren1:=fosa[21]; tranlin(4,true)  (* end; del DONODE y procedure *)
end;

(*********************************************************** PRCO *)
procedure prco; (* procesar nodo comun *)
begin
encnod(true);
if nod^[jn].antc then gllc; (* si es sucesor de nodo C gen.llamada *)
 while lb<lbf do begin prins;recid;k:=m end;
 ren1:=fosa[21]; tranlin(4,false); (* end del prco *)
end;


(*********************************************************** PRNO *)
procedure prno; (* procesar nodos *)

(**********************************************************VERSIUN*)
procedure versiun; (*ver si se encabeza unidad*)
 var copc,cuj,cnumun:string[10]; numun:integer;
 begin
   numun:=nod^[jn].uni; (* numero de nueva unidad o cero *)
IF W THEN BEGIN WRITELN('VER SI HAY UNIDADES NUMUN ',NUMUN); READln(UT) END;
   if numun>0 then (*comienza unidad, generar encabezamiento;*)
    begin
     if numun>1 then   (*poner fin de la unidad anterior*)
      begin ren1:='end.';  tranlin(4,true);
       limpbuf(4); closeFile(modnet)
      end;
      (*encabezamiento unidad del NETWORK va a modnet (4) *)
     str(numun,cnumun); cnumun:='unid'+cnumun;
     {delphi 13.11.2000 assign(modnet, cnumun+'.pas'); rewrite(modnet);}
     assign(modnet,dirname+cnumun+'.pas'); rewrite(modnet);
      ren1:='unit '+cnumun+';' ;  tranlin(4,true);  (* unit unid#; *)
      ren1:='interface '; tranlin(4,true);
      ren1:=fosa[488]; tranlin(4,true); (* uses crt,....,gdinar; *)
      ren1:=fosa[530]; tranlin(4,true); (* Delphi 2000 uses uglmemo,Dialogs, caben mas *)
      if hayuses then palisun(4) (*pasar lista de units del usuario*)
                                                       (*25/10/1998*)
      else begin ren1:=';'; tranlin(4,true) end;       (*25/10/1998*)
{MARTA 24.05.2004} ren1:='var _i,_j: integer;'; tranlin(4,true);
      inser(fosa[61],'*',nod^[jn].nom,ren1,0);
      tranlin(4,true);
      j:=jn+1;
      while (nod^[j].uni=0) AND (j<=n) do
       begin inser(fosa[61],'*',nod^[j].nom,ren1,0);
        tranlin(4,true); j:=j+1;
       end;

      ren1:='implementation'; tranlin(4,true);
{      if numun<numunt then
       begin
        ren1:='uses '; tranlin(4,true);
        copc:=',';
        for j:=numun+1 to numunt do
         begin if j=numunt then copc:=';' ;
          str(j,cuj); ren1:='unid'+cuj+copc;
          tranlin(4,true)
         end;
       end
}
    end;
 end; (*de ver si se encabeza unidad*)

(*d95*) var _jn: integer;
begin             (*DE PRNO*)
IF W THEN WRITELN('PROCESAR NODOS 1'); IF W THEN READln(UT);
 ptra:=4;
 str(n,cn); str(n-1,cnm1);  (*numero del nodo y menos1 en char*)
 for _jn:=1 to n do
  begin jn:=_jn;
   pl:=nod^[jn].pl; lb:=nod^[jn].lb;
   k:=nod^[jn].separ; ki:=k; str(jn,cjn);
   if jn<n then lbf:=nod^[jn].nextl else lbf:=block[2];
{IF W THEN BEGIN WRITELN('NODO ',nod^[JN].NOM,
               '  N=',JN,' LIN.COL ',NOD^[JN].LB,' ',NOD^[JN].SEPAR,
               '  PROX.LINEA ',LBF);
               READln(UT) END;
    }
IF W THEN WRITELN('PROCESAR NODOS 2'); IF W THEN READln(UT);
    {limpbuf(4);}    bextr:=false;
IF W THEN WRITELN('PROCESAR NODOS 3'); IF W THEN READln(UT);

   str(nod^[jn].sub,csub);    (* valor maximo subin. en char. *)
   str(nod^[jn].sub-1,csub1); (* el anterior disminuido en 1 *)
   nel:=nod^[jn].el; str(nel,cnel);  (*num. de EL en char*)
   nli:=nod^[jn].il; str(nli,cnil);  (*num. de IL en char*)

   if (nod^[jn].sub>1)      { and (nod^[jn].nant=1) }
    then       (*si tiene sub.  va nEL-1+ino*)
    begin  nel:=nel-1; str(nel,cnel); cnel:=cnel+'+ino';
           nli:=nli-1; str(nli,cnil); cnil:=cnil+'+ino'
    end;
IF W THEN WRITELN('VA A VER SI HAY UNID'); IF W THEN READln(UT);
   versiun;
IF W THEN WRITELN('VIO SI HAY UNID'); IF W THEN READln(UT);
huboVarNodeG:=false;  //02.07.2002
    case nod^[jn].tipo of
    'G': prga;
    'L': prli;
    'I': prin;
    'D': prde;
    'E': prex;
    'R': prre;
    'C': prsc;
    'A': prau;
    else prco;
   end
  end
end;

procedure gedenume;
(*generar decl. de numeradores de mensajes _NUME1,_NUME2, etc.*)
var cs:char; (* coma o dos puntos*)   ci:st10;
(*d95*) var _i: integer;
begin
cs:=',';
ren1:='var '; tranlin(1,true);
for _i:=1 to n do
 if nod^[_i].tipo='I' then
 begin if (_i=ulni) and (ncrea=0) then cs:=':' ;
  str(_i,ci);
  ren1:='_NUME'+ci+cs; tranlin(1,false);
 end;

 for _i:=ulni+1 to ulni+ncrea do
  begin  str(_i,ci); if _i=ulni+ncrea then cs:=':' ;
   ren1:='_NUME'+ci+cs; tranlin(1,false);
  end;
ren1:='integer;' ; tranlin(1,false);
end;

(********************************************************GECLRST***)
procedure geclrst; (*generar procedimiento CLRSTAT *)
(* generar inicializaciones de estadisticos: llegadas,salidas,var. *)
  var cuj:st10;
begin
  limpbuf(3);
  ren1:=fosa[57];  tranlin(3,true); (*  encab _inies *)
  inser(fosa[115],'*',nulic,ren1,0); tranlin(3,true); (*inicial. listas*)
  ren1:=fosa[136]; tranlin(3,true); (* _lm[_j]:=0;... *)
  ren1:=fosa[75];tranlin(3,true);  (* _la[                _tl[_j]:= 0 *)
  ren1:=fosa[293];tranlin(3,true);  (* _tp[_j] _tp2[_j] _mtp[-j]:= 0 *)
  ren1:=fosa[21]; tranlin(3,true);

  inser(fosa[164],'*',nst,ren1,0); tranlin(3,true); (*blck[] false*)


  if nnll>1 then
   begin inser(fosa[114],'*',cnnll,ren1,0); tranlin(3,true);
   end;

  if nees>1 then (*para nodos E inicializar estad.de tp.en sist.*)
   begin inser(fosa[153],'*',cnees,ren1,0); tranlin(3,false);
   inser(fosa[481],'*',cnees,ren1,0); tranlin(3,false);
    ren1:=fosa[21]; tranlin(3,true);
   end;

  if nves>0 then
   begin inser(fosa[158],'*',cnves,ren1,0); tranlin(3,true);
   ren1:=fosa[486]; tranlin(3,true);
    ren1:=fosa[159]; tranlin(3,true);    (* inic. acumul.*)
   end;
   ren1:=fosa[292]; tranlin(3,true); (* inic. _fr a cero *)

  ren1:='_nuno:='+nst+';' ; tranlin(3,true);  (*numero de nodos*)
  ren1:=fosa[21]; tranlin(3,true);
end;

(**************************************************GEINTIGRAF****)
procedure geintigraf; (*generar _initgraph e _initgrafa*)
begin
(* generar _INTIGRAF e _INTIGRAFA de grafico interac. de func. XY*)
(* y hacer verificaciones de inicializaciones *)
pfu:=pfuf; (*verificar si hay funciones sin tabla *)

while pfu<>nil do
begin     
 if not pfu^.btafu then error('function not initialized');
 if pfu^.inti then
  begin
   if pfu^.arg='REAL'
   then
    begin inser(fosa[346],'*','false',ren1,0); tranlin(6,true);
     inser(fosa[343],'&',pfu^.nom,ren1,0);
    end
   else
    begin inser(fosa[346],'*','true',ren1,0); tranlin(6,true);
     inser(fosa[345],'&',pfu^.nom,ren1,0);
    end;

   if pfu^.cla='SPLINE' then str(pfu^.nfspl,cnfspl) else cnfspl:='1';
   inser(ren1,'@',cnfspl,ren1,0);
   if pfu^.cla='POLYG' then ntip:='1'
   else if pfu^.cla='SPLINE' then ntip:='2'
   else if pfu^.cla='STAIR' then ntip:='3'
   else if pfu^.cla='DISC'  then ntip:='4'
   else if pfu^.cla='FREQ' then ntip:='5'
   else ntip:='6';
   inser(ren1,'%',ntip,ren1,0);
   inser(ren1,'/',pfu^.nom,ren1,0);
   tranlin(6,true);
  end;
 pfu:=pfu^.pfus
 end;
end;

(*d95*) var _lb, _i: integer;
begin  (* comienzo del procedure ******************************** prinet *)
IF W THEN WRITELN('PROCESAR INICIALIZACIONES DEL USUARIO **************** ');
binit:=true;
bmod:=false; bmod1:=true; bdeclr:=false; btran:=true;{ rewrite(modnet);}
pl:=plf; j:=block[2]-1;
for _lb:=1 to j do pl:=pl^.pls;(*ubicar INIT*)
lb:=block[2];
k:=1; bprin:=true; im:=2;  ptra:=6; (* para escribir texto en modini1 *)
recid; {elim(1,k-1); k:=1;} ki:=K;  (*pasar INIT; requiere elim??*)
if ctit then lb:=lb+1; lbf:=block[3];
for _i:=1 to 5 do begin ren1:=afel[_i]; TRANLIN(3,TRUE) end;
{d95 for _i:=1 to 5 do begin ren1:=errpr[_i]; TRANLIN(3,TRUE) end;}
ren1:=' ';      tranlin(3,true);

(* CONSTRUIR INIT EN MODINI1 6 *)
ren1:=fosa[91]; tranlin(6,true);  (* enc.INIT y luego decl. en modec *)
ren1:=fosa[20]; tranlin(6,true);
ren1:=fosa[81]; tranlin(6,true); (*gettime*)
inser(fosa[115],'*',nulic,ren1,0); tranlin(6,true); (*inicial. listas*)

ren1:=fosa[74];tranlin(6,true);
{multig 8.2.2001} ren1:=fosa[528];tranlin(6,true);

ren1:=fosa[400] ; tranlin(6,true);  (*_bpg, randseed *)
ren1:=fosa[308]; tranlin(6,true);
ren1:=fosa[325]; tranlin(6,true); (* EREL EABS *)
ren1:=fosa[471]; tranlin(6,true); (*if _rep then nrep+1*)
while lb<lbf do  (* buscar hasta linea final *)
 begin
  prins; (* procesar instruccion; pasar a modini1*)
  recid;
 k:=m; (* prov.cambio lin *)
 end;
 binit:=FALSE;
 if not bacti then error('no ACT procedure in INIT');
 {Delphi 2.03.2001} if UserWindowSizes[1] and UserWindowSizes[2]
                   then begin //6.4.2003
                        ren1:='_windowsize:=true;'; tranlin(6,true);
                        end; //6.4.2003
IF W THEN WRITELN('FIN PROCESADO INIT USUARIO**********************');

geintigraf; (*generar llamadas a _intigraf (a) *)

geclrst; (*generar procedimiento _com *)

if bexpa then gelvex (* generar lectura de variables experimentales *)
         else begin ren1:=fosa[172]; tranlin(3,true) end; (*prbeginend*)

(* generar inicializaciones de indices k de inicializaciones de arreglos*)
(*indices numericos*)
{if ukmax>0 then  }
 begin ren1:='var'; tranlin(1,true); coma:=' ';
  for _i:=1 to 20 {ukmax} do
   begin str(_i,cncia);
    ren1:=coma+'_k'+cncia; tranlin(1,false); coma:=','
   end;
  ren1:=':integer;'; tranlin(1,false);
 end;

(*indices escalares*)
if pavef<>nil then
begin  ren1:='var ';tranlin(1,true);
 pave:=pavef;
 while pave<>nil do
 begin
  ren1:='_k'+pave^.nomt+':'+pave^.tipo+'; ';
  tranlin(1,false);
  pave:=pave^.ps
 end
end;

if itmx<0 then itmx:=1;
str(itmx,cncia);
inser(fosa[289],'#',cntab,ren1,0); inser(ren1,'*',cncia,ren1,0);
tranlin(1,true);
ren1:=fosa[290]; tranlin(1,true);
ren1:=fosa[291]; tranlin(1,true);

(*si hay variables FREQ generar declaraciones y poner las RAND_XX
 en arbol para que sean reconocidas en el fuente*)
pfrmx:=pfrmf;
while pfrmx<>nil do
begin nom:=pfrmx^.nom; busidar; str(pva^.dim,cnin);
 IF W THEN WRITELN('VA A GENERAR DECL PARA RANDV_<ARREGLO>');
 inser(fosa[402],'*',nom,ren1,0); inser(ren1,'/',cnin,ren1,0);
 tranlin(1,true); (*randv_XX:array etc*)
 inser(fosa[403],'*',nom,ren1,0); inser(ren1,'/',cnin,ren1,0);
 pnx:=pva^.apind;
 while pnx<>nil do
  begin str(pnx^.max,cmaxin); ren1:=ren1+cmaxin; pnx:=pnx^.ps;
   {if pnx^.min<>1 then error('minimum index of FREQ array<>1');}
   if pnx<>nil then ren1:=ren1+',' else ren1:=ren1+');' ;
  end; tranlin(1,true);
 inser(fosa[404],'*',nom,ren1,0); tranlin(1,true);
 inser(fosa[405],'*',nom,ren1,0); inser(ren1,'/',cnin,ren1,0);
 tranlin(6,true);
 inser(fosa[406],'*',nom,ren1,0); inser(ren1,'/',cnin,ren1,0);
 tranlin(6,true);
 inser(fosa[407],'*',nom,ren1,0); tranlin(6,true);
 bg:=true; tipo:='ARRAY'; nom:='RANDV_'+nom;
 stvname(true,nom); (*poner en arbol*)  bg:=false;
 pfrmx:=pfrmx^.ps;
end;

(*si hay FACTOR y RESPONSE generar declaraciones y codigos*)
if bfact then
begin
 ren1:=fosa[452]; tranlin(1,true);  (*type record= _ar etc.*)
 ren1:=fosa[453]; tranlin(1,true);
 ren1:=fosa[454]; tranlin(1,true);
 ren1:=fosa[455]; tranlin(1,true);
 ren1:=fosa[456]; tranlin(1,true);
 ren1:=fosa[457]; tranlin(1,true);
 ren1:=fosa[458]; tranlin(1,true);
 ren1:=fosa[459]; tranlin(1,true);
 ren1:=fosa[466]; tranlin(1,true);
 ren1:=fosa[460]; tranlin(1,true);  (*_a1:_ar1; etc;*)


 delete(archen,length(archen)-2,3); (* <nombre>.  *)
 inser(fosa[438],'*',archen+'D01',ren1,0); tranlin(6,true);
 inser(fosa[439],'/',cnf,ren1,0); inser(ren1,'%',cnr,ren1,0);
 tranlin(6,true);
 ii:=0;
 pfa:=pfaf;
 while pfa<>nil do
  begin
   ii:=ii+1; str(ii,cfi);   (*numero de orden *)
   inser(fosa[440],'/',cfi,ren1,0);   (*_a6.noft[ii]:='FAC';*)
   cfi:=pfa^.nom; for _i:=1 to 8-length(cfi) do cfi:=cfi+' ';
   inser(ren1,'*',cfi,ren1,0); tranlin(6,false);
   pfa:=pfa^.ps;
  end;
 if pref=nil then error('RESPONSES not declared');
 ii:=0;
 pre:=pref;
 while pre<>nil do
  begin
   ii:=ii+1; str(ii,cfi);   (*numero de orden *)
   inser(fosa[441],'/',cfi,ren1,0);   (*_a7.nort[ii]:='RESP';*)
   cfi:=pre^.nom; for _i:=1 to 8-length(cfi) do cfi:=cfi+' ';
   inser(ren1,'*',cfi,ren1,0); tranlin(6,false);
   pre:=pre^.ps;
  end;
 ren1:=fosa[442]; tranlin(6,true);
 ren1:=fosa[443]; tranlin(6,true);
 ren1:=fosa[468]; tranlin(6,true); (*escribe numeros aleat.*)
 ren1:=fosa[469]; tranlin(6,true);
 ren1:=fosa[444]; tranlin(6,true);
 ren1:=fosa[465]; tranlin(6,true); (*relee _a6 _a7 *)
 ren1:=fosa[445]; tranlin(6,true);
 ren1:=fosa[446]; tranlin(6,true);
 ren1:=fosa[447]; tranlin(6,true);
 ren1:=fosa[448]; tranlin(6,true);
 ren1:=fosa[449]; tranlin(6,true);
 ren1:=fosa[450]; tranlin(6,true);
 ii:=0;
 pfa:=pfaf;
 while pfa<>nil do
  begin
   ii:=ii+1; str(ii,cfi);   (*numero de orden *)
   inser(fosa[451],'/',cfi,ren1,0);   (*ii:'FAC':=_a3.cni[_i];*)
   inser(ren1,'*',pfa^.nom,ren1,0); tranlin(6,false);
   pfa:=pfa^.ps;
  end;
 ren1:=fosa[21]; tranlin(6,true);
 ren1:=fosa[467]; tranlin(6,true);
 ren1:=fosa[44]; tranlin(6,true);
end;  (*fin de procesado de FACTORS y RESPONSES en init*)


bprno:=true;
prno;
  (****procesar nodos ********************)

(*generar decl. de numeradores de mensajes VAR _NUME1,_NUME2, etc.:INTEGER*)
if (ulni>0) or (ncrea>0) then gedenume;

(*generar inic. de numeradores de mensajes _NUME1:=0;_NUME2:=0; etc.*)
for _i:=1 to n do
 if nod^[_i].tipo='I' then
 begin
  str(_i,ci);
  ren1:=' _NUME'+ci+':=0; ' ; tranlin(6,false);
 end;

for _i:=ulni+1 to ulni+ncrea  do
begin  str(_i,ci);
 ren1:=' _NUME'+ci+':=0; '; tranlin(6,false);
end;

ren1:=fosa[21]; tranlin(6,true);  (************* end del proc. INIT *)

(*PASAR MODINI1 (INIT) A MODPRO*)

limpbuf(6); closeFile(modini1); (* vaciar buffer modini1 *)
limpbuf(2); closeFile(modini);  (* vaciar buffer modini  *)
limpbuf(3); (* vaciar buffer modpro  *)
IF W THEN BEGIN WRITELN('PASAR INIT. USUARIO  A PROC. INIT');
            READln(UT) END;

binit:=false;
reset(modini1);
while not eof(modini1) do
 begin readln(modini1,ren); writeln(modpro,ren) end;
closeFile(modini1);

(* generar constante de  ec dif-> var cont. *)
(* si es fanta. poner ivcon 0 para no generar cuerpo de _fec  [269] *)
if necdif=0 then
 begin
  ved[1]:=1; necdif:=1; ivcon:=0 ; (*fanta*)
 end;
str(necdif,civcon);  (*escribir  _ore:array[1..*] of integer=(  *)
inser(fosa[272],'*',civcon,ren1,0); tranlin(1,true);
maome:=',';
(*####################tomar de lista ap.por plvc (ojo a la fanta!!)*)
if plvcf=nil  (*elemento de lista fantasma ivcon=0 evita fec:=(269)*)
 then begin new(plvcf); plvcf^.necdi:=1;plvcf^.ps:=nil;ivcon:=0 end
 else ivcon:=1;

{for ii:=1 to necdif do  (*para cada ecuacion diferencial*)
begin                   (*buscar en lista su numero de var. (deriv.)*)
 plvc:=plvcf; numde:=1; (*en numde va numero de var.continua revisado*)
 while (plvc<>nil) and (plvc^.necdi<>ii) do
  begin numde:=numde+1; plvc:=plvc^.ps;
  if plvc^.necdi=0 then
   warning('continuous variable without equation '+plvc^.nom);
  end;
 str(numde,cnumde);
 if ii=necdif then maome:=');';
  ren1:=cnumde+maome; tranlin(1,false);
end;
 }
{} (*construir el _ore :  tabla de variables de sucesivas ecuaciones*)

porel:=poref;
while porel<>nil  do  (*para cada ecuacion diferencial*)
begin
 str(porel^.nuvar,cnumde);        (*poner numero de var. en string*)
 if porel^.ps=nil then maome:=');';  (*despues de ultimo va ); *)
  ren1:=cnumde+maome; tranlin(1,false);
  porel:=porel^.ps
end;

if poref=nil then begin ren1:='1);';
tranlin(1,false) end;
{}

end;

(* ******* fin del  prinet ***************************************** *)


(********************************************************* PRLINK *)
procedure prlink; (* une modec modedi modp modpro modini modnet;
                     crea prpr *)
var copc,cuj:st10;
(*d95*) var _j, _k, _i, _nuof: integer;
begin
 limpbuf(3);
 limpbuf(4);
 limpbuf(1);

 (*poner en modec: 'implementation' _fec PROCP FUNCP *)
ren1:=fosa[333]; tranlin(1,true);  (*'implementation'*)
ren1:='uses pp;';tranlin(1,true);
 (* pasar a modec funcion _ff de ecuaciones diferenciales *)

 (* encab.de funcion _fec de las ec.diferenciales *)
IF W THEN BEGIN WRITELN('ENCAB. _FEC EC.DIFERENCIALES');READln(UT) END;

 ren1:=fosa[269]; tranlin(1,true);   (*function _fec( etc *)

 ren1:=fosa[20]; tranlin(1,true);   (*begin de la _fec*)
 limpbuf(1);
 if ivcon<>0   then  (*si hay ecuaciones diferenciales*)
 begin
  {if necudi>ivcon then error('lack of differential equations');  }
  limpbuf(8);
  closeFile(modedi);
  reset(modedi);
  (*pasar lineas de ec.diferenciales*)
  while not eof(modedi) do
   begin readln(modedi,ren); writeln(modec,ren) end;
   closeFile(modedi); ren1:=fosa[44]   (*end de case y _fec*)
 end
 else ren1:=fosa[21]; (*end de _fec vacia*)

 tranlin(1,true); ren1:=' '; tranlin(1,true);  (*end de la fec*)
 limpbuf(1);

(*si hay PROCEDURES y FUNCTIONS pascal pasarlas a modec*)
if bpropf then
begin   LIMPBUF(9);
 closeFile(modproc);
 reset(modproc);

 while not eof(modproc) do
  begin readln(modproc,ren); writeln(modec,ren) end;

 closeFile(modproc);
end;


 closeFile(modec);

 append(modec);
 (*d95 28.4.98*) writeln(modpro,' ');
 closeFile(modpro);
 reset(modpro);

 while not eof(modpro) do
  begin readln(modpro,ren);writeln(modec,ren) end;
 closeFile(modpro);

 if nexl>0 then (* funcion _cl de expr. logicas de SYNCHR y ASS *)
 begin
  ren1:=fosa[44]; tranlin(7,true);
  limpbuf(7); closeFile(modlog); reset(modlog);
  while not eof(modlog) do
   begin readln(modlog,ren); writeln(modec,ren) end;
  closeFile(modlog)
 end
 else begin ren:=fosa[223];writeln(modec,ren) end;

 reset(modini);

 while not eof(modini) do
  begin readln(modini,ren);writeln(modec,ren) end;
 closeFile(modini);

ren1:='end.' ; writeln(modec,ren1); (*fin de unidad modec PRU.PAS*)
closeFile(modec);
 (***********************************************************)

 (* crear programa principal *)
ren1:='end.'; tranlin(ptra,true); (*fin de la ultima unidad*)
limpbuf(4); closeFile(modnet);

I:=POS('.',ARCHEN);
(*d ASSIGN(MODNET,COPY(ARCHEN,1,I)+'PAS'); rewrite(modnet);*)
ASSIGN(MODNET,COPY(ARCHEN,1,I)+'DPR'); rewrite(modnet);
{delphi 13.11.2000 dirname:=copy(archen,1,ibarra);}
(*d31*)
ibarra:=i-1;
while (ibarra > 0) and (archen[ibarra] <> '\') do Dec(ibarra);
{delphi 2.10.2001} dirname:=copy(archen,1,ibarra);
{delphi 2.10.2001 writeln(dirname,'**',ibarra); readln;}
ren1:='program '+ copy(archen,ibarra+1,i-1-ibarra)+';';
tranlin(4,true);
ren1:='{$WARNINGS OFF}'; tranlin(4,true);
ren1:='{$HINTS OFF}'; tranlin(4,true);
(*d31 d95 fin*)
ren1:=
(*d31 multig 'program _xx;uses crt,dos,printer,graph,pru,pp,fung,inpout,gdinar,';*)
'uses tipos,pru,pp,fung,venmenu,ppgraph,inpout,gdinar,wdgraph,forms,';
tranlin(4,true);
{for j:=1 to numunt do
 (*agregar nombres de unidades al uses*)
begin }
 copc:=',';
 for _j:=1 to numunt do
  begin j:=_j;
   if j=numunt then copc:=' ' ;     (*2/11/1998*)
   str(j,cuj); ren1:='unid'+cuj+copc;
   tranlin(4,true)
  end;
{end;}
if hayuses then palisun(4) (*pasar lista de units del usuario*)
                                                 (*25/10/1998*)
  else begin ren1:=';'; tranlin(4,true) end;     (*25/10/1998*)
(*d ren1:='{$F+} label 1,2,3,4;'; tranlin(4,true);*)
{multig ren1:='var _jk:integer; label 1,2,3,4;'; tranlin(4,true);}
ren1:='var _jk, _kk:integer; label 1,2,3,4;'; tranlin(4,true);
(*declaracion de arreglo de procedimintos _PRNOD*)
inser(fosa[496],'*',nst,ren1,0); tranlin(4,true);
for _k:=1 to n-1 do
 begin
  ren1:=nod^[_k].nom+','; tranlin(4,false)
 end;
ren1:=nod^[n].nom+');'; tranlin(4,false);
(*d31*
ren1:='procedure CloseGraph; far; external ''DLGraph'';';
tranlin(4,true);
*d31 fin*)

(*transferir proc. _revred *)
for _i:=1 to 13 do begin i:=_i; ren1:=fosa[i+500]; tranlin(4,false) end;

ren1:=fosa[20]; tranlin(4,true); (* begin *)
{Delphi multig 16.3.2001}
    str(numGrafs,cnumGrafs);
    ren1:='_maxGraphics:='+cnumGrafs+';';  tranlin(4,true);
ren1:=fosa[133];tranlin(4,true); (* llamar proc.ver /ps /so *)
ren1:=fosa[529];tranlin(4,true); (* Delphi 9.2.2001 _nomars,
                                    assign _ars, rewrite*)
ren1:=fosa[470];tranlin(4,true); (* 2: proc _menu o _inici *)
ren1:=fosa[477];tranlin(4,true); (* _prm false, ver si 'Q', etc *)

ren3:='';
if btsim then   (* hay TSIM *)
          begin ren3:=ren3+' (time<tsim) ';
           if bes   then ren3:=ren3+  ' and not _es '   (* y ENDSIM *)
          end
         else   (* no  TSIM *)
          if bes
           then ren3:=' not _es '   (* solo ENDSIM *)
         else  error('missing terminating condition: TSIM or ENDSIMUL');

 inser(fosa[76],'*',ren3,ren1,0);tranlin(4,true); (* while time<=tsim..*)
 {d95 ren1:='if _bt then begin disfel(true); if _bftr then disfel(false) end;';}
 ren1:='if _bt then disfel;';
 tranlin(4,true);
 ren1:='_exfel;'; tranlin(4,true);
 if btsim then
  begin ren1:=fosa[77];tranlin(4,true); (*  tsim _n1:=_n; *)
   ren1:='goto 4 end;'; tranlin(4,true);
  end;
 ren1:='_ci1:=true;'; tranlin(4,true);
 ren1:=fosa[78];tranlin(4,true); (*  repeat etc. *)
 ren1:=fosa[79];tranlin(4,true); (*  repeat      *)

 ren1:=fosa[514]; tranlin(4,true); (*llamados a _REVRED*)

 ren1:=fosa[234]; tranlin(4,true); (* if _quit then goto 1 *)
 ren1:=fosa[177]; tranlin(4,true); (*if _bmen then _bmen false menu etc.*)
 inser(fosa[83],'*',cn,ren1,0);tranlin(4,true); (*_n1:=  _k:= *)
 str(n+1,cn);
 inser(fosa[84],'*',cn,ren1,0);tranlin(4,true); (* until      *)
 ren1:=fosa[85];  tranlin(4,true); (* until..end.*)
 {multig 11.12.2000
 ren1:=fosa[395]; tranlin(4,true); (* begin closegraph etc.*)}
 (*Delphi 11.6.2001
 for _nuof:=1 to nuoft do  //poner close de archivos si hay
  begin nuof:=_nuof;
   str(nuof,nuofc);
   nuofc:='_filv'+nuofc; //nombre de variable archivo _filv#
   {Delphi 30.3.2001 ren1:=' if nrep=ntrep then begin writeln(*,''# 0'');'; }
   Delphi 11.6.2001 ren1:=' if nrep=ntrep then ';
   {Delphi 30.3.2001 inser(ren1+fosa[368]+' end;','*',nuofc,ren1,0);}
   inser(ren1+fosa[368],'*',nuofc,ren1,0);
   tranlin(4,true);
  end;
 limpbuf(4);
 Delphi fin 11.6.2001 *)
 
 if bfact then (*hay factores*)
  begin
   ren1:=fosa[461]; tranlin(4,true);
   ii:=0;
   pre:=pref;
   while pre<>nil do
    begin
     ii:=ii+1; str(ii,cfi);   (*numero de orden *)
     inser(fosa[462],'/',cfi,ren1,0);   (*_a7.nort[ii]:='RESP';*)
     inser(ren1,'*',pre^.nom,ren1,0); tranlin(4,false);
     pre:=pre^.ps;
    end;
    ren1:=fosa[21]; tranlin(4,true);
    ren1:='reset(_arf);'; tranlin(4,true);
    ren1:=fosa[468]; tranlin(4,true);
    ren1:=fosa[463]; tranlin(4,true);
    ren1:='end else '; tranlin(4,true);
  end;
    ren1:=fosa[472]; tranlin(4,true);
{multig 8.2.2001 modificados 472 y 473}
    ren1:=fosa[473]; tranlin(4,true);
    ren1:=fosa[436]; tranlin(4,true);
    ren1:=fosa[162]; tranlin(4,true);
 (*d31 ren1:='1:textbackground(0);textcolor(15);clrscr;' ; tranlin(4,true);*)
{multig 8.2.2001    ren1:='1: ' ; tranlin(4,true); }
    ren1:='1: CerrarGraficos;' ; tranlin(4,true);
 ren1:='end.'; tranlin(4,true);

 limpbuf(4); closeFile(modnet);       (* vaciar!!!!!!!!*)
end;
(******************************************************************)
(*d95*) var _i: integer;
(* programa principal                                               *)
begin
 archen:=paramstr(1);

 (*delphi*) if paramcount=2 then W:=true else W:=false;

{ if paramcount=2
 then begin ARCHEN:=PARAMSTR(2); esps:=true end
 else begin archen:=paramstr(1); esps:=false end;
 }
 ASSIGN(ART,ARCHEN);
 (*delphi W:=FALSE; *)
(*27.4.98*) writeln('GLIDER Compiler. Universidad de los Andes.');
 writeln('  Windows 95/98/NT/2000/XP version March 2006');

{multig 11.12.2000} numGrafs:=0;
{delphi 2.03.2001}  UserWindowSizes[1]:=false; UserWindowSizes[2]:=false;
ModecCreado:=false; //17.07.2002
berr:=false; bbeg:=true; bmod:=false; bmod1:=false;
bdeclr:=false; ls:=1; blist:=false; pfuf:=nil; bprin:=false;
bdecl:=false; pcff:=nil; binit:=false;bexp:=false; pexf:=nil;
bexpa:=false; brecr:=false; best:=false; bestv:=false;balt:=false;
bstate:=false; bfunpg:=false; bsa:=false; bsp:=false; bpree:=false;
nnll:=0; nees:=0; nves:=0; nexl:=0;  bprins:=false; brem:=false;
brel:=false; ptrf:=nil; ptrfo:=nil; ptrof:=nil; ncia:=0; ukmax:=0;
brepar:=false; bsca:=false; plcf:=nil; pltf:=nil; pfilf:=nil;
brewr:=false; bactiv:= false; nomfunpg:=' '; prog:='MAIN';  (*1997*)
el:='&'; n:=0; pnof:=nil;
ni:=0; nuli:=1; bn:=false; br:=false; bnc:=false;ki:=1;
btsim:=false; bes:=false; nulic:='1'; itmx:=-32767; ntab:=0;
bprocp:=false; bvprocp:=false; bencpf:=false;
bprovar:=false; bprarr:=false;              (*25/10/1998*)
bprovln:=false;                      (*30/4/1997*)
binext:=false; bsel:=false;  bnpree:=true; {1998}
pusesf:=nil; (*27/10/1998*)  hayuses:=true; (* pruses 14.2.2001*)
necdif:=0; fingr:=false; bnodc:=false;
becdif:=false; bprged:=true; ivcon:=0; necudi:=0; bvcon:=false;
bhvcon:=false;  bypacon:=false; bpricon:=true;
bprno:=false; bnfree:=false;bpropf:=false;
kant:=0; lbant:=0; nnest:=0; nves:=0; nfspl:=0; bdea:=false;
pfrmf:=nil; pavef:=nil; bacti:=false; bsimpl:=false;
nnuant:=0; pdb:=nil;
bprcn:=false; btipro:=false; breport:=false; bprtyp:=false;
bpreco:=false; nuoft:=0; brelea:=false; ncrea:=0;
pfaf:=nil;pref:=nil; bfact:=false; bproced:=false; ULNI:=0; noni:=0;
{ nuvcon:=1;} (*num.de var cont.*)
bmess:=false; pmessf:=nil; bnsend:=false; bsendto:=false;
plvcf:=nil; (*ap a lista var.continuas*)
bdelay:=false; dbase:=false;  bcopy:=false; pcaref:=nil;
poref:=nil; nfspl:=0; primef:=true;
(* assign(modec,'A1.PAS'); rewrite(modec); *) (****activar esto **)
 IF W THEN BEGIN WRITELN('PROCESAR ',ARCHEN); READLN(UT) END;
 {assign(modini,'MOD.INI');rewrite(modini); im:=1;
 assign(modini1,'MODIN1'); rewrite(modini1);
 assign(modpro,'MOD.PRO'); rewrite(modpro);
 assign(modproc,'MOD.PRP'); rewrite(modproc); }
 {Delphi 11.03.2002
 assign(modini,'MODINI');rewrite(modini); im:=1;
 assign(modini1,'MODIN1'); rewrite(modini1);
 assign(modpro,'MODPRO'); rewrite(modpro);
 assign(modproc,'MODPRP'); rewrite(modproc); }

 assign(modini,dirname+'MODINI');rewrite(modini); im:=1;  //Delphi 11.03.2002
 assign(modini1,dirname+'MODIN1'); rewrite(modini1);  //Delphi 11.03.2002
 assign(modpro,dirname+'MODPRO'); rewrite(modpro);   //Delphi 11.03.2002
 assign(modproc,dirname+'MODPRP'); rewrite(modproc); //Delphi 11.03.2002

{ I:=POS('.',ARCHEN);
 ASSIGN(MODNET,COPY(ARCHEN,1,I)+'PAS');

 assign(modaux,'MOD.AUX');
 assign(modlog,'MOD.LOG');
 assign(modedi,'MOD.EDI');rewrite(modedi);   }

 assign(modaux,dirname+'MODAUX'); //Delphi 11.03.2002 d95 assign(modp,'P.PAS');
 assign(modlog,dirname+'MODLOG'); //Delphi 11.03.2002
 assign(modedi,dirname+'MODEDI');rewrite(modedi); //Delphi 11.03.2002
 for _i:=1 to 9 do linbuf[_i]:=''; btran:=false; ptra:=1; ISU:=' ';

 new(ptyp); ptyp^.nom:=tabtypp[1]; ptyp^.tipo:=tabtypp[1];
 ptypf:=ptyp; ptypa:=ptyp;
 for _i:=2 to 21 do   (*construir lista de tipos; parte predefinida*)
  begin i:=_i; new(ptyp); ptypa^.ps:=ptyp; ptyp^.nom:=tabtypp[i];
   ptyp^.tipo:=tabtypp[i]; ptypa:=ptyp; ptyp^.ps:=nil; ptypl:=ptyp
  end;

 lontypp[5]:=6; lontypp[6]:=2; lontypp[7]:=1;
 lontypp[8]:=1;lontypp[9]:=4;lontypp[10]:=1; (*pueden agre.los declarados*)
 lontypp[11]:=6; begend:=0; casend:=0; repunt:=0;
 for _i:=19 to 31 do lontypp[_i]:=1;

 (*****procesado del programa fuente ************************)

 crealin;   (* crear archivo de lineas *)
 retit;    (* recoger titulo y buscar NETWORK *)
 buside;   (* buscar nodos, INIT y DECL *)
 prodecl;   (* procesar declaraciones *)
 {bnet;}      (* organizar tabla de nodos. Lo hace prodecl*)
 prinet;    (* procesar inicializaciones y nodos *)
 prlink;    (*armar .pro y .pas*)
{$I-}
  CloseFile(modproc); CloseFile(modedi);
  erase(modini); erase(modpro);    erase(modproc); erase(modlog);
  erase(modini1); erase(modedi);   erase(modaux);
  {delphi 14.11.2000 11.03.2002} AssignFile(testigo,dirname+'Testigo.GGG');
  rewrite(Testigo); writeln(Testigo,'Fin precompilacion');CloseFile(Testigo);
{$I+}
  

end.
