unit ug2; (*RECID CLAREC RECEXPR BUSQUEDAS EN TABLAS*)
interface
uses {crt,} Dialogs, SysUtils, ug1;
procedure tranlin(ij:integer; bfl:boolean); (* ren1 a buffer y tran.*)
procedure limpbuf(n:integer); (* limpia buffer # n *)
procedure tranhas(j,h:integer); (* transmite a h, desde ki a j-1 *)
procedure inser(esq:cont;chrr:char;sust:cont;var ren2:cont;uk:integer);
procedure busidar1; (* busca var,tipo en tipo bc=false o bva=false  *)
procedure busidar; (* busca var O CAMPO,tipo en tipo bc=false o bva=false  *)
procedure butanod;  (* buscar en tabla de nodos *)
procedure butamess; (*buscar en tabla de mensajes*)
procedure errca(chc:char);   (*espera caracter chc*)
procedure error(mes:cont);
procedure warning(mes:cont);
procedure verflin; (* si es fin de linea reiniciar *)
procedure elicom; (* eliminar comentarios con  ( en k  *)
procedure reccnum; (* recoger constante numerica *)
procedure recstr; (* recoger constante tipo str *)
procedure rechar; (* recoger caracter *)
procedure recid;
procedure clarec; (* clasificar nom recogido por recid *)
procedure verspar(nusub:integer); (* ver si hay [], procesarlo *)
procedure proesva; (* gen. procesado anterior de est. de var *)
procedure proesvp; (* gen.procesado posterior de est. de var *)
procedure recexpr; (* recoge expresion o var.de comienzo instr. *)
procedure butasep; (* busca separador:END,OR,AND,THEN,ELSE,DO,TO,DOWNTO
    OF,MOD,NOT,DIV,XOR, si halla pone bc=false, y tipo en tabnoms[i] *)
procedure butainc; (* ver si es instr.comp.,if,while, etc. num.en r *)
procedure butafun; (* busca funciones valuadas las apunta por pfu *)
procedure butapro; (*busca en tabla de procedimientos G *)
procedure butaprop; (*busca en tabla de procedimientos P *)
procedure bufugli; (*busca en tabla de funciones G o P *)
procedure bulitab(tab:boolean); (* busca en lista de tab. t tab f var*)
procedure buprwr; (* busca en tabla de procedimientos W o R *)
procedure butacol; (*busca nom en tabla de colores*)
procedure bulitip; (*busca nom en lista de tipos*)
procedure agrtyp(s,tipo:st10); (*agrega tipo s de tipo tipo a lista*)
procedure resuno; (* recoger subin. de nodo con nombre en nom1 *)
procedure reno(bno:boolean); (* recoger nodo,deja nombre en nom1 *)
procedure prfunpg; (* procesar funcion P o G *)
procedure prfunp; (* procesar funcion PASCAL DEL USUARIO*)
procedure prfunv; (* procesar funcion valuada en expresion *)
procedure prfunva; (* procesar funcion valuada en INIT *)
procedure prntr;(*capacidad de nodos R individuales *)
procedure prntc;
procedure stvname(first:boolean;var nom:cont);(* gua.en arb;lis.ap.a var*)
procedure busli(var cind:cont);  (* buscar numero de IL_NXX[IND]      *)
procedure buselnl(nant,nsuc:integer;inant,insuc:st10; var cind:cont;
                  dimsuc:integer);
procedure absigu; (*absorber y verificar := *)
procedure calel(elist:integer;subno:st10;var res:cont ); (* calc.el *)
procedure bulesu(na,ns:integer);
procedure prinsim(varc:boolean); (* procesar asignativa gen.llamado estad.*)
procedure finpro(bend:boolean); (* ter.proc.G con end o end; aj. ki *)
var hayest:boolean;

implementation

procedure tranlin(ij:integer; bfl:boolean); (* ren1 a buffer y trans.
 si se llena. 1:modec 2:modini 3:modpro 4:modnet 5:modaux 6:modini1
 7:outg 8:modedi 9:modproc                        31/10/1998
 si bfl es true se vacia linbuf anterior y comienza nueva linea *)
begin
   if (length(ren1)>74-length(linbuf[ij]) ) or bfl then
    begin
     case ij of
      1:writeln(modec, linbuf[1]); 
      2:writeln(modini,linbuf[2]);
      3:writeln(modpro,linbuf[3]);
      4:writeln(modnet,linbuf[4]);
      5:writeln(modaux,linbuf[5]);
      6:writeln(modini1,linbuf[6]);
      7:writeln(modlog,linbuf[7]);
      8:writeln(modedi,linbuf[8]);
      9:writeln(modproc,linbuf[9]);
     end;
IF W THEN WRITELN('TR.LIN  ',LINBUF[IJ]);
     linbuf[ij]:=ren1;
    end
   else linbuf[ij]:=linbuf[ij]+ren1;
IF W THEN BEGIN WRITELN('A BUF ',IJ,' ',REN1); READln(UT) END
end;

(******************************************************** LIMPBUF *)
procedure limpbuf(n:integer); (* limpia buffer # n *)
begin
 case n of
   1:begin writeln(modec  ,linbuf[1]); linbuf[1]:='' end;
   2:begin writeln(modini ,linbuf[2]); linbuf[2]:='' end;
   3:begin writeln(modpro ,linbuf[3]); linbuf[3]:='' end;
   4:begin writeln(modnet ,linbuf[4]); linbuf[4]:='' end;
   5:begin writeln(modaux ,linbuf[5]); linbuf[5]:='' end;
   6:begin writeln(modini1,linbuf[6]); linbuf[6]:='' end;
   7:begin writeln(modlog, linbuf[7]); linbuf[7]:='' end;
   8:begin writeln(modedi, linbuf[8]); linbuf[8]:='' end;
   9:begin writeln(modproc, linbuf[9]); linbuf[9]:='' end;
 end
end;

(********************************************************* TRANHAS *)
procedure tranhas(j,h:integer); (* transmite a h, desde ki a j-1 *)
begin
 ren1:=copy(pl^.con,ki,j-ki); tranlin(h,false)
end;

(*P*)
(********************************************************** INSER *)
procedure inser(esq:cont;chrr:char;sust:cont;var ren2:cont;uk:integer);
(* pone el esqueleto en ren2 y el string sust donde hay chrr; si uk es
0 no lo imprime, 1 lo imprime en modec, 2 en modini, 3 en modpro   *)
var j,k:integer;
begin  ren2:=esq; j:=pos(chrr,ren2);
while j<>0 do
 begin ;
  delete(ren2,j,1); insert(sust,ren2,j); j:=pos(chrr,ren2) end;
 case uk of
  0:; 1:writeln(modec,ren2); 2,3,4:tranlin(uk,false); end;
end;

(******************************************************** BUSIDAR1 *)
procedure busidar1; (* busca var,tipo en tipo bc=false o bva=false  *)
label 1;     (* queda apuntada por pva; si halla deja bc:=false bva=true *)
var jjk,k0,m0:integer; nomx:st10;
begin
IF W THEN BEGIN WRITELN('ENTRADA A BUSIDAR1 CON ',NOM); READln(UT) END;
bva:=false; tipo:=' ';
if pvf<>nil then  (* si hay arbol ir a buscar     *)
 begin
 pva:=pvf;  (* comenzando desde el primero                    *)
 while (pva<>nil) and not bva do (* mientras no se acabe ni se halle *)
  begin
{IF W THEN WRITELN('EXAMINA EN ARBOL AL ',PVA^.NOM);  }
   if (pva^.nom=nom)
    then             (*hallado nombre igual; hallar el tipo*)
     begin

      if prog='MAIN'
       then          (*procesando MAIN*)
         begin
          if pva^.prog='MAIN'
           then begin
           tipo:=pva^.typ;  bc:=false; bva:=true end; (*se hallo*)
         end

       else          (*procesando procedimiento o NODE*)
        begin
         if pva^.prog=prog
          then
           begin
            tipo:=pva^.typ; (*la del proc es la primera de la lista*)
            bc:=false; bva:=true;    (*llaves de se hallo*)
           end
          else
           begin           (*buscar si la del proc.es algun sinonimo*)
IF W THEN WRITELN('BUSCANDO SINONIMO ',NOM);
            psi:=pva^.psi; (*apunta a primera o es nil *)
            while (psi<>nil) and (psi^.prog<>prog) do psi:=psi^.psi;
            if (psi=nil) then
                          begin
                           tipo:=pva^.typ;  (*es global*)
IF W THEN BEGIN WRITELN('VER SI ES VAR GLOBAL TIPO ',PVA^.TYP);READln(UT) END;
                           if pva^.prog='MAIN'
                            then begin bc:=false; bva:=true;  end;
                          end
                         else
                          begin tipo:=psi^.typ;
                           pva:=psi;
IF W THEN BEGIN WRITELN('VAR LOCAL ',PVA^.NOM,' TIPO ',PVA^.TYP);READln(UT) END;

                           bc:=false; bva:=true;   (*llaves de se hallo*)
                          end;(*es local*)

           end
        end;
      goto 1;   (*se da por terminado busqueda en arbol  3/11/1998*)
     end  (* del caso nombre igual*)

    else  (*no hubo nombre igual 3/11/1998*)
    begin
     jjk:=pos('.',pva^.nom);  (*busca punto;si no hay,pos da cero 3/11/1998*)
     if (ch='.') and (jjk<>0) and (nom=copy(pva^.nom,1,jjk-1))
        and pva^.dbase
       then
        begin   (*guardar m, k y nombre tabla (nomx) recoger lo que
                   sigue al . o sea nombre de campo  3/11/1998*)
              m0:=m; k0:=k; k:=k+1; nomx:=nom; recid;
              if nom=copy(pva^.nom,jjk+1,length(pva^.nom)-jjk)
               then begin bc:=false; bva:=true; nom:=pva^.nom; m:=m0;
                     goto 1
                    end
               else begin m:=m0; k:=k0; nom:=nomx; ch:='.'
                    end
        end;

     if pva^.nom>=nom then pva:=pva^.pa else pva:=pva^.ps (*an o si*)
    end  (*del if todavia no se halla*)

  end    (*del while que revisa arbol*)
 end;
1:
IF W THEN BEGIN
IF BVA THEN WRITELN('SE HALLO ',PVA^.NOM,' TIPO ',TIPO,' TYPTYP ',
     pva^.typtyp,
 ' DE PROGR. ',PVA^.PROG)
       ELSE WRITELN('NO ESTA EN ARBOL'); READln(UT) END;
end;
(********************************************************BUSIDAR*)
procedure busidar;  (*busca en arbol si es rec.campo o apu^.campo
                      busca el campo *)
label 1;
begin
 busidar1;         (*busqueda en arbol*)



 if bva and (PVA^.TYPTYP='RECORD')
  then               (**antes ver si es array!!*****++++=========*)
   begin
    nom4:=nom;
IF W THEN WRITELN('ENCONTRO TIPO RECORD ',PVA^.NOM,' BUSCA CAMPO  ',
          'NOMFUNPG ',NOMFUNPG);


    if ch='.' then
     begin
      k:=k+1;
      recid; pvf1:=pvf; pvf:=pva^.apre;
      busidar1;
      if not bva then error('invalid field name');
      pvf:=pvf1;
      nom:=nom4+'.'+nom;
IF W THEN BEGIN WRITELN('HALLADO ',NOM,' TIPO ',PVA^.TYP); READln(UT) END;
     end;

   end;  (*fin de caso record*)

 if bva and  (pva^.typtyp='POINTER') and (ch='^') and (pl^.con[k+1]<>'.')
  then begin k:=k+1; nom4:=nom;  bc:=false;
        nom:=nom4+'^';  goto 1;
       end;
                    

 if bva and  (pva^.typtyp='POINTER')
             and (ch='^') and (pl^.con[k+1]='.')
  then
   begin nom4:=nom;
IF W THEN WRITELN('ENCONTRO TIPO POINTER ',NOM,' BUSCA CAMPO');
    k:=k+2;
    recid; pvf1:=pvf; pvf:=pva^.apre;
IF W THEN WRITELN('BUSCARA EN SUBARBOL COM.CON ',NOM);
    if (nom4<>'PMESS')  then
    begin
     busidar1; if not bva then error('invalid field name');
     pvf:=pvf1;
    end;
    nom:=nom4+'^.'+nom;
   end;
(*d95 27.4.98*) if pva <> nil then pva^.typtyp:=' ';
 IF W THEN WRITELN('RECOGIDO ',NOM);

1: end;
(******************************************************** BUTANOD *)
procedure butanod; label 1,4; (* buscar en tabla de nodos lugar
                 en tabla subindice i *)
begin
 i:=1; bc:=true;
 while(i<=n) do
  if nod^[i].nom<>nom then i:=i+1 else goto 4;

 4:if i<=n then
  BEGIN bc:=false  (* para busqueda desde clarec y bunod *)
   ;IF W THEN WRITELN('HALLADO NODO ',NOD^[I].NOM,' EN TABLA')
  END
  else
  if bn then            (* para busqueda desde pronode *)
   begin berr:=true; goto 1 end
   else begin nod^[i].il:=0; nod^[i].el:=0 end;
1:end;

(*******************************************************BUTAMESS*)
procedure butamess; (*buscar y  agregar a lista de mensajes*)
 (*si no halla deja bmessfo=false y agrega al final; si halla
   deja apuntado por pmess y bmessfo=true*)
begin
 pmess:=pmessf; bmessfo:=false;
 while (pmess<>nil) and not bmessfo do (*buscar mensaje*)
 begin
  if pmess^.nom=nom
  then bmessfo:=true else begin pmessa:=pmess; pmess:=pmess^.ps end;
 end;

 if not bmessfo then                   (*si no se hallo agregarlo*)
  begin new(pmess); pmess^.nom:=nom; pmess^.ps:=nil;
   if pmessf=nil
   then pmessf:=pmess
   else pmessa^.ps:=pmess;
  end;

end;

(*P*)
(**********************************************************ERRCA***)
procedure errca(chc:char);   (*espera caracter chc*)
begin if ch<>chc then error(chc+' expected');
end;
(********************************************************** ERROR *)
procedure error(mes:cont);
begin {d95 writeln; writeln('ERROR ',mes,' lin: ',lb,' col ',k); writeln;
 writeln('(press Enter Enter to exit to Editor)'); writeln;
 write(pl^.con);
 (*d gotoxy(k,wherey);*)
 {readln(UT); readln(UT);
 readln(UT); writeln;}
 MessageDlg(pl^.con+': '+mes+' Lin: '+IntToStr(lb)+' Col: '+IntToStr(k),
            mtError,[mbOK],0);
 {delphi 14.11.2000}
 {$I-}
  CloseFile(modproc); CloseFile(modedi);  CloseFile(modini1);
  CloseFile(modini);  CloseFile(modpro);  CloseFile(modaux);  CloseFile(modlog);
  AssignFile(testigo,dirname+'Testigo.GGG'); //Delphi 11.03.2002
  rewrite(Testigo); writeln(Testigo,'Fin precompilacion');CloseFile(Testigo);
{$I+}
 {delphi 14.11.2000 fin}
 berr:=true ;

{$I-}
  erase(modini); erase(modpro);      erase(modaux);  erase(modlog);
  erase(modini1); erase(modedi);     erase(modproc);

{$I+}

halt(3)
end;

(******************************************************** WARNING *)
procedure warning(mes:cont); var j:integer;
begin {writeln; writeln('WARNING ',mes,' lin: ',lb); writeln;
 write(pl^.con);
 writeln('press Enter to continue'); writeln;
 readln(UT); writeln Delphi }
 MessageDlg(pl^.con+': '+mes+' Lin: '+IntToStr(lb)+' Col: '+IntToStr(k),
            mtWarning,[mbOK],0);
 end;

(******************************************************** VERFLIN *)
procedure verflin; (* si es fin de linea reiniciar *)
 (* transferir segun variable im *)
label 1,2; var ii:integer;
begin
if (pl^.con[k]<>el) then goto 1;
IF W THEN WRITELN('ENTRADA A VERFLIN LINEA ',LB,' ',PL^.CON);
  pl^.con[k]:=' '; k:=k+1;
 if btran and (not bprocp or bprovln)   (*28/3/1998*)
 then (*si hay que transmitir texto y no estamos
                               procesando proc. o func. PASCAL com.1998*)
  begin
   ren1:=copy(pl^.con,ki,k-ki); (*transmitir desde ki com.1998*)
   tranlin(ptra,true);limpbuf(ptra);ki:=1;
   if bn and bnue and not bprocon
    then begin tranlin(5,false);limpbuf(5) end;
   goto 2
  end;

if im=1 then  (*procesando declaraciones*)
    begin
      if bmod and (not bprocp) and (not dbase) (*transf.linea a modec*)
       then
        begin ls:=ls+1; writeln(modec,pl^.con) end;
      if bprocp  (*procesando PROC o FUNC pascal*)
       then
        begin
         ren1:=copy(pl^.con,ki,k-ki);
         tranlin(ptra,true);ki:=1; limpbuf(ptra);
IF W THEN BEGIN
 WRITELN('TRANSMITIDA LINEA DE PROCP O FUNCP');
 IF BENCPF THEN WRITELN('SI ES ENC.VA TAMBIEN A INTERFACE') END;
         if bencpf then tranlin(1,true); (*enc.PROoFUN a interface*)
        end;
      if bdeclr and bnuecam then  (*campo nuevo en declar.de reg.g*)
       begin
        ren1:=copy(pl^.con,mn,k-mn); mn:=1;
       end
    end;

2:IF W THEN WRITELN('LINEA TERM. LB ',LB,' ',PL^.CON);
  repeat  (*mientras sea vacia*)
   pl:=pl^.pls; lb:=lb+1; (* ver linea siguiente *)
   IF W THEN WRITELN('LINEA SIG . LB ',LB,' ',PL^.CON);
   if pl^.con[1]='$' then error('unexpected end of program');
   k:=0; bbeg:=true; (* comienza nueva linea *)
  until pl^.con[1]<>el;
  {Delphi 9.2.2001 Si empieza con # se pasa sin analizar}
  repeat
    if pl^.con[1]='#' then
       begin
         if (ptra<>1 {modec}) or ModecCreado then  //17.07.2002
          begin                //17.07.2002
             ren1:=copy(pl^.con,2,length(pl^.con)-1);  //17.07.2002
             tranlin(ptra,false); limpbuf(ptra);       //17.07.2002
          end;                 //17.07.2002
         pl:=pl^.pls; lb:=lb+1; (* ver linea siguiente *)
       end;
  until pl^.con[1]<>'#';
1:end;

(*P*)
(********************************************************* ELICOM *)
procedure elicom; (* eliminar comentarios con  ( en k            *)
                  (* deja k despues de delimitador derecho no el *)
                  (* si de entrada es no delim. deja bcome=false *)
begin
{Delphi 8.2.2001 Dejar pasar instrucciones sin analizar evertido 10.3.2003}
  if ((pl^.con[k]='(') and (pl^.con[k+1]='*')) or (pl^.con[k]='{')
{if ((pl^.con[k]='(') and ((pl^.con[k+1]='*') or (pl^.con[k+1]='#')))
   or (pl^.con[k]='{') }
then
begin
IF W THEN WRITELN('COMIENZA A SALTAR COMENTARIO');
case pl^.con[k] of
'(': begin
       (*case pl^.con[k+1] of
       '*': begin   *)
            k:=k+2;
            while (pl^.con[k]<>'*') or (pl^.con[k+1]<>')') do
            begin
              k:=k+1;
              verflin; if k=0 then k:=1;
            end;
            k:=k+2; (* se recomienza en posicion siguiente al comentario *)
           end;
{Delphi 8.2.2001 Se agrega tratamiento comentario especial con (# #) }
     { '#': begin   pl^.con[k]:=' '; pl^.con[k+1]:=' '; k:=k+2;
           while (pl^.con[k]<>'#') or (pl^.con[k+1]<>')') do
           begin
             k:=k+1;
             verflin; if k=0 then k:=1;
           end;
           pl^.con[k]:=' '; pl^.con[k+1]:=' ';
           k:=k+2; (* se recomienza en posicion siguiente al comentario *)
           end;
     end; (*del case ( *)
     end; (*begin ( *) }
'{': begin k:=k+1;
     while pl^.con[k]<>'}' do
      begin k:=k+1;
       verflin; if k=0 then k:=1;
      end;
     k:=k+1; (* se recomienza en posicion siguiente al comentario *)
    end;
end;  (* del case *)
verflin; if k=0 then k:=1;  (* salta linea si comentario acaba en 74 *)
end
else bcome:=false
end;

procedure eliblan; (* deja k en primero que no es blanco no el    *)
                   (* si de entrada es no blanco deja bblan=false *)
begin
 if pl^.con[k]=' '
 then
 BEGIN
 IF W THEN WRITELN('VA A ELIMINAR BLANCOS');
  while pl^.con[k]=' ' do
   begin k:=k+1; verflin; if k=0 then k:=1; end
 END
 else
  bblan:=false
end;

(******************************************************** RECCNUM *)
procedure reccnum; (* recoger constante numerica *)

procedure busdi; (* recoge cadena de digitos de pl^.con en nom *)
var kh:integer;
begin
 nom:=nom+ch; k:=k+1; ch:=pl^.con[k]; kh:=k;
 while ch in digit do begin nom:=nom+ch; k:=k+1; ch:=pl^.con[k] end;
 if kh=k then bnumer:=false
end;

procedure busexp; (* recoger exponente *)
begin
 ch1:=pl^.con[k+1]; (* ve lo que sigue a E *)
 if (ch1='+') or (ch1='-') then begin nom:=nom+ch; k:=k+1; ch:=ch1 end;
 busdi   (* recoger valor numerico del exponente; verificar!!!!!*)
end;

begin (* proc. reccnum; retroceder, el comienzo esta en m *)
 k:=m-1; nom:=''; bent:=true; bnumer:=true; busdi; delete(nom,1,1);
 case ch of
  '.': begin if pl^.con[k+1]<>'.' then
              begin bent:=false; busdi;
              if (ch='E') or (ch='e') then busexp end
       end;
  'E','e': begin bent:=false; busexp end;
 end;
IF W THEN WRITELN('RECOGIDO NUMERO ',NOM,' CH ',CH);
end;

(*P*)
(********************************************************* RECSTR *)
procedure recstr; (* recoger constante tipo str *)
var bfst:boolean;
begin
IF W THEN WRITELN('RECOGIENDO CONSTANTE DE TIPO STRING');
 k:=k+1;  (*saltar el ' inicial; puede seguir ''*)
 bfst:=false;
 (*recoge car.mientras no halle ' solo. Para si comienza linea *)
 while ((pl^.con[k]<>'''') or (pl^.con[k+1]='''')) and (k<>0) do

  if (pl^.con[k]='''') and (pl^.con[k+1]='''')
   then           (*hallo '' *)
    begin k:=k+2;
IF W THEN WRITELN('DOS APOSTR. SEGUIDOS ',PL^.CON[K],PL^.CON[K+1]);
     verflin
    end

   else
    begin
IF W THEN WRITE(PL^.CON[K]);
     k:=k+1;                   (*pasar el caracter siguiente*)
     if pl^.con[k]='''' then bfst:=true;
     verflin
    end;

   if (k=0) and not bfst then error('constant string exceeds the line');
   k:=k+1; (* queda k despues del ' final *) tipo:='STRING';b:=true;
 IF W THEN BEGIN WRITELN; READln(UT) END;
end;

(********************************************************* RECHAR *)
procedure rechar; (* recoger caracter *)
begin IF W THEN WRITELN('RECHAR K=',K,' PL^.CON[K] ',PL^.CON[K]);
 k:=k+1; ch2:=pl^.con[k]; k:=k+1; (* pensando en avk1 *)
 if pl^.con[k]<>'''' then error(''' expected');
 k:=k+1; tipo:='CHAR';
end;

(*P*)
(********************************************************** RECID *)
procedure recid;
label 1;
(* a partir del caracter k de pl^.con busca la hilera de caracteres
 (eliminando blancos y buscando en lineas que siguen)
 y la pone en nom. Si es identificador pone b=true. En m queda
 posicion de comienzo, en k la de salida. El caracter que sigue al
 identificador queda en ch (puede ser blanco) se eliminan los
  comentarios precedentes. Los simbolos no
   identificadores detectados son
 ; = : ( ) [ ] , - + * / ^ blanco & < > =                           *)
const separ:
 set of char=
 [' ',';','=',':','(',')','[',']',',','-','+','*','/', '^',
 '&','<','>','{','#','''','@','%','\'];
var sep:boolean;
begin
IF W THEN WRITELN('RECID');
bnumer:=false; bent:=false;
verflin; if k=0 then k:=1;
nom:=''; ch:=' '; sep:=false; b:=true;

(*eliminar blancos y comentarios iniciales*)
bcome:=true; bblan:=true;
while bcome or bblan do
  begin bcome:=true; bblan:=true; eliblan; elicom end;

(*recoleccion de identificador*)
m:=k; ch:=pl^.con[k];
while (ch<>el) and not sep do
 begin  (* parar si es separador o . en numerico o .. o . no de end.*)
  if (ch in separ)
   or ((ch='.') and  (nom[1] in digit))  (*digito.*)
   or ((ch='.') and (pl^.con[k+1]='.'))  (*escalar..  de array*)
   or ((ch='.') and (nom<>'END' ))
   then sep:=true     (* parar busqueda !!!! dejar solo ultima condicion *)
   else
   begin
    IF (CH>='a') AND (CH<='z') THEN CH:=UPCASE(CH);
    nom:=nom+ch; k:=k+1; ch:=pl^.con[k]
   end
 end;
if m=k then b:=false;

if bbeg then
 if (nom<>'NODE') and (nom<>'STATISTICS') and (nom<>'NODEC')
  then bbeg:=false;

if b and (nom[1] in digit) and ((pl^.con[k+1]<>'.') or (ch<>'.'))
 then (* si comienza con digito y no sigue .. *)
 begin reccnum;
  if not bnumer then begin error('error in number'); berr:=true end
 end
 else    (*ver caso n.. de subindices poner bent true (ver array)*)
 if b and (nom[1] in digit) and ((pl^.con[k+1]='.') and (ch='.'))
  then bent:=true;
 if not b and (ch='''') then recstr;
1:
IF W THEN WRITELN('FIN RECID');
IF W THEN WRITELN('IDENT ',NOM,'   CH ',CH,'  PL^.CON[K] ',PL^.CON[K]);
end; (* fin del procedure recid *)

(********************************************************** CLAREC *)
procedure clarec; (* clasificar nom recogido por recid; queda:kc=
 1:caracter;2:var.,3:separ.,4:nodo,5:func.val.,6:tabla,7:nada;
 caracter en ch; tipo de var en tipo *)
 VAR IJJ:INTEGER;
 begin bc:=true; kc:=0; tipo:='';
IF W THEN WRITELN('CLASIFICAR LA VARIABLE ',NOM,' (PROCESA ',PROG,' )');
 while bc do
  begin kc:=kc+1;
   case kc of  (* si lo hallan pone bc=false *)
    1:if not b then
    begin
     bc:=false; TIPO:='CAR.';  (*detectar ciclo de car.invalido*)
     if (k=kant) and (lb=lbant) then error('illegal character');
     lbant:=lb; kant:=k
    end;

    2:begin busidar;  (*busca en arbol; si no halla, bc=true*)
       (* ver si es var.o proc o func. PASCAL o AAA^.CCC*)
       (*si es var. de prog. principal,proced.o func solo vale en estos*)
       (*en cada proc. que variables usa para verificar esto*)

       if not bc then ret:=pva^.ret; (*si es o no de retardo*)
       (*se hallo en arbol (bc false) y es tipo FUNP y no es FUNCTION
       o no es var.izquierda, entonces es llamada a func.Pascal del usuario*)

       if not bc and (tipo='FUNP') and (not bfunp or not bprins)
        then begin prfunp;
              bc:=false       (*por si prfunp lo puso true*)
             end;

           (*ver si es campo DBASE*)
(*d95       if not bc and pva^.dbase and bva then *)
       if (pva<>nil) and (pva^.dbase) and not bc and bva then
        begin
         tranhas(m,ptra); btran:=false;
          IJJ:=POS('_',NOM);
          if ijj<>0
           then
            ren1:=copy(nom,ijj+1,length(nom)-ijj)+'.'+copy(nom,1,ijj-1)+'^'
           else
            begin
             ijj:=pos('.',nom);
             if ijj<>0 then ren1:=nom+'^'
                       else error('invalid dbase variable')
            end;
         tranlin(ptra,false); LIMPBUF(PTRA);
         btran:=true; ki:=k; bc:=false;
        end

      end;

    3:begin butasep; TIPO:='SEP' end;(* ver si es separador *)
    4:begin butanod; TIPO:='NODO' end;
    5:begin butafun; TIPO:='FUNV'; (*puede ser definicion o llamada*)
       if not bc then if (ptra=6) then kc:=28 else prfunv;
      end;(* ver si fun.val.apuntada:pfu *)

    6:begin bulitab(true); TIPO:='TABLA' end;(* ver si es tabla *)
    7:if nom='' then begin bc:=false;TIPO:=nom end; (*!!!!!!!*)
    8:if nom='TSIM' then begin bc:=false; bg:=true; dime:=0; tipo:='REAL';
                          stvname(true,nom); (* TSIM a arbol *)
                          TIPO:=nom; nom4:='TSIM'; bg:=false;
                         end;
    9:begin butainc; TIPO:='INS.ESTR.' end; (* es IF,FOR,..,DONODE,etc.*)
    10:if nom='END' then begin bc:=false; TIPO:=nom end;
    11:if bnumer then
        begin bc:=false; TIPO:='NUMERO' end;
    12:if (nom='TRUE') or (nom='FALSE')
        then begin bc:=false;TIPO:='CONST.LOG' end;
    13:if nom='UNTIL' then begin bc:=false;tipo:=nom end;
    14:if (nom='IT') or (nom='NT') then begin bc:=false; TIPO:=nom end;
    15:begin butapro; TIPO:='PROCG' end; (* queda posicion en ij *)
    16:begin
         bufugli; TIPO:='FUNPG';(* funcion G o P pos en ij *)
       if not bc then prfunpg end;
    17:begin buprwr ; TIPO:='PRWR'end; (* proc.WRITE o READ LN, FILE*)
    18:if nom='EXPER'    then begin bc:=false;TIPO:='EXP.' end;
    19:if nom='ENDEXP' then begin bc:=false;TIPO:='ENDEXP.' end;
    21:begin butaprop; TIPO:='PROPA' end;   (*proc.PASCAL*)
    23:if nom='RAND' then bc:=false; (*proc. RAND f.prob.multiple*)
    26:if nom='REPORT'    then begin bc:=false;TIPO:='REPORT' end;
    27:if nom='ENDREPORT' then begin bc:=false;TIPO:='ENDREPORT' end;
    29:begin error('unknown  identifier '+nom);
       end;

  end (* del case *)
  end; (* del while bc *)
  IF W THEN WRITELN('KC=',KC,' ',NOM,'  ES DE TIPO ',TIPO);
 end; (* de clarec *)

(********************************************************* VERSPAR *)
procedure verspar(nusub:integer); (* ver si hay parentesis [], procesarlo *)
var contsu:integer; (*ojo recursiva!!*)
begin
IF W THEN BEGIN WRITELN('ENTRA A VER PARENTESIS');READln(UT) END;
 {recid;} k:=k+1; (* absorber  el supuesto [ *)   {kc1:=kc;}
 brepar:=true;
 if b or (ch<>'[') then error('[ expected');
 contsu:=0;
 while ch<>']' do
  begin
IF W THEN BEGIN WRITELN('A RECOGER ',NUSUB,'  SUBINDICES'); READln(UT) END;
   recexpr;
   if (ch<>']') and (ch<>',') then error('] or , expected');
   contsu:=contsu+1;
  end;
  {ANULADO PARA PERMITIR SUBINDICES EN CAMPOS VER RECEXPR}
  {if contsu<>nusub then error('incorrect number of subscripts'); }

  (*ver si al ] le sigue campo de record*)
  if pl^.con[k]='.' then begin k:=k+1; recid; end;

 brepar:=false;
   { kc:=kc1; k:=k+1;}
 b:=true; (* no busq.unario *)
end;

(********************************************************* PROESVA *)
procedure proesva; (* gen. procesado anterior de est. de var *)
begin
IF W THEN BEGIN WRITELN('PROC. EST.ANTERIOR A VARIABLE');READln(UT) END;
  bestv:=true;
 tranhas(m-1,ptra); btran:=false; nome:=nom; (* guardar identific.*)
 nom4:=nom; (* por si es experimental (ver prinsim)  *)
 recid; (* ver que sigue a identificador  : o [ *)
 cindes:=''; indn:=0;
 if ch='[' then
  begin k:=k+1; recid; (* recoger subin. simple *)
   nome:=nome+'['+nom+']'; (* formar variable con indice *)
   if bnumer and bent then val(nom,indn,esnum) else cindes:=nom;
   recid; if ch<>']' then
    error('error in subscripted variable with statistics');
   k:=k+1; recid (*ver que sigue a ] , debe ser :  *)
  end;

   if pva^.ind=1
    then begin str(pva^.nvl,invae);cindes:=invae end
    else begin str(pva^.nvl-1+indn,invae);
          cindes:=cindes+'+'+invae
         end;
   ren1:=fosa[20]; tranlin(ptra,true); (* poner begin *)
   if not binit
    then
     begin
      ren1:='_prsta('+cindes+','+nome+'); ';  tranlin(ptra,true);
     end;

    ren1:=nome; tranlin(ptra,true);  (*poner miembro izq. de asignacion*)
    ki:=k; nom:=nom4; (* por si es exp *)
   btran:=true;
end;

(********************************************************* PROESVP *)
procedure proesvp; (* gen.procesado posterior de est. de var *)
begin (*k quedo despues de lo que sigue a <expresion> *)
IF W THEN BEGIN WRITELN('PROC. EST.POSTERIOR A VARIABLE');READln(UT) END;
 if (nom='ELSE') or (nom='END')
  then begin tranhas(m,ptra); ki:=m; ren1:=';'; tranlin(ptra,false) end
  else begin tranhas(k,ptra); ki:=k+1 end;

 { inser(fosa[163],'.',cindes,ren1,0); inser(ren1,'/',nome,ren1,0);
 tranlin(ptra,true);    (* if var> _hv etc. *)
 inser(fosa[164],'.',cindes,ren1,0); inser(ren1,'/',nome,ren1,0);
 tranlin(ptra,false);   (* if var< _hv etc *)
 inser(fosa[165],'.',cindes,ren1,0);tranlin(ptra,true);(*act.h.ult.camb*)
 (*actualizar _svv,_s2vv*,_sva*)
 inser(fosa[484],'.',cindes,ren1,0); inser(ren1,'%',nome,ren1,0);
 tranlin(ptra,true);
 inser(fosa[485],'.',cindes,ren1,0); inser(ren1,'%',nome,ren1,0);
 }
 ren1:='_prstp('+cindes+','+nome+');' ;
 tranlin(ptra,true);
 if (nom='ELSE') or (nom='END')  then ren1 :=fosa[30] else ren1:=fosa[21];
 tranlin(ptra,true);
 limpbuf(ptra)
end;
(***************************recexpr nuevo**********************)
(********************************************************* RECEXPR *)
procedure recexpr; (* recoge expresion o var.de comienzo instr. *)
label 1,2;
var bterm:boolean; badd,bmult:boolean;
begin
 badd:=true; (* comienza proc. recexpr   *****)
IF W THEN WRITELN('SE BUSCA EXPRESION');
if lb>=lbf
 then BEGIN WRITELN('PASADO DE LINEA****');READln(UT); goto 1;
                END;

 while badd do  (* repetir mientras haya aditivos *)
  begin
   bmult:=true;         (* recoger termino *)
   while bmult do
    begin               (*recoger factor*)

     recid; (*recoge identificador o simbolo*******************)

     if lb>=lbf then  goto 1; (***********VER****************)
(*recoge unario o variable o ( *)
IF W THEN WRITELN('FACTOR COMENZADO POR ',NOM, '     SIGUE ',CH);
     if b and (nom='NOT')  (* unario de expr.logica *)
      then begin ch:='-';
            b:=false;  (*se espera exp.booleana*)
           end; (* exp logica *)

     clarec; (* clasificar identificador recogido procesa asig a nodo
                y fun. pascal tipo queda en tivr *)
     if tipo='ARRAY'
      then
       begin
       recid;
       verspar(pva^.dim); b:=true end (*es tipo arreglo predef.*)
      else
(*d95 27.4.98      if pva^.typtyp='ARRAY' *)
(* *)  if (pva <> nil) and (pva^.typtyp='ARRAY')
       then    (*es tipo declarado tipo arreglo*)
        begin recid;  (*puede no tener [] en llamado a proc.pas*)
         if ch='[' then verspar(pva^.dim)
                   else if not bfunpg then errca('[');
         b:=true;
        end;
  {PROV. PARA PERMITIR SUBINDICES EN CAMPOS}
       IF CH='[' THEN
       BEGIN B:=FALSE; VERSPAR(PVA^.DIM) END;

     if tipo='STRING' then  (*si es STRING puede tener [] *)
       begin recid; if ch='[' then verspar(1)
                              else b:=true end;  (*restaura b*)

     if not b  (*no se recogio identificador*)
      then     (* es unario + -  o  es ( '  *)
       case ch of
       '+','-': begin k:=k+1;
                 recid; (* rec. lo que sigue a unario  ( o var *)
                 clarec;
                 if tipo='ARRAY'
                  then begin recid;verspar(pva^.dim);
                        b:=true
                       end (*es tip arr predef.*)
                  else
(*d95 27.4.98     if pva^.typtyp='ARRAY' *)
(* *)             if (pva<>nil) and (pva^.typtyp='ARRAY')
                    then    (*es tipo declarado tipo arreglo*)
                     begin recid;  (*puede no tener [] en llamado a proc.pas*)
                      if ch='[' then verspar(pva^.dim)
                                else if not bfunpg then errca('[');
                      b:=true
                     end;

                 if ch='('then   (* es unario seguido de ( *)
                  begin k:=k+1; par :=par+1; recexpr;
                   if ch<>')' then error(') expected')
                              else begin par:=par-1 end (*OJO*)
                  end (* factor parentizado  *)
                end;
          '(':  begin k:=k+1; par:=par+1; recexpr;  (*** !! repetido *)
                  if ch<>')' then error(') expected')
                             else begin par:=par-1 end
                end; (* factor parentizado  *)
         '''':  begin (* constante string *)
                 recstr (* recogerla *)
                end;
         else  error('illegal term');
       end  (* fin del case ch *)
      else
       case kc of
        2,5,7,11,12,16 :  ;
                else error('variable, function or constant expected');
       end;

IF W THEN BEGIN WRITELN('VER SIG A VAR. O FAC.PL^.CON[K] ',PL^.CON[K]);
           READln(UT) END;
       recid;  (* rec.lo sig. a variable o factor *)
       if b then
        begin (* factor seguido por nombre tal vez separador      *)
         i:=0; butasep;
         case i of (* end or and then else do to downto of mod not div xor *)
          1,4,5,6,7,8,9,11: begin ch:=';';k:=k-1 end;
          2,13,14: ch:='+'; (* OR XOR IN*)   (*el IN provisorio aqui*)
          3: ch:='*';    (* AND *)
          12:ch:='/';   (*DIV*)
          10:ch:='+';   (*MOD*)
          else error('invalid character following factor or missing separator')
         end (* del case i *)
        end;
        case ch of   (* ver si siguen factores mult. o terminan *)
         '/','*': k:=k+1;   (* buscar factor siguiente *)
         else bmult:= false;  (* fin factores, puede ser + - ; < > = *)
        end  (* del case *)
    end ; (* fin del while bmult, recogio termino y lo que sigue *)

    k:=k+1;badd:=false; (* saltar lo que sigue a separador de expr.*)
    case ch of (* ver que sigue al termino,ojo! k despues de ch *)
     '+','-': badd:=true; (* para seguir recogiendo terminos *)
     ')':; (* salida de recursion hubo (  *)
     ';': ;
     '=': recexpr;
      (* si es ) end ; = salida de la recursion.Si sigue ; saltarlo*)
     '<': begin  if pl^.con[k] in ['=','>'] then k:=k+1;recexpr end;
     '>': begin  if pl^.con[k] ='=' then k:=k+1; recexpr end;
     ']':; (* salida de identificador con [] *)

     ',':if not bfunpg and not brepar and not brewr and not bactiv (*1997*)
         (*si no esta en func.proc.o [,] o READ WRITE FILE*)
          then error('illegal  ,  after expression');
         (* , debe ser separador de argumentos *)
     ':': (* : de formato  o de var[ ]:= *)

      else  error('in expression');
    end ; IF W THEN WRITELN('SE RECOGIO TERMINO');
  end;   (* fin del while badd,recogido termino *)

IF W THEN BEGIN WRITELN('RECOGIDA EXPRESION TERMINADA CON CH ',CH,
                        '  NOM ',NOM); READln(UT) END;
GOTO 1;

2: if begend<>0 then begin writeln('VER NODO  ', nod^[jn].nom);
                       error('BEGIN END do not match')
                      end ;

1:
end;   (* de recexpr  *)

(*******************************************************  BUTASEP *)
procedure butasep; (* busca separador:END,OR,AND,THEN,ELSE,DO,TO,DOWNTO
    OF,MOD,NOT,DIV,XOR, si halla pone bc=false, y tipo en tabnoms[i] *)
begin
  i:=1; while (nom<>tabnoms[i]) and (i<15) do i:=i+1;
  if i<15 then bc:=false
end;

(******************************************************** BUTAINC *)
procedure butainc; (* ver si es instr.comp.,if,while, etc. num.en r *)
begin
 r:=1; while (r<11) and (tabin[r]<>nom) do r:=r+1;
 if r<11 then bc:=false
end;

(******************************************************** BUTAFUN *)
procedure butafun; (* busca funciones valuadas las apunta por pfu *)
begin IF W THEN WRITELN('BUSCA FUNCION VALUADA');
 pfu:=pfuf;
 while (pfu<>nil) and bc do
  begin pfuan:=pfu;
   if pfu^.nom<>nom then pfu:=pfu^.pfus else bc:=false
  end
end;      (******************************************)

(******************************************************** BUTAPRO *)
procedure butapro; (*busca en tabla de procedimientos G *)
begin                (*BINARIA !!!!!!!!!!*)
IF W THEN WRITELN('BUSCA ',NOM,' EN TABLA INST.Y PROC.GLIDER');
 ij:=1; while (ij<=59) and (stgli[ij]<>nom) do
 BEGIN IF W THEN WRITE(IJ,' ',STGLI[IJ]); ij:=ij+1;  END;
 if ij<=59 then bc:=false
end;

(******************************************************** BUTAPROP *)
procedure butaprop; (*busca en tabla de procedimientos P *)
begin                (*BINARIA !!!!!!!!!!*)
IF W THEN WRITELN('BUSCA ',NOM,' EN TABLA PROC.PASCAL');
 ij:=1; while (ij<=27) and (tapropa[ij]<>nom) do ij:=ij+1;
 if ij<=27 then bc:=false
end;

(******************************************************** BUFUGLI *)
procedure bufugli; (*busca en tabla de funciones G o P *)
begin                (*BINARIA !!!!!!!!!!*)
IF W THEN WRITELN('BUSCAR FUNCION G o P ',NOM);
 ij:=1; while (ij<=56) and (fugli[ij]<>nom) do ij:=ij+1;
 IF W THEN WRITELN(nom, 'en ',ij);
 if ij<=56 then bc:=false
end;

(******************************************************** BUTATAB *)
procedure bulitab; (* busca en lista de tablas deja apuntado por plt*)
begin;   (* si param. tab true busca por nom.tabla sino  por variable*)
plt:=pltf; bc:=true; r:=0;
while bc and (plt<>nil) do
begin
 if tab
 then if plt^.t=nom then bc:=false
                    else plt:=plt^.p
 else if plt^.v=nom then bc:=false
                    else plt:=plt^.p;
 r:=r+1;   (* numero de tabla *)
end

end;
(******************************************************** BULITIP *)
procedure bulitip; (* busca en lista de tipos deja apuntado por ptyp*)
begin;   (* si lo halla queda bc false; queda apuntado por ptyp*)
ptyp:=ptypf; bc:=true; l:=1;
while bc and (ptyp<>nil) do
 begin
  IF W THEN WRITE(' ',PTYP^.NOM);
  if ptyp^.nom=nom then bc:=false
  else begin ptyp:=ptyp^.ps; l:=l+1 end;
 end;
 IF W THEN WRITELN;
 IF W THEN IF BC THEN WRITELN('NO HALLADO')
                 ELSE WRITELN('HALLADO TIPO ',PTYP^.NOM);
                 IF W THEN READln(UT);
end;
(********************************************************AGRTYP****)
procedure agrtyp(s,tipo:st10); (*agrega a lista de tipos el s de tipo
                                tipo y lo apunta por ptyp y ptypa*)
begin
 new(ptyp); ptyp^.nom:=s; ptypa^.ps:=ptyp; (*EL ANTERIOR LO APUNTA*)
 ptypa:=ptyp; ptyp^.ps:=nil; ptypl:=ptyp; ptyp^.tipo:=tipo;
 ptyp^.apind:=apind; ptyp^.nsub:=dime;
 ptyp^.typel:=typel; (*18/10/1998*)
 IF W THEN
  WRITELN('AGREGADO A LISTA DE TIPOS EL ',PTYP^.NOM,' DE TIPO ',PTYP^.TIPO);
end;

(********************************************************* BUPRWR *)
procedure buprwr; (* busca en tabla de procedimientos W o R *)
begin                (*BINARIA !!!!!!!!!!*)
 ij:=1; while (ij<=5) and (taprwr[ij]<>nom) do ij:=ij+1;
 if ij<=5 then bc:=false
end;

(********************************************************BUTACOL*)
procedure butacol; (*busca nom en tabla de colores*)
begin
 ij:=1; while (ij<=17) and (tabcolo[ij]<>nom) do ij:=ij+1;
 if ij>17 then error('erroneous color name');
end;

(********************************************************* RESUNO *)
procedure resuno; (* recoger subin. de nodo con nombre en nom1 *)
begin (* subin en nom2,su valor en vind ,k queda despues de  ] *)
 recid; if ch<>'[' then error('[ missing in node'); k:=k+1;
 recid;
 nom2:=nom;
 val(nom2,vind,esnum); (* si es numerico queda esnum=0 *)
 if (esnum<>0) and (nom<>'MIN') and (nom<>'FREE') then
  begin busidar; if not bva then error('unknown identifier '+nom);
   if (tipo='INTEGER') or (tipo='WORD')
                     then binte:=true
                     else error('integer identifier expected');
  end;
 if esnum=0 then if vind>nod^[i].sub then error('subscript value exceeded');
 if (nom<>'MIN') and (nom<>'FREE') then nom1:=nom1+'['+nom+']';
  recid;
 if b or (ch<>']') then error('invalid subscript'); k:=k+1;
end;

(*********************************************************** RENO *)
procedure reno(bno:boolean); (* recoger nodo,deja nombre en nom1 *)
label 1; (* si bno=true y no es nodo da error; si es nodo bc=false *)
begin bc:=true; nom2:='1'; (*subin.tentativamente a 1 *)
 recid; butanod;
  if bc then
   if bno=true then error('node expected')
                else goto 1; nom1:=nom; (* si es SELECT terminar *)
 str(i,nic); tipon:=nod^[i].tipo; if nod^[i].sub<>1 then resuno;
1:end;

(******************************************************** PRFUNPG *)
procedure prfunpg; (* procesar funcion P o G *)
var ik,nump,ijr:integer; bfun:boolean; (* van aqui por llamada recursiva *)
begin
IF W THEN BEGIN WRITELN('FUNCION P O G ',NOM); READln(UT) END;
ijr:=ij; ik:=0;  nomfunpg:=nom; bfun:=bfunpg;
if nupar[ijr]>=0
  then

   begin  (* funcion con parametros expresiones *)
    nump:=nupar[ijr];
    if nump>0 then

     begin  bfunpg:=true; recid;
      if ch<>'(' then error('( missing in function');
      k:=k+1;
      while (ch<>')') and (ik<nump) do
       begin recexpr; (***)    ik:=ik+1  end;
        if ijr<=15 then (*es aleatoria *)
         if ch=','
          then

           begin (* debe seguir parametro numerico de semilla *)
            recid; if not bent then error('integer or ) expected');
            val(nom,numse,numpr);
            if (numse<1) or (numse>10)
             then error('invalid seed number');
            recid; k:=k+1
           end

          else

           begin  (* falta semilla poner ,1 *)
            tranhas(k-1,ptra); ren1:=',1)' ; tranlin(ptra,false);ki:=k
           end;

        if ch<>')' then
        error('missing ) or erroneous number of parameters');
        bfunpg:=bfun;
       end;


      if ik<>nump then error('erroneous number of parameters');
     end

  else (* funcion con parametros IL_ o EL_ *)

   begin tranhas(m,ptra); btran:=false; nom5:=nom;
    recid; if ch<>'(' then error('( missing in function');
    k:=k+1;
    busli(ren3); (* hallar numero de la lista *)
    if nom5='L' then ren1:='_l[.]'
    else if nom5='LL'     then ren1:='_l^[.]'
    else if nom5='MAXL'   then ren1:='_lm^[.]'
    else if nom5='MINL'   then ren1:='_[.]'  (****!!!!!!!!!!!!***)
    else if nom5='MEDL'   then ren1:='_lp^[.]'
    else if nom5='DMEDL'  then ren1:='_de^[.]'
    else if nom5='ENTR'   then ren1:='_en^[.]'
    else if nom5='TFREE'  then ren1:='_tl^[.]'
    else if nom5='MSTL'   then ren1:='_tpp^[.]'
    else if nom5='DMSTL'  then ren1:='_dp^[.]'
    else if nom5='PLAST'  then ren1:='_ll[.]'   (*05291996*)
    else if nom5='PFIRST' then ren1:='_fl[.]';  (*05291996*)

    inser(ren1,'.',ren3,ren1,0); tranlin(ptra,false);
    recid; (* recoger ) *)
    if ch<>')'then error(') expected in function'); k:=k+1; ki:=k
   end; (* del if de parametros nodos *)
IF W THEN BEGIN WRITELN('PROCESADA FUNCION P O G'); READln(UT) END;

 b:=true; btran:=true;
 nomfunpg:=' ';
end;

(********************************************************* PRFUNP *)
procedure prfunp; (* procesar funcion PASCAL del usuario*)
var ik,nump:integer; (* van aqui por llamada recursiva *)
begin
IF W THEN BEGIN WRITELN('FUNCION PASCAL DEL USUARIO ',NOM); READln(UT) END;
nomfunpg:=nom;  (*para distinguir que funcion se esta procesando*)
nump:=pva^.npar; 
if nump>0
 then
  begin  ik:=0;  recid; bfunpg:=true;
   if ch<>'(' then error('( missing in function');
   k:=k+1;
   while (ch<>')') and (ik<nump) do begin recexpr; ik:=ik+1  end;
   if ch<>')' then
    error(') missing or erroneous number of parameters');
   b:=true;  (*"recogido identificador" *)
IF W THEN BEGIN WRITELN('NOMFUNPG ', NOMFUNPG); READln(UT) END;
   bfunpg:=false;
  end;
  nomfunpg:=' ';
 end;

(********************************************************* PRFUNV *)
procedure prfunv; (* procesar funcion valuada en expresion *)
var clafun,nomfun,argfun,mfufun:st10; (* necesarios por butafun *)
    guarnuspl:integer;
begin  (* se esta procesando expresion gener. llamada a _f...*)
IF W THEN BEGIN WRITELN('PROCESAR FUNCION VALUADA EN EXPRESION'); READln(UT) END;
 tranhas(m,ptra); btran:=false;
 clafun:=pfu^.cla; nomfun:=pfu^.nom; argfun:=pfu^.arg; mfufun:=pfu^.mfu;
 {recid;} (* ver que sigue a nombre de gfuncion ( o ; *)
 ren3:=clafun+argfun+mfufun;  (*_fclaseargumvalor*)
 inser(fosa[109],'@',ren3,ren1,0); tranlin(ptra,false);
 if clafun<>'FREQ' then
 begin                   (*********VER SPLINE Y PONERLE NUMERO*)
  recid;
  if ch<>'(' then error('( expected'); k:=k+1;
  ki:=k; btran:=true;
  if clafun='SPLINE' then guarnuspl:=pfu^.nfspl; (*por i se pierde*)
  recexpr;  b:=true;
  tranhas(k-1,ptra); ki:=k; (* tr. argumento *)
  if ch<>')' then error(') expected');
  inser(fosa[110],'@',nomfun,ren1,0);
  if clafun='SPLINE' then
    begin
    str(guarnuspl,cnfspl);
    ren1:=ren1+','+cnfspl
   end;
   ren1:=ren1+')'; tranlin(ptra,false);
   b:=true; (*recogido identificador*)
end
else (* es FREQ *)
begin
 inser(fosa[300],'&',nomfun,ren1,0);   (*  (_xNOM,_yNOM,_nNOM,  *)
 tranlin(ptra,false); limpbuf(ptra);
 recid; (*ver que sigue ( num.corr.aleat  ) END ELSE ; etc.*)
 if ch='(' then  (*espera corriente de numeros aleatorios*)
  begin k:=k+1; recid; if bent=false then error('number expected');
     (*verificar!!!!!!!!!!!!!!<=10*)
   ren1:=nom+')';     (*poner numero de corriente y ) cierre*)
   tranlin(ptra,false);
   recid; if ch<>')' then error(') expected'); k:=k+1;
   b:=true;
  end
  else
   begin ren1:='1)';   (*corriente de defecto 1 *)
    tranlin(ptra,false); (* tran. nr o 1)  *)
    if b then k:=m-1 else b:=true;
   end;
end;
 ki:=k; btran:=true;
end;

(********************************************************PRFUNVA*)
procedure prfunva;    (*procesar funcion valuada en INIT*)
 begin (* funcion valuada apuntada por pfu *)
IF W THEN BEGIN WRITELN('PROCESAR FUNCION VALUADA EN INIT'); READln(UT) END;
    if ptra<>6 then error('illegal use of function');
   (* se esta procesando INIT generar const. y decl.array *)
      tranhas(m,6); (* transferir lo anterior  a modini1 *)
      ren1:='const '; tranlin(3,true); im:=2;
      btran:=false; recid; (* ver que sigue a nombre de funcion *)
      if b or ((ch<>':') or (pl^.con[k+1]<>'='))
      then error(':= expected'); k:=k+2; ptxf:=nil;
      while ch<>';' do                   (* buscar puntos *)
      begin
IF W THEN BEGIN WRITELN('RECOGIENDO PUNTOS'); READLN(UT) END;
       new(ptx);new(pty);
       if ptxf=nil then begin ptxf:=ptx; ptyf:=pty; npun:=0 end
                   else begin ptxa^.ps:=ptx; ptya^.ps:=pty end;
       npun:=npun+1;
              (*!!!!!!!!!! procedimiento *)
       recid; (* recoger signo o valor de x ******** verificarlo ***)
       if not b then
        if ((ch='-') or (ch='+')) then
        begin k:=k+1; ch3:=ch; recid;
         if bnumer then nom:=ch3+nom else error('number expected')
        end;

       if (pfu^.cla <>'DISC') and (pfu^.cla<>'FREQ') then
         (* verificar secuencia *)
        begin val(nom,nux,esnum);
         if esnum<>0 then error('error in number');
         if npun>1 then
          if nuxa>nux then
           error('argument values not in order');
          nuxa:=nux;
        end;
       ptx^.val:=nom; ptx^.ps:=nil;
       recid; if ch<>',' then
         error('Y value expected');
       k:=k+1;
       recid; (* recoger signo o valor de y ******** verificarlo ***)
       if not b then
        if ((ch='-') or (ch='+')) then
        begin k:=k+1; ch3:=ch; recid;
         if bnumer then nom:=ch3+nom else error('number expected')
        end;
       if pfu^.cla='FREQ' then
       (* acumular frecuencias *)
        begin val(nom,nuy,esnum);
         if esnum<>0 then error('error in value of frequency');
         if npun>1 then nuya:=nuy+nuya else nuya:=nuy;
         str(nuya,nom)
        end;
       pty^.val:=nom; pty^.ps:=nil;
       recid;
       if (ch<>'/') and (ch<>';')
        then error('/ o ; expected');
       k:=k+1; ptxa:=ptx; ptya:=pty;
IF W THEN BEGIN WRITELN('VALORES RECOGIDOS X ',PTX^.VAL,
                        '  Y ',PTY^.VAL) ; READln(UT) END;
      end; (* del while que busca puntos *)

      if pfu^.np<npun
       then error('incorrect number of values');
      pfu^.btafu:=true;  (* anotar que hay tabla de esta funcion *)
      str(npun,snpun);   (* generar constantes *)
      inser(fosa[96],'@',pfu^.nom,ren1,0); (* nombre de const *)
      inser(ren1,'*',pfu^.arg,ren1,0);
      inser(ren1,'/',snpun,ren1,0);tranlin(3,false);
      ptx:=ptxf;
      while ptx<>nil do
       begin if ptx^.ps=nil then sfc:='); ' else sfc:=',' ;
        ren1:=ptx^.val+sfc; tranlin(3,false); ptx:=ptx^.ps
       end;
      inser(fosa[97],'@',pfu^.nom,ren1,0); (* nombre de const *)
      inser(ren1,'&',pfu^.mfu,ren1,0);
      inser(ren1,'/',snpun,ren1,0);tranlin(3,false);
      pty:=ptyf;
      while pty<>nil do
       begin if pty^.ps=nil then sfc:='); ' else sfc:=',' ;
        ren1:=pty^.val+sfc; tranlin(3,false); pty:=pty^.ps
       end;
      if primef then (*la primera vez transmitir los new(_spb); etc *)
       begin primef:=false; ren1:=fosa[344]; tranlin(6,true) end;
      if pfu^.arg='REAL'
       then
        begin ren1:='new(_x'+ pfu^.nom+');'; tranlin(6,true) end
       else
        begin ren1:='new(_xa'+pfu^.nom+');'; tranlin(6,true) end;
      if pfu^.mfu='REAL' then
       begin ren1:='new(_y'+pfu^.nom+');'; tranlin(6,true); end;

      inser(fosa[98],'@',pfu^.nom,ren1,0);
      inser(ren1,'/',snpun,ren1,0); tranlin(6,true);

      if (pfu^.arg='REAL') then ren1:=fosa[99] else ren1:=fosa[341];
      inser(ren1,'@',pfu^.nom,ren1,0);
      tranlin(6,true);
      if (pfu^.mfu='REAL') then ren1:=fosa[100] else ren1:=fosa[342];
      inser(ren1,'@',pfu^.nom,ren1,0);
      tranlin(6,true);
      if pfu^.arg<>'REAL' then
       begin
        inser(fosa[106],'@',pfu^.nom,ren1,0); tranlin(6,true);
       end;
       ren1:=fosa[21]; tranlin(6,true);

       if pfu^.cla='SPLINE' then
        begin
         str(pfu^.nfspl,cnfspl);
         inser(fosa[337],'*',pfu^.nom,ren1,0);
         inser(ren1,'&',cnfspl,ren1,0);
        tranlin(6,true);
       end;

       if pfu^.arg<>'REAL' then (*generar arreglo de nombres*)
       begin
        inser(fosa[105],'@',pfu^.nom,ren1,0);
        inser(ren1,'/',snpun,ren1,0); tranlin(3,false);
         ptx:=ptxf;
         while ptx<>nil do
          begin if ptx^.ps=nil then sfc:=''');' else sfc:=''',';
          ren1:=''''+ptx^.val+sfc;
          tranlin(3,true);
          ptx:=ptx^.ps
         end;
       end;

      IF W THEN BEGIN WRITELN('FIN TABLA CONST K= ',K,' ',PL^.CON);
                      READln(UT) END;
      btran:=true; k:=k+1; ki:=k;

      if bexp then  (* funcion en EXPER.*)
       begin (* guard.nombre y tipo:'F' *)
        nexp:=nexp+1;
        new(pex); pex^.nom:=pfu^.nom; pex^.tipo:='F'; pex^.ps:=nil;
        if pexf=nil then  pexf:=pex
        else pexl^.ps:=pex; pexl:=pex
       end
   end;

(***********************************************************PRNTR *)
  procedure prntr;(*capacidad de nodos R individuales *)
    begin
     nod^[i].tamr:=2;(* se supone<>1 !!!!!!!!no necesario!!!!!!!*)
     nom1:=nod^[i].nom; (* guardar nombre de nodo.Tran lo anterior: *)
     tranhas(m,ptra); btran:=false;
     binte:=false;(*no subin.va*)
     if nod^[i].sub<>1 then
      begin btran:=false; (*no tran por verflin*)
       resuno; (*recoger subindice *)
      { if binte then begin ren1:='begin ';tranlin(ptra,false) end }
      end
      ELSE K:=K+1;
     ren1:=fosa[20]; tranlin(ptra,true);  (*begin*)
     ren1:='m_'+nom1 ;
     tranlin(ptra,false); (*!!!!VER!!!!*)
     btran:=true; ki:=k;
     absigu;
     bprcn:=true;
     prinsim(false); (*capacidad de nodo es expresion simple*)
     bprcn:=false;
     tranhas( m ,ptra); k:=m;  btran:=false;
     ren1:='; '; tranlin(ptra,false);
     if binit  (*en INIT inic u_ a 0 si no actualizar f_=m_-u_*)
      then inser(fosa[11],'*',nom1,ren1,0)
      else inser(fosa[520],'*',nom1,ren1,0); tranlin(ptra,false);
     finpro(true); btran:=true;
     if bexp then
      begin
IF W THEN BEGIN WRITELN('!!!!!!!PROCESANDO NOD.EXP[] ',NOM1);READln(UT) END;
       nexp:=nexp+1;(* guard.nombre y tipo: 'N' *)
       new(pex); pex^.nom:=nom1; pex^.tipo:='N'; pex^.ps:=nil;
       if pexf=nil then pexf:=pex
       else pexl^.ps:=pex; pexl:=pex
      end;
   end;

 (****************************************** agregar a arbol *)
(***********************************************************PRNTC *)
procedure prntc;  var lln:string[75]; cni:st10;
 begin (* procesar llamado a nodo tipo C o G L I D E (k esta antes de ( ) *)
  tranhas(m,ptra); btran:=false;
  k:=k+2;
  lln:=nom1+'(';  (*saltar (   formar llamada en cn *)
  recid;  lln:=lln+nom; nom1:=nom; (*guardar subindice en nom1*)
 (*!!!!! ver si es entero o excede!!!!!!!!!!!*)
  lln:=lln+');';  (*completar llamada*)
  recid; errca(')'); k :=k+1;
  str(i,cni);
  ren1:=' begin _pxx:=_px; _nn:=_n; _n:='+cni+';'+'_ievv:=iev; iev:='+nom1+';';
  tranlin(ptra,true);limpbuf(ptra);
  ren1:=lln; tranlin(ptra,true);
  ren1:='; _px:=_pxx; _n:=_nn; iev:=_ievv end;'; tranlin(ptra,false);
  limpbuf(ptra); ki:=k; btran:=true;
  recid; (* ver que sigue debe ser ; END ELSE   *)
  if not b then if ch=';' then k:=k+1
                          else errca(';')
           else if (nom<>'END') and (nom<>'ELSE')
                  then error('END o ELSE expected');
 end;

(*******************************************************PONDBASE***)
procedure pondbase; (*poner datos a tipo DBASE*)
var i:integer;
begin
 pv^.typ:='ARRAY'; pv^.typel:=tipo; pv^.typtyp:='ARRAY';
 pv^.apind:=pnxf;
end;

(******************************************************** STVNAME *)
procedure stvname(first:boolean;var nom:cont);
(* guarda en arbol y hace lista apuntadores a var.de arbol.
 Si es primero en lista de variables entrar com first=true
 Si es variable GLIDER poner antes bg:=true *)
label 1,2; VAR PVPR:PTAV;
begin      
IF W THEN BEGIN PVPR:=NIL;WRITELN('NOMBRE A AGREGAR A ARBOL ', NOM );
 IF FIRST THEN  WRITELN('ES PRIMERO') ELSE WRITELN('NO PRIMERO');
 READln(UT) END;
  nomnue:=true; (* se prepara nuevo si no dispose!!!! *)
  new(pv); pv^.pa:=nil; pv^.ps:=nil; pv^.nom:=nom; pv^.est:=false;
  pv^.psi:=nil; PSI:=NIL; (*el nuevo no tiene sinonimos que le sigan*)
  pv^.dim:=dime;
  pv^.typel:=typel;       (*17/10/1998*)
  pv^.dbase:=dbase;       (*anotar si es o no var. DBASE*)
  pv^.tipfun:='';
  pv^.ret:=0;
  pv^.tipof:=false; (* por ahora no es FORWARD *)
  pv^.tipop:=false; (*           ni PROCEDURE  *)
  (*indicar si es MAIN procedimiento o funcion *)
  pv^.prog:=prog;  (*va a elem. de arbol nomb.de proc. o nodo en proceso*)
  if bn then pv^.vame:=true else pv^.vame:=false; (*si es mensaje, true*)
  pv^.nvcon:=0;

  if dbase then pondbase; (*poner datos a tipo dbase*)

  if pvf=nil then  pvf:=pv (* no habia nada en el arbol,anot. comie.*)
   else (* ya hay algo en el arbol *)
    begin pva:=pvf; pvx:=pva; (* comienza revision de arbol *)
     while pva<>nil do
      begin
IF W THEN WRITELN('EXPLORANDO ELEMENTO ',PVA^.NOM,' DEL ARBOL');
       if (pva^.nom=nom) {AND (PVA^.PROG=PROG)}   (*se hallo nombre igual*)
        then
         begin
IF W THEN BEGIN WRITELN('HALLADO SINONIMO DE PROC. O MENSAJE'); READln(UT) END;
           if bprocp
               then      (*es procedimiento o VAR DE NODO*)
                begin (*poner en lista de sinonimos de pva*)
IF W THEN WRITELN('PONER EN LISTA DE SINONIMOS');
                 psi:=pva^.psi; (*apunta a nil o primer sinonimo*)
                 if psi=nil
                  then (*es primer sinonimo*)
                   begin  pva^.psi:=pv; (*apunta a primer sinonimo*)
IF W THEN WRITELN('ES PRIMER SINONIMO ',PV^.NOM); PSI:=PV; (*PARA ESCRIBIRLO*)
                   end
                  else  (*ya hay un sinonimo*)
                   begin psia:=pva^.psia; (*apunta al ultimo*)
                    psia^.psi:=pv;  (*poner sinonimo en la lista*)
                   end;
                 pva^.psia:=pv; (*guadar apuntador al ultimo*)
                 goto 2;        (*terminada exploracion arbol*)
                end  (*si es parametro formal*)

               else
               if bn and pva^.vame
                      then    (*es mensaje*)
                       begin
IF W THEN BEGIN WRITELN('VARIABLE DE MENSAJE REPETIDA ',NOM); READln(UT) END;
                        nomnue:=false; goto 2
                       end
                      else error('duplicated name '+nom)

         end;
       (*proseguir exploracion de arbol*)
       if pva^.nom>nom then begin pvx:=pva; pva:=pva^.pa end
                       else begin pvx:=pva; pva:=pva^.ps end

      end;  (*hallo apunt. a rama vacia; termina expl.arbol*)

     (*poner elemento nuevo en arbol*)
     if pvx^.nom>nom then pvx^.pa:=pv else pvx^.ps:=pv;
     PV^.PSI:=NIL; (*elemento nuevo; no hay sinonimos (por ahora)*)
     PV^.PSIA:=NIL;
    end; (*fin del caso con arbol no vacio*)

    (* si es de los G poner largo y tipo y terminar. Si no    *)
    (* poner el elemento (nuevo o no) en lista de apuntadores *)

  2:if bg then
     begin
IF W THEN WRITELN('AGREGAR VARIABLE TIPO GLIDER DBASE O PROCED.');
      pv^.long:=lc; pv^.typ:=tipo; pv^.psi:=nil; pvafunc:=pv; goto 1;
{}    if pv^.nom='NUMBER' then
        begin
        end
     end;

IF W THEN
 BEGIN
 IF PSI=NIL
 THEN WRITELN('NO HAY SINONIMOS')
 ELSE
 BEGIN WRITELN('HAY SINONIMOS'); PVPR:=PVA^.PSIA;
  WRITELN('SE AGREGO SINONIMO ',PV^.NOM,'  ',PVPR^.NOM, ' DE PROG ',PROG);
 END;
 END;
  new(plv); plv^.ps:=nil; (*para lista de apunt. a variables agr.a arbol*)
  if nomnue
   then begin plv^.pv:=pv; pv^.typ:='' end (* si nuevo apunta y borra tipo *)
   else plv^.pv:=pva; (* si es repetido apuntar al original *)
                      (*ELSE!!!!!!!!!!no debe ocurrir!!!!!!!!!!!!*)
  if first
   then begin plvf:=plv; plva:=plv end
   else  (* ya hay algo en la lista de apuntadores; agregar *)
    begin plva^.ps:=plv; plva:=plv end;

1:  IF W THEN BEGIN WRITELN('SALE DE STVNAME'); {SEARCH(pvf);} READLN(UT) END;
 end;  (* fin procedimiento stvname poner var. en arbol *)

(***********************************************************BUSLI***)
procedure busli(var cind:cont);  (* buscar numero de IL_NXX[IND]      *)
var tl:string[3];                (* EL_NXX[IND]  EL_NXX[IND](NYY[IND]) *)
begin
recid; tl:=copy(nom,1,3);
if (tl<>'EL_') and (tl<>'IL_') then error('EL_ or IL_ expected');
k:=m+3; (*  saltar IL_ o EL_ en la linea *)
reno(true); (* recoge nodo actual y subindice *) ; i2:=i;
if tl='IL_'
 then
  if nod^[i].sub=1
   then str(nod^[i].il,cind)   (* no subindice *)
   else begin str(nod^[i].il-1,cind); cind:=cind+'+'+nom2 end

 else  (* es EL_           puede haber antecesor *)
  begin i2:=i; nom3:=nom1; nom4:=nom2; (* guardar datos nodo actual *)
IF W THEN BEGIN WRITELN('EL DE NODO ',I,' ',NOM1,' IND ',NOM2);
               {UT:=READKEY;} readln(UT); END;
   recid; (* recoge lo que sigue a ] *)
   if ch <>'('
    then   (* no hay antecesor indicado *)
     if nod^[i].sub=1
      then str(nod^[i].el,cind)  (* no subindice *)
      else begin str(nod^[i].el-1,cind); cind:=cind+'+'+nom2 end
    else   (* si hay antecesor  es ch=(    *)
     begin
       k:=k+1;
       reno(true); (* recoger antec.numero i;nom. en nom1 con sub. nom2 *)
       buselnl(i,i2,nom2,nom4,cind,nod^[i2].sub);
       recid; if ch<>')' then error(') expected'); k:=k+1;
IF W THEN BEGIN
 WRITELN('ANTECESOR (DESP.BUSELN)',I,' ',NOM1,' ',' SUB. ',NOM2,'  CIND ',CIND);
 READln(UT) END;
     end;           (*** ver si esta caso ant. L con subindice **)
  end;
end;

(**********************************************************BUSELN**)
procedure buselnl(nant,nsuc:integer;inant,insuc:st10; var cind:cont;
                  dimsuc:integer);
(* pone en cind lista de entrada EL_NSUC[INSUC](NANT[INANT]) que es
si suc. no es tipo D : el-1+insuc;
si suc es tipo     D con antec.<>L  el-1+insuc+(inant-1)*dimsuc;
si suc es tipo     D con antec. =L  el-1+inant;                    *)
var ind:integer;
begin
bulesu(nant,nsuc); (* ver relac. antecesor sucesor; el a nbel  *)
if nod^[nsuc].tipo<>'D'
 then calel(nbel,insuc,cind)
 else (* es sucesor tipo D *)

  if nod^[nant].tipo<>'L' then
   begin
    calel(nbel,insuc,cind); (*calc. el del sucesor+ind.suc.-1, pone en cind*)
    if inant<>'1' then
     begin          (* hay subid. en antecesor *)
      val(inant,vind,esnum) ;
      if esnum=0 then
                  begin vind:=vind-1; str(vind,inant)

                  end
               else inant:='('+inant+'-1)' ;
      if dimsuc>1 then begin str(dimsuc,insuc); inant:=inant+'*'+insuc end;
      if esnum<>0
       then cind:=cind+'+'+inant
       else begin val(cind,ind,esnum); ind:=ind+vind;
             str(ind,cind);
            end;
     end;
   end
   else calel(nbel,inant,cind);
end;

(**********************************************************ABSIGU   *)
procedure absigu; (*absorber y verificar := *)
begin
 recid;
 if (ch<>':') and (pl^.con[k+1]<>'=') then error(':= expected');
 k:=k+2;
end;

(********************************************************** CALEL *)
procedure calel(elist:integer;subno:st10;var res:cont ); (* calc.el *)
begin  str(elist,res);
IF W THEN WRITELN('LA EL DEL SUCESOR ES ',RES,'  SU SUBIN. ES ',SUBNO);
 if subno<>'1' then  (* si hay sub. restar 1 y sumar indice *)
  begin
   val(subno,vind,esnum);  elist:=elist-1; (* si es numerico esnum=0 *)

    if esnum=0 then elist:=elist+vind ; str(elist,res);
    if esnum<>0 then res:=res+'+'+subno

  end;
end;
(*********************************************************BULESU **)
procedure bulesu(na,ns:integer);
(*busca el de antec. na sucesor ns, pone en nbel*)
var b:boolean;
begin
if bproced    (*si estamos en procedimiento, no hay antecesor*)
then
begin
 nbel:=nod^[ns].el;
end
else
begin
 pna:=nod^[na].apns; b:=true;
 while (pna<>nil) and b do (* buscar en lista de sucesores del na *)
  begin                    (* hasta hallar el ns                   *)
   if pna^.num=ns then begin b:=false; nbel:=pna^.nueli end;
   pna:=pna^.pns
  end;
IF W THEN WRITELN('BULESU HALLO EL CORRESP. A ANTEC.SU EL ES ',NBEL);
 if b
  then error('predecessor or succesor node not defined');
end;

end;

(********************************************************** PRINSIM *)
procedure prinsim(varc:boolean) ;  (* procesar asignativa;
   guard.experimentales no nodo ; si es de ret. ret debe indicar
   orden; gener.estadist.ant.y post. *)
 var nomr,cret:st10;
 begin IF W THEN BEGIN WRITELN('PRINSIM ');READln(UT) END;
  bsimpl:=true;  (*se procesa asignativa*)
  nomr:=nom4;
  if not bexp
   then
     begin {Delphi 2.03.2001}
      recexpr; (*recoger la <expresion> ************)
{Delphi 2.03.2001} if nomr='WINDOWWIDTH' then
                      UserWindowSizes[1]:=true;
                   if nomr='WINDOWHEIGHT' then
                      UserWindowSizes[2]:=true;
     end {Delphi 2.03.2001}
   else  (* variable simple o nodo !!!!!!!!!! en EXPER.*)
    begin
     recid; if not bnumer then error('number expected');
IF W THEN BEGIN WRITELN('!!!!!!!PROCESANDO VAR.EXP ',NOM4);
     WRITELN('ANTES DE ESTA HAY ',NEXP);READln(UT);
     PEX:=PEXF; WHILE PEX<>NIL DO
     BEGIN WRITELN(PEX^.NOM); PEX:=PEX^.PS END;
END;
     recid; if ch<>';' then error('; expected');k:=k+1;
     if not bprcn then
      begin
        nexp:=nexp+1; (* guard.nombre y tipo:'V' *)
        new(pex); pex^.nom:=nom4; pex^.tipo:='V'; pex^.ps:=nil;
        if pexf=nil then pexf:=pex
                    else pexl^.ps:=pex; pexl:=pex
      end
    end;
   (*estadisticas posteriores en NETWORK e INIT *)
   if bestv then begin proesvp;  bestv:=false; end;

   if (ret>0) and varc then
    begin tranhas(k,ptra); ki:=k; btran:=false; str(ret-1,cret);
     ren1:='for _i:=1 to '+cret+' do _'+nomr+'_DEL[_i]:='+nomr+';';
          tranlin(ptra,true); limpbuf(ptra); btran:=true;
    end;
   bsimpl:=false;
 end;

(********************************************************* FINPRO *)
procedure finpro(bend:boolean); (* ter.proc.G con end o end; aj. ki *)
 begin
  recid; (* recoge lo que sigue al ) o nombre del proc.*)
  if bend then ren1:=fosa[30] else ren1:=''; (* poner end o vacio *)
  if not b and (ch=';') then
   begin k:=k+1;ki:=k; (*recogido ;  *)
    ren1:=ren1+';'
   end
   else if (nom<>'END') and (nom<>'ELSE')
    then error('; or END or ELSE expected')
    else begin ki:=m-1;{k:=k+1} end; (*recogido END o ELSE*)

  tranlin(ptra,false)
end;


end.