unit ug4; (* BUSQUEDAS EN TABLAS ORGANIZAR RED *)
interface
uses ug1, {crt,} ug2,ug3;
procedure pracc; (* procesar activate de nodo tipo C *)
procedure listecva; (*formar lista de veriables de cada ecuacion sucesiva*)
procedure prcont; (* procesar ecuacion diferencial de nodo C; formas:*)
procedure relvarcon(nomcon:st10); (*revisar var.cont.buscar nomcon*)
procedure encfec; (*pone case _m of de ec.difer*)
procedure bnet;
procedure gelvex; (*generar proc.escr.y lectura var.experimentales *)
procedure prfunpg; (* procesar funcion P o G *)
procedure proprop; (* procesar llamada a procedimiento PASCAL *)
procedure geans(bac:boolean); (* gen.envio aut.a nodos su.y act.reg.*)
procedure reccomi; (* recoger comienzo de instruccion en prins *)
procedure grkf; (* generar _rkf(m,n)  ;          *)
procedure prpoca; (*procesar apuntador a campo*)
procedure recr(k:integer); (* declarar recursos de nodos R e inic. a 1 *)

implementation
(*****************************************************GECOCANO***)
procedure gecocano; (*generar constantes de caracteristicas de nodos*)
(* generar constante de tabla de nombre de nodos, numeros de listas,
tipos, multiplicidades( si es D orden) y matriz de EL de antecesores*)

var maxant,numnd,column,nfil:integer; nlen:st10; coma,coma1:string[3];
(*d95*) var _k, _j: integer;
begin
 (*genera lista de nombres*)
str(n,nst);
inser(fosa[314],'*',nst,ren1,0); tranlin(1,true);
for _k:=1 to n-1 do
 begin
  ren1:=''''+nod^[_k].nom+''','; tranlin(1,false)
 end;
ren1:=''''+nod^[n].nom+''');'; tranlin(1,false);

 (*genera lista de tipos*)
inser(fosa[497],'*',nst,ren1,0); tranlin(1,true);
coma:='(';
for _k:=1 to n do
 begin
  ren1:=coma+''''+nod^[_k].tipo+''''; coma:=',' ; tranlin(1,false);
 end;   ren1:=');' ; tranlin(1,false);

 (*genera lista de numeros de lista de entrada. Si es D da su orden*)
inser(fosa[498],'*',nst,ren1,0); tranlin(1,true);
coma:='(';
maxant:=0;
numnd:=0;
for _k:=1 to n do
 begin
  if (nod^[_k].tipo='D')
   then
    begin  numnd:=numnd+1; str(numnd,nlen);
     if (nod^[_k].nant>maxant) then maxant:=nod^[_k].nant;
    end
   else str(nod^[_k].el,nlen);
  ren1:=coma+nlen ; coma:=',' ; tranlin(1,false);
 end;   ren1:=');' ; tranlin(1,false);

 (*genera lista de multiplicidades (si es D pone el orden)
  halla maximo antec. de nodos D y num. de nodos D *)
inser(fosa[499],'*',nst,ren1,0); tranlin(1,true);
coma:='(';
for _k:=1 to n do
 begin
  str(nod^[_k].sub,nlen);
  ren1:=coma + nlen; tranlin(1,false); coma:=',' ;
 end;

 ren1:=');' ; tranlin(1,false);

if numnd=0
 then
  begin  inser(fosa[500],'*','1',ren1,0);
   inser(ren1     ,'&','1',ren1,0); ren1:=ren1+'((0));';
   tranlin(1,true);
  end
 else
  begin  nfil:=0;
   (*matriz de numeros de EL de los nodos D *)
   str(numnd,nlen);    inser(fosa[500],'*',nlen,ren1,0);
   str(maxant+1,nlen); inser(ren1     ,'&',nlen,ren1,0); tranlin(1,true);
   ren1:='( '; tranlin(1,true);
   for _k:=1 to n do
   if nod^[_k].tipo='D'
    then
     begin k:=_k;
      str(nod^[k].nant,nlen);   (*poner   (num.de ant   *)
      ren1:='('+nlen+', '; tranlin(1,false);
      column:=0; nfil:=nfil+1;
      pna:=nod^[k].apna; coma:=',' ; coma1:=' ';
      while pna<>nil do         (*para todo antecesor*)
       begin
        column:=column+1;       (*contar cuantas EL se pusieron*)
        if column=maxant then   (*si se acabo fila va ), o ); *)
         begin coma:=' ';
          if nfil=numnd then coma1:='));' else coma1:='),' ;
                                (*pone num. de la EL seguido de , o ), o ); *)
         end;
        str(pna^.nueli,ci); ren1:=ci+coma+coma1; tranlin(1,false);
        pna:=pna^.pns;
       end;

      for _j:=column to maxant-1 do  (*completar fila con ceros*)
       begin
        column:=column+1;       (*contar cuantos ceros se pusieron*)
        if column=maxant then   (*si se acabo fila va ), o ); *)
         begin coma:=' ';
          if nfil=numnd then coma1:='));' else coma1:='),' ;
                                (*pone cero seguido de , o ), o ); *)
         end;
        ren1:='0'+coma+coma1; tranlin(1,false);
       end
     end   (*del if nod D *)
   end; (*del else de hay nodos D *)


end;
(*********************************************************** RECR *)
procedure recr(k:integer); (* declarar recursos de nodos R e inic. a 1 *)
var k1:integer;
begin
nom3:=nod^[k].nom;
if nod^[k].sub=1 then inser(fosa[12],'*',nom3,ren1,0)
else begin inser(fosa[13],'*',nom3,ren1,0); str(nod^[k].sub,nom1);
           inser(ren1,'/',nom1,ren1,0)     end;
tranlin(1,true); (* declaracion de cap. recursos *)
        (* inic. cap  a 1; nom3=nombre; nom1=subin.max *)
if nod^[k].sub<>1 then
 begin inser(fosa[23],'*',nom1,ren1,0); tranlin(3,false);
   nom1:='[ino]' end
  else nom1:=''; nom3:=nom3+nom1; (* agreg.subin ino si tiene sub. *)
 inser(fosa[11],'*',nom3,ren1,0); ren1:='m_'+nom3+':=1;'+ren1;
 tranlin(3,true); (* inicializar las capacidades a 1 *)
if nod^[k].sub<>1 then begin ren1:='end;'; tranlin(3,false) end;

(* agregar F_NOM3 U_NOM3 M_NOM3 a arbol *)
dime:=0;
if nod^[k].sub=1 then tipo:='REAL'
 else begin tipo:='ARRAY'; dime:=1 end; bg:=true;
 (*en dime va numero de subindices *)
k1:=nod^[k].sub; (*dimension var.cap.nodo 0,1,2..*)
nom3:='F_'+nod^[k].nom; stvname(true,nom3); pv^.ind:=k1; pv^.dim:=dime;
PV^.EST:=FALSE; pv^.typel:='REAL';
nom3:='U_'+nod^[k].nom; stvname(true,nom3); pv^.ind:=k1; pv^.dim:=dime;
pv^.typel:='REAL';
nves:=nves+1;best:=true;  pv^.est:=TRUE; pv^.ind:=nod^[k].sub;
IF W THEN BEGIN WRITELN('SE AGREGO A ARBOL ',PV^.NOM);READln(UT) END;
nvest:=nvest+pv^.ind;
nom3:='M_'+nod^[k].nom; stvname(true,nom3); pv^.ind:=k1; pv^.dim:=dime;
PV^.EST:=FALSE; pv^.typel:='REAL';bg:=false;
end;


(***********************************************************PRACC *)
procedure pracc; (* procesar activate de nodo tipo C *)
var ig:integer;
begin  (* genera _ac_CXX:=true;_tc_CXX:=<expr>; *)
 ren1:=fosa[20]; tranlin(ptra,true);   (* begin _ac_ _tc_ *)
 inser(fosa[267],'*',nod^[i].nom,ren1,0); tranlin(ptra,true);
 btran:=true; ki:=k; ig:=i;
 recexpr; if ch<>')' then error(') expected');
 tranhas(k-1,ptra); ki:=k;
 ren1:=';' ; tranlin(ptra,false);
 (* genera _afel(#CXX,-1,_tc_CXX); _bi_CXX:=false; *)
 str(ig,cnea);
 inser(fosa[273],'/',cnea,ren1,0); inser(ren1,'*',nod^[ig].nom,ren1,0);
 tranlin(ptra,false);
 ren1:=fosa[30]; tranlin(ptra,false);
end;
(*******************************************************ENCFEC***)
procedure encfec; (*pone case _m of de ec.difer*)
begin
IF W THEN BEGIN WRITELN('PRIMERA VEZ'); READln(UT) END;
 becdif:=true; nedgr:=1; append(modedi);
 if bprged then (*es primer grupo*)
  begin
   bprged:=false;
   ren1:=fosa[324]; tranlin(8,true); (* case _m of  *)
  end;
end;

(******************************************************RELVARCON**)
procedure relvarcon(nomcon:st10); (*revisar var.cont.buscar nomcon*)
var nomder:st10; b1:boolean; necdi,reta:integer;
(*d95*) var _j: integer;
begin
plvc:=plvcf; b1:=true;
nuvaco:=0; (*contador de la variable*)
while (plvc<>nil) and b1 do
 begin nomder:=plvc^.nom;
  if plvc^.subn<>0 then nomder:=nomder+'['+plvc^.subs+']';
  nuvaco:=nuvaco+1;
{  WRITELN;
  WRITELN('NUVACO ',NUVACO,'  ',NOMDER,'  ',NOMCON,'  PLVC^.RET ',PLVC^.RET);
   UT:=READKEY;  }
  if nomder=nomcon then b1:=false else plvc:=plvc^.ps;
 end;
 if plvc=nil then error('continuous variable not declared');
necdif:=necdif+1;    (* numero absoluto de la ecuacion diferencial *)
if plvc^.ret=0 then necdi:=necdif else necdi:=necdif+plvc^.ret-1;
plvc^.necdi:=necdi;  (*la de salida corresponde a la ultima ec.dif*)
necdi:=necdif-1;
reta:=plvc^.ret;     (*guardar retardo anotado en la variable*)
 for _j:=1 to plvc^.ret-1 do (*poner num.ec.dif. en var.intermedias*)
  begin
   plvc:=plvc^.ps; necdi:=necdi+1; plvc^.necdi:=necdi; plvc^.ret:=0;
  end;
{WRITELN('NORETA ',NORETA,'  PLVC^.RET ',PLVC^.RET,'  NINT ',NINT);
UT:=READKEY;  }
if bdelay
 then
 begin
  if reta=0 then begin listecva; nint:=nint+1 end
            else nint:=0;
  if nint=noreta-1 then
   begin nuvaco:=nuvaco-noreta+1; listecva end;

 end
end;
(********************************************************LISTECVA*)
procedure listecva; (*formar lista de variables de cada ecuacion sucesiva*)
{VAR POREA:PTORE;}
begin
new(pore);
pore^.nuvar:=nuvaco; (*nuvaco se calcula en relvarcon *)
pore^.ps:=nil;
if poref=nil         (*si estaba vacia*)
 then poref:=pore    (*esta es la primera*)
 else porel^.ps:=pore; (*si no la ultima apunta a esta*)
 porel:=pore;          (*la actual queda de ultima*)
{POREA:=POREF;  WRITELN;
WHILE POREA<>NIL DO BEGIN WRITE(POREA^.NUVAR:3); POREA:=POREA^.PS END;
UT:=READKEY;  WRITELN;  }
end;
(**********************************************************PRCONT*)
procedure prcont; (* procesar ecuacion diferencial de nodo C; formas:
var':=<expr>    var'[num]:=<expr.>;  futuro: var'[j:=2..5]:=<expr>
                                    (esta debiera generar varias)*)
var nomcon:st10; mm:integer; b1:boolean;
begin
IF W THEN WRITELN('PROCESAR ECUACION DIFERENCIAL');
 tranhas(m,ptra); btran:=false; ki:=k; (*transmitir lo anterior*)
 nomcon:=nom;  (*guardar nombre de derivada por si hay subind.*)
  (*pasar el ' *)
 if pl^.con[k+1]='[' then (*subindice (numerico por ahora) *)
 begin
  k:=k+2; (*absorber ' y [ (se suponen unidos!!!!)*)
  recid; if not bent then error('integer number expected');
  nomcon:=nomcon+'['+nom+']'; (*nombre de la derivada con subindice*)
  recid;  if ch<>']' then errca(']');
  nom:=nomcon;      (*en nom queda nombre de variable y su subindice*)
IF W THEN WRITELN(NOM, '  ES VARIABLE CON SUBINDICE');
 end;
 k:=k+1;   (*k queda en o antes del : del :=*)

if becdif then nedgr:=nedgr+1  (* act. num.de ecdif en el grupo *)
          else begin encfec; necdifo:=necdif+1 end;
relvarcon(nomcon); (*buscar nomcon en lista de variables continuas*)

(*iniciar o continuar lista de variables de cada ecuacion sucesiva*)

listecva;

(* recoger UNA ecdif y formar linea de _fec en modedi 8 *)
 str(necdif,cen); (* numero de la ecuacion diferencial     *)
 ren1:=cen+':_fec:='; tranlin(8,true);

 absigu; (* buscar y verif. := *)
 ptra:=8;
 btran:=true; ki:=k;
 recexpr;      (*expresion de la derivada*)
 if not b and (ch=';')
  then begin tranhas(k,8); ki:=k end
  else
  begin  (* ver si grupo acaba por END o ELSE *)
   if (nom<>'END') and (nom<>'ELSE') then
    error('; or END or ELSE expected');
   tranhas(m,8); ren1:=';'; tranlin(8,false); ki:=m; fingr:=true;
  end;
 ptra:=4;
end;

(******************************************************** PRFUNPG *)
procedure prfunpg; (* procesar funcion P o G *)
var ik,nump,ijr:integer; (* van aqui por llamada recursiva *)
begin
IF W THEN BEGIN WRITELN('FUNCION P O G ',NOM); READln(UT) END;
ijr:=ij; ik:=0;
if nupar[ijr]>=0
  then
   begin  (* funcion con parametros expresiones *)
    nump:=nupar[ijr];
    if nump>0 then
     begin  bfunpg:=true; recid;
      if ch<>'(' then error('( missing in function');
      k:=k+1;
      while (ch<>')') and (ik<nump) do
      begin recexpr; (***)    ik:=ik+1  end;
       if ijr<=11 then (*es aleatoria *)
        if ch=','
         then
          begin (* debe seguir parametro numerico de semilla *)
          recid; if not bent then error('integer or ) expected');
           val(nom,numse,numpr);
           if (numse<1) or (numse>10)
            then error('invalid seed number');
           recid; k:=k+1
          end
         else
          begin  (* falta semilla poner ,1 *)
           tranhas(k-1,ptra); ren1:=',1)' ; tranlin(ptra,false);ki:=k
          end;

       if ch<>')' then
       error('missing ) or erroneous number of parameters');
       bfunpg:=false;
      end;
      if ik<>nump then error('erroneous number of parameters');
    end

  else (* funcion con parametros IL_ o EL_ *)

   begin btran:=false; tranhas(m,ptra); nom5:=nom;
    recid; if ch<>'(' then error('( missing in function');
    k:=k+1;
    busli(ren3); (* hallar numero de la lista *)
    if nom5='L' then ren1:='_l[.]'
    else if nom5='LENGTH' then ren1:='_l^[.]'
    else if nom5='MAXL' then ren1:='_lm^[.]'
    else if nom5='MINL' then ren1:='_^[.]'  (****!!!!!!!!!!!!***)
    else if nom5='MEDL' then ren1:='_lp^[.]'
    else if nom5='DMEDL' then ren1:='_de^[.]'
    else if nom5='ENTR' then ren1:='_en^[.]'
    else if nom5='TFREE' then ren1:='_tl^[.]'
    else if nom5='MSTL' then ren1:='_tpp^[.]'
    else if nom5='DMSTL' then ren1:='_dp^[.]' ;

    inser(ren1,'.',ren3,ren1,0); tranlin(ptra,false);
    recid; (* recoger ) *)
    if ch<>')'then error(') expected in function'); k:=k+1; ki:=k
   end; (* del if de parametros nodos *)
IF W THEN BEGIN WRITELN('PROCESADA FUNCION P O G'); READln(UT) END;

 b:=true; btran:=true
end;

(********************************************************* PRFUNP *)
procedure prfunp; (* procesar funcion PASCAL *)
var ik,nump:integer; (* van aqui por llamada recursiva *)
begin
IF W THEN BEGIN WRITELN('FUNCION PASCAL USUARIO ',NOM); READln(UT) END;
nump:=pva^.npar;
if nump>=0
 then
  begin  ik:=0; bfunpg:=true; recid;
      if ch<>'(' then error('( missing in function');
      k:=k+1;
      while (ch<>')') and (ik<nump) do begin recexpr; ik:=ik+1  end;
      if ch<>')' then
       error(') missing or erroneous number of parameters');
      bfunpg:=false;  b:=true  (*"recogido identificador" *)
  end;
 end;


(********************************************************* GELVEX *)
procedure gelvex; (*generar proc.escr.y lectura var.experimentales *)
begin
IF W THEN WRITELN('ENTRADA A GELVEX **************************');
      str(nexp,cnexp); (* enc. y const. lista nombres *)
      inser(fosa[117],'*',cnexp,ren1,0); tranlin(3,true);
      pex:=pexf; ren1:='('''+pex^.nom+''''; pex:=pex^.ps;
      tranlin(3,true);
      while pex<>nil do  (* nombres de segunda var y sig. *)
       begin ren1:=','''+pex^.nom+''''; tranlin(3,false);
       pex:=pex^.ps
      end ; ren1:=');' ; tranlin(3,false); limpbuf(3);

      ren1:=fosa[429]; tranlin(3,true);  (* trans.proced.de lect.var exp*)
      ren1:=fosa[430]; tranlin(3,true);ren1:=fosa[431]; tranlin(3,true);
      ren1:=fosa[432]; tranlin(3,true);ren1:=fosa[433]; tranlin(3,true);
      ren1:=fosa[434]; tranlin(3,true);ren1:=fosa[435]; tranlin(3,true);
      (* procedimiento _listvar *)
      ren1:=fosa[310]; tranlin(3,true); (* enc. _listvar *)
      ren1:=fosa[20];  tranlin(3,true);
(* instrucciones de escritura de variables experimentales *)
      pex:=pexf;
     while pex<>nil do  (* para todas las var. exp. *)
       begin
        case pex^.tipo of (* var arr rec arrrec tab fun *)
         'V':inser(fosa[140],'/',pex^.nom,ren1,0);
         'A':begin inser(fosa[141],'.',pex^.tam,ren1,0);
                   inser(ren1,'/',pex^.nom,ren1,0) end;
         'N':inser(fosa[422],'/',pex^.nom,ren1,0);
         'M':begin inser(fosa[141],'.',pex^.tam,ren1,0);
                   inser(ren1,'/',pex^.nom,ren1,0) end;
         'T':begin inser(fosa[424],'*',pex^.nom,ren1,0);
                   inser(ren1,'/',pex^.cr,ren1,0) end;
         'F':begin ren1:='writeln(''FUNCTION '','''+pex^.nom+''');';
                   tranlin(3,true);
                   inser(fosa[142],'/',pex^.nom,ren1,0);tranlin(3,true);
                   inser(fosa[143],'/',pex^.nom,ren1,0)
              end;
        end; (* del case instr.escr *)
        tranlin(3,false);
        pex:=pex^.ps
       end; (* del while instr. escr *)
      ren1:=fosa[21]; tranlin(3,true);

      ren1:=fosa[237]; tranlin(3,true);  (* comienzo del proc. pexp *)
      ren1:=fosa[475]; tranlin(3,true);
      ren1:=fosa[476]; tranlin(3,true);
      ren1:=fosa[311]; tranlin(3,true);
      ren1:=fosa[238]; tranlin(3,true);
      ren1:=fosa[239]; tranlin(3,true);
      ren1:=fosa[240]; tranlin(3,true);
      inser(fosa[130],'*',cnexp,ren1,0); tranlin(3,true);
      inser(fosa[131],'*',cnexp,ren1,0); tranlin(3,true);
      ren1:=fosa[132]; tranlin(3,true);
      pex:=pexf; nexp:=1;
     while pex<>nil do  (* transm.elementos del case *)
       begin str(nexp,cnexp); nexp:=nexp+1;
        case pex^.tipo of (* var arr rec arrrec tab fun *)
         'V':begin inser(fosa[118],'*',cnexp,ren1,0);
                   inser(ren1,'/',pex^.nom,ren1,0) end;
         'A':begin inser(fosa[119],'*',cnexp,ren1,0);
                   inser(ren1,'.',pex^.tam,ren1,0);tranlin(3,true);
                   inser(fosa[120],'/',pex^.nom,ren1,0) end;
         'N':begin inser(fosa[121],'*',cnexp,ren1,0);
                   inser(ren1,'/',pex^.nom,ren1,0);tranlin(3,true);
                   inser(fosa[122],'/',pex^.nom,ren1,0) end;
         'M':begin inser(fosa[119],'*',cnexp,ren1,0);
                   inser(ren1,'.',pex^.tam,ren1,0);tranlin(3,true);
                   inser(fosa[123],'/',pex^.nom,ren1,0);tranlin(3,true);
                   inser(fosa[124],'/',pex^.nom,ren1,0) end;
         'T':begin inser(fosa[125],'*',cnexp,ren1,0);
                   inser(ren1,'/',pex^.cr,ren1,0); tranlin(3,true);
                   inser(fosa[423],'/',pex^.cr,ren1,0); end;
         'F':begin inser(fosa[126],'*',cnexp,ren1,0);
                   inser(ren1,'/',pex^.nom,ren1,0); tranlin(3,true);
                   inser(fosa[127],'/',pex^.nom,ren1,0);tranlin(3,true);
                   inser(fosa[128],'/',pex^.nom,ren1,0) end;
        end; tranlin(3,false);
         pex:=pex^.ps;
       end;
       ren1:=fosa[129]; tranlin(3,true); (* end de case etc. *)
       ren1:=fosa[139]; tranlin(3,true); (* close _dat *)
     ren1:=fosa[144]; tranlin(3,true); (* instr. de repetir *)
     ren1:=fosa[21];tranlin(3,true); (* end del exp *)
     append(modec);
     end;


(**********************************************************BNET****)
procedure bnet; (* organizar la red *)
 type st2=string[2]; label 1;

(********************************************************** FINTR *)
procedure fintr; (* finalizar proc. de transferencia upvr uprv *)

procedure uplipro(up:st10 ;ptrf:ptl); (* up lista a modpro *)
var ptrx:ptl;
begin
IF W THEN BEGIN WRITELN('ENTRA A UPLIPRO (LIST.UPA A MODPRO)');
                READln(UT) END;
 ren1:=fosa[6];inser(ren1,'*',up,ren1,0); tranlin(3,true);
 ptrx:=ptrf;
 if ptrx=nil
 then begin ren1:=' 1:;'; tranlin(3,false) end
 else
 while ptrx<>nil do
 begin ren1:=ptrx^.con;tranlin(3,false);
       ptrx:=ptrx^.pls
 end;

 ren1:=fosa[44];tranlin(3,false)
end;

begin
 (* 1:; fantasma *)
 if ptrf=nil then begin ren1:=' 1:;'; tranlin(3,false) end;
 ren1:=fosa[44]; tranlin(3,false); (* end de case y upvr *)

 uplipro('_uprv' ,ptrf);
 uplipro('_upvro',ptrof);
 uplipro('_uprvo',ptrfo);

end;

(********************************************************* GENELI *)
procedure geneli; (* generar procedimiento de eliminacion reg *)
(*d95*) var _i: integer;
begin
 ren1:=fosa[69]; tranlin(3,true); (*procedure _elim(   *)

 ren1:=fosa[243]; tranlin(3,true); (*MESSAGE DELETED*)
 ren1:=fosa[165]; tranlin(3,true); (*MESSAGE DELETED*)
 ren1:=fosa[179]; tranlin(3,true); (*MESSAGE DELETED*)
 ren1:=fosa[180]; tranlin(3,true); (*MESSAGE DELETED*)
 ren1:='case r of '; tranlin(3,true);
 if ptrf=nil then begin ren1:=' 1:;'; tranlin(3,false) end
 else
 for _i:=1 to n do
   if nod^[_i].reg then
    begin str(_i,nic); inser(fosa[70],'*',nic,ren1,0); tranlin(3,true)
    end;
 pmess:=pmessf;
 while pmess<>nil do
 begin
  inser(fosa[70],'*',pmess^.num,ren1,0); tranlin(3,true);
  pmess:=pmess^.ps
 end;
 ren1:=fosa[21]; tranlin(3,true);   (*del case generado*)
 ren1:=fosa[21]; tranlin(3,true);
end;

(******************************************************** GENNEWR *)
procedure gennewr; (* generar procedimiento de duplicacion reg *)
(*d95*) var _i: integer;
begin ren1:=fosa[71]; tranlin(3,true);
 if ptrf=nil then begin ren1:=' 1:;'; tranlin(3,false) end
 else
 for _i:=1 to n do
   if nod^[_i].reg then
    begin str(_i,nic); inser(fosa[72],'*',nic,ren1,0); tranlin(3,true)
    end;
 pmess:=pmessf;
 while pmess<>nil do
 begin
  inser(fosa[72],'*',pmess^.num,ren1,0); tranlin(3,true);
  pmess:=pmess^.ps
 end;
 ren1:=fosa[86]; tranlin(3,true)
end;

(*********************************************************** DECON*)
procedure decon; (* declarar interv.max y t.ultimo cambio nodo C *)
begin
nom3:=nod^[k].nom;
if nod^[k].sub=1     (* decl dt_  _tc_ _ac _bi *)
 then begin tipo:='REAL'; inser(fosa[265],'*',nom3,ren1,0);
       tranlin(1,true); inser(fosa[260],'*',nom3,ren1,0) end

 else begin inser(fosa[266],'*',nom3,ren1,0); str(nod^[k].sub,nom1);
            inser(ren1,'/',nom1,ren1,0); tipo:='ARRAY'
      end;

tranlin(1,true);
typtyp:='REAL';
bg:=true; (* poner en arbol *)
ren1:='DT_'+nom3; stvname(true,ren1);
bg:=false;
end;


(******************************************************** POELELS *)
procedure poelels; (*poner el del k en lista de sucec. del ant. nna *)
begin (* pna apunt.a elem. de lis.ant. corr. al ant; el en pna^.nueli*)
 b:=true;pnh:=nod^[pna^.num].apns; (* prim.lista suc.de ant.de k *)
 while b do  (* ver lista sucec. de antecesor de k *)
  begin (* poner en ella el prim.num. de el del nodo k *)
   if pnh^.num=k then (* se halla k como sucesor en lista *)
    begin b:=false;pnh^.nueli:=pna^.nueli;
    end;
    pnh:=pnh^.pns
  end;
end;
(******************************************************* COPFSPL   *)
procedure copfspl; (*copiar funcion SPLINE*)
(*d95*) var _i: integer;
begin
 for _i:=341 to 364 do
 begin ren1:=fosa[_i]; tranlin(3,true)
end;
end;
(*****************************************************LISTARRFUN***)
procedure listarrfun; (*hacer lista para construir arreglos de funcval*)
                      (*lo usa gedefunc*)
 begin
  pfu:=pfuf;
  while pfu<>nil do   (*revisar para cada funcion valuada *)
   begin
    pmfx:=pmfxf;      (*la lista de tipos*)
    if pfu=pfuf       (**)
       then           (*si las listas estan vacias, crear el primero*)
        begin
         new(pmfx); pmfxf:=pmfx; pmfx^.ps:=nil;
         pmfx^.tipar:=pfu^.arg; pmfx^.maxp:=pfu^.np;
         new(pmfy); pmfyf:=pmfy; pmfy^.ps:=nil;
         pmfy^.tipar:=pfu^.mfu; pmfy^.maxp:=pfu^.np
        end
       else
        begin  (*buscar en lista existente de argumentos X *)
         pmfx:=pmfxf; b:=true;
         while (pmfx<>nil) and b do  (*hasta final o hasta encontrarlo*)
          begin
           if pfu^.arg=pmfx^.tipar
            then    (*se hallo; actualizar numero de puntos maximo*)
             begin
              if pfu^.np>pmfx^.maxp then pmfx^.maxp:=pfu^.np;
              b:=false
             end
            else pmfxa:=pmfx ; (*apuntador al revisado*)
           pmfx:=pmfx^.ps  (*si aun no se hallo ver el siguiente*)
          end;
         if b then (*no se hallo; crearlo*)
          begin
           new(pmfx); pmfxa^.ps:=pmfx; pmfx^.ps:=nil;
           pmfx^.tipar:=pfu^.arg; pmfx^.maxp:=pfu^.np; pmfxa:=pmfx
          end;
                 (*buscar en lista existente de valores de funcion Y*)
         pmfy:=pmfyf; b:=true;
         while (pmfy<>nil) and b do  (*hasta final o hasta encontrarlo*)
          begin
           if pfu^.mfu=pmfy^.tipar
            then    (*se hallo; actualizar numero de puntos maximo*)
             begin
              if pfu^.np>pmfy^.maxp then pmfy^.maxp:=pfu^.np;
              b:=false
             end
            else pmfya:=pmfy ; (*apuntador al revisado*)
           pmfy:=pmfy^.ps  (*si aun no se hallo ver el siguiente*)
          end;
         if b then (*no se hallo; crearlo*)
          begin
           new(pmfy); pmfya^.ps:=pmfy; pmfy^.ps:=nil;
           pmfy^.tipar:=pfu^.mfu; pmfy^.maxp:=pfu^.np; pmfya:=pmfy
          end;
        end;  (*del else de busqueda y agregado a listas existentes*)
     pfu:=pfu^.pfus; (*ver la funcion que sigue*)
   end;  (*del while que revisa funciones*)
 end;
(******************************************************* GEDEFUNC *)
procedure gedefunc; (* generar declaraciones de func.valuadas *)
var sco:string[2]; {nok:string[3];} (* compar. en busqueda en tabla *)
tix,tiy:st10;
begin

  listarrfun; (*construir lista de arreglos para funciones*)
   (*construir declaraciones de tipos de arreglos
  de funciones valuadas de tipo o argumento no REAL*)
  pmfx:=pmfxf;
  while pmfx<>nil  do
   begin
IF W THEN BEGIN WRITELN(PMFX^.TIPAR); READln(UT);  END;
      inser(fosa[92],'*',pmfx^.tipar,ren1,0); str(pmfx^.maxp,nvc);
      inser(ren1,'/',nvc,ren1,0); tranlin(1,true);
    pmfx:=pmfx^.ps
   end;

  pmfy:=pmfyf;
  while pmfy<>nil do
   begin
    if pmfy^.tipar<>'REAL' then
     begin
      inser(fosa[93],'&',pmfy^.tipar,ren1,0);
      inser(ren1,'/',nvc,ren1,0); tranlin(1,true);
     end;
      pmfy:=pmfy^.ps
   end;

   (*declaraciones de variables*)
   ren1:='var '; tranlin(1,true);
   pfu:=pfuf;
   while pfu<>nil do
    begin 
     inser(fosa[94],'@',pfu^.nom,ren1,0); (* _xfun:_xtipo;_y.. *)
     if pfu^.arg='REAL' then tix:='_tpx' else tix:='_x'+pfu^.arg;
     if pfu^.mfu='REAL' then tiy:='_tpy' else tiy:='_y'+pfu^.mfu;
     inser(ren1,'*',tix,ren1,0);
     inser(ren1,'&',tiy,ren1,0);
     tranlin(1,true);
     inser(fosa[95],'@',pfu^.nom,ren1,0); tranlin(1,true);
     if pfu^.arg<>'REAL' then
      begin ren1:='_xa'+pfu^.nom+':_tpxa;'; tranlin(1,true) end;
     pfu:=pfu^.pfus
    end;
    limpbuf(1); (* descargar buffer modec*)

(* creacion de los procedimientos de proceso de funciones *)
pcf:=pcff;
while pcf<>nil do
 begin
(*poner enc.de funcion valuada en proc. y en interface de unit
   para el caso en que funcion o argumento es no REAL*)
 if (pcf^.ar<>'REAL') or (pcf^.mf<>'REAL') then
  begin
   if pcf^.cl='DISC'
    then
     begin
      inser(fosa[101],'@',pcf^.cla,ren1,0); (*_fTIPOARGXARGY(x:..*)
      inser(ren1,'*',pcf^.ar,ren1,0); tranlin(3,true); (*modpro*)
                                   tranlin(1,true); (*modec*)
      if pcf^.ar='REAL' then tix:='_tpx' else tix:='_x'+pcf^.ar;
      inser(fosa[102],'*',tix,ren1,0); (*var ax  ay n*)
      if pcf^.mf='REAL' then tiy:='_tpy' else tiy:='_y'+pcf^.mf;
      inser(ren1,'&',tiy,ren1,0);
      inser(ren1,'/',pcf^.mf,ren1,0);
      tranlin(3,true); (*modpro*) tranlin(1,true); (*modec*)
      ren1:=fosa[103]; (* var j:integer begin j:=1 *)
      tranlin(3,true);
      ren1:=fosa[104]; tranlin(3,true); (*while j<>n *)
   (*si no es DISC poner j=1 or j>n para fuera de rango si no j>n*)
      ren1:=fosa [370];
      tranlin(3,true); (*if x< or x> error*)
      ren1:='_f'+pcf^.cla+':='; tranlin(3,true);
      if pcf^.mf='REAL' then ren1:=fosa[108] else ren1:=fosa[107];
      tranlin(3,false); (*asig. del valor a la funcion*)
      ren1:=fosa[21];  tranlin(3,true);  (*end de la _fTIPOARGXARGY(x  *)
     end

    else   (* generar funcion tipo FREQTIPOREAL poner en interface*)
     begin inser(fosa[294],'@',pcf^.cla,ren1,0); tranlin(3,true);
                                                 tranlin(1,true);
      inser(fosa[295],'*',pcf^.ar,ren1,0);
      inser(ren1,'&','_tpy',ren1,0); tranlin(3,false);
                                     tranlin(1,true);
      ren1:=fosa[296]; tranlin(3,true);
      ren1:=fosa[297]; tranlin(3,true);
      inser(fosa[298],'@',pcf^.cla,ren1,0); tranlin(3,false);
      ren1:=fosa[21]; tranlin(3,true);
    end; (*del caso FREQ*)

   end;  (*de argumento o valor no REAL*)
  pcf:=pcf^.ps
 end;    (*de ver todas las funciones para generar _fTIPOARGXARGY*)
  limpbuf(3);limpbuf(1);
end;
(* terminan declaraciones, incluidas funciones *)

(******************************************************** CRPROUT *)
procedure crprout; (* crear procedimiento de output *)
var elarr:boolean; ivest:integer; civest:st10;
procedure presv(plv:ptav);
(* gen. arr. estad.de var y act.final de estad.*)

procedure gelcar; (* generar elementos de arreglo o act.final estad.var *)
begin
if elarr then
begin
 plv^.nvl:=nvl;nvl:=nvl+plv^.ind; (* anot.y actual.ind.de arr.estad.*)
 inser(fosa[156],'*',plv^.nom,ren1,0);
 str(plv^.ind,cind);
 inser(ren1,'&',cind,ren1,0);
 if nve<nves then ren1:=ren1+','; nve:=nve+1; tranlin(1,false)
end
else                       (* generar transferencias para actualiz.*)
begin  ren2:=' ';

 if plv^.ind>1 then       (* Si var a actu. tiene sub.*)
  begin str(plv^.ind,cind);
   inser(fosa[259],'*',cind,ren1,0); tranlin(3,true); ren2:='[_ki]';
  end;
 inser(fosa[255],'*',plv^.nom+ren2,ren1,0);
 ivest:=ivest+INDANT; str(ivest,civest);
 if plv^.ind>1 then civest:=civest+'+_ki-1';
 inser(ren1,'/',civest,ren1,0); tranlin(3,false);
 if plv^.ind>1 then begin ren1:=fosa[21]; tranlin(3,true) end
end;
INDANT:=PLV^.IND; (*guardar indice del anterior*)
end; (*del gelcar*)

begin (* del presv *)
IF W THEN BEGIN WRITELN('A BUSCAR EN NODO DE ARBOL'); READln(UT) END;
if plv^.pa<>nil
 then
  begin presv(plv^.pa);
 IF W THEN BEGIN WRITELN(PLV^.NOM); IF PLV^.EST THEN WRITELN(' ESTAD') END;
   if plv^.est then BEGIN gelcar; IF W THEN WRITELN(PLV^.NOM) END;
   if plv^.ps<>nil then presv(plv^.ps)
  end
 else
  begin
 IF W THEN BEGIN WRITELN(PLV^.NOM); IF PLV^.EST THEN WRITELN(' ESTAD') END;
   if plv^.est then BEGIN gelcar; IF W THEN WRITELN(PLV^.NOM) END;
   if plv^.ps<>nil then presv(plv^.ps)
  end
end;  (* del presv *)

(*d95*) var _k: integer;
begin                        (*comienzo del crprout *)
 if nnest=0
 then
 begin  (*declaraciones fanta.en _stad  *)
  inser(fosa[148],'*','1',ren1,0);tranlin(1,true);
  ren1:='(nom:''H'';ind:1;el:1;il:1));' ; tranlin(1,true);
  inser(fosa[150],'*','0',ren1,0); tranlin(1,true);

  inser(fosa[112],'*','1',ren1,0); tranlin(1,true);
  inser(fosa[151],'*','1',ren1,0); tranlin(1,true);
  inser(fosa[479],'*','1',ren1,0); tranlin(1,true);

 end

 else    (*generacion de arreglos para escribir estadisticas*)
 begin
  ne:=0; nnll:=1; nees:=1; (*ind.arr.estad.nodos I E *)
  str(nnest,cnest); inser(fosa[148],'*',cnest,ren1,0);tranlin(1,true);
  for _k:=1 to n do
   if nod^[_k].est then
    begin (* el nodo k tiene estadistica *)
     k:=_k;
     str(nod^[k].sub,cind);
     inser(fosa[149],'*',nod^[k].nom,ren1,0); inser(ren1,'/',cind,ren1,0);
     case nod^[k].tipo of
    'I':begin inser(ren1,'&','-2',ren1,0);
         str(nnll,cnnll); nnll:=nnll+nod^[k].sub;
         inser(ren1,'.',cnnll,ren1,0);
         nod^[k].cnes:=cnnll; (*anotar ind.de arr.estad. *)
         ne:=ne+1; if ne<nnest then ren1:=ren1+',' ; tranlin(1,false)
        end;
    'D':begin inser(ren1,'&','-1',ren1,0); str(nod^[k].nant,cnel);
              inser(ren1,'.',cnel,ren1,0);
         ne:=ne+1; if ne<nnest then ren1:=ren1+',' ; tranlin(1,false);
         pna:=nod^[k].apna;
         while pna<>nil do (* para cada antecesor *)
          begin m:=pna^.num; (* numero de nodo antecesor *)
           inser(fosa[149],'*',nod^[m].nom,ren1,0); str(nod^[m].sub,cind);
           inser(ren1,'/',cind,ren1,0);
           if nod^[m].tipo='L' (* en tipo L usar il, si no el del D *)
            then begin cnel:='-1';str(nod^[m].il,cnil)   end
            else begin cnel:= '0';str(pna^.nueli,cnil) end;
           inser(ren1,'&',cnel,ren1,0);
           inser(ren1,'.',cnil,ren1,0);
           ne:=ne+1; if ne<nnest then ren1:=ren1+',' ; tranlin(1,false);
           pna:=pna^.pns;
          end
        end;
    'E':begin (* pone EL y en IL pone ind.arr. _tmps con signo - *)
         str(nod^[k].el,cnel); inser(ren1,'&',cnel,ren1,0);
         str(nees,cnees); nees:=nees+nod^[k].sub;
         nod^[k].cnes:=cnees; (*anotar ind.de arr.estad. *)
         inser(ren1,'.','-'+cnees,ren1,0);(*  - dice a stat que es E *)
         ne:=ne+1; if ne<nnest then ren1:=ren1+',' ; tranlin(1,false);
        end
      else begin  (* es nodo G L R *)
         str(nod^[k].el,cnel); inser(ren1,'&',cnel,ren1,0);
         str(nod^[k].il,cnil); inser(ren1,'.',cnil,ren1,0);
         ne:=ne+1; if ne<nnest then ren1:=ren1+',' ; tranlin(1,false);
        end;
     end (* del case *)
    end; (* del if estad. y del for *)

  ren1:=');'; tranlin(1,false);     (* pasar el nes:integer=# *)
  inser(fosa[150],'*',cnest,ren1,0); tranlin(1,true); limpbuf(1);


  if nnll>1 then  (* hubo nodos I con estad. *)
    str(nnll-1,cnnll)  (* decl. e inicial. arreglo _nulle *)
    else cnnll:='1'; (* fanta *)
  inser(fosa[112],'*',cnnll,ren1,0);tranlin(1,false);

  if nees>1 then (* hubo nodos E con estad.*)
    str(nees-1,cnees)  (* decl.e inicial.arr _tmps *)
    else cnees:='1'; (* fanta *)
  inser(fosa[151],'*',cnees,ren1,0); tranlin(1,false);
  inser(fosa[479],'*',cnees,ren1,0); tranlin(1,false);
end;
if nuli=1 then nulic:='1' else str(nuli-1,nulic);
(* pasar el _n_list:integer=# *)
inser(fosa[258],'*',nulic,ren1,0); tranlin(1,false);


(* si no hay estad. de variables generar decl.fantasma *)
 if nves=0 then

 begin  cnves:='1';
  inser(fosa[155],'*','1',ren1,0); tranlin(1,true);
  ren1:='(nom:''H'';ind:1));' ; tranlin(1,true);
  inser(fosa[160],'*','0',ren1,0);
  inser(ren1,'/','0',ren1,0);tranlin(1,false); (* const nves nvest 0 *)
  inser(fosa[157],'*','1',ren1,0); tranlin(1,true ); (* var _sv,etc.*)
  inser(fosa[487],'*','1',ren1,0); tranlin(1,true );
 end

 else        (*hay estadistica de variables generar descriptor*)
  begin IF W THEN BEGIN WRITELN('ESTAD. DE VARIABLES');READln(UT) END;
     str(nves,cnves); (* hubo estad.de nves variables *)
     nve:=1; nvl:=1; (* inic. contad. de var.con est.y ind.de estad.*)
     inser(fosa[155],'*',cnves,ren1,0); tranlin(1,true);
     elarr:=true; (* se genera arreglo descriptor de estad.de var.*)
     presv(pvf); (* procesar estad.de variables *)
     ren1:=');'; tranlin(1,false);
     inser(fosa[160],'*',cnves,ren1,0);(* pasar el _n_ves:integer=# *)
     str(nvest,cnves);
     inser(ren1,'/',cnves,ren1,0); (* pasar el _n_vest:integer=# *)
     tranlin(1,true);
     limpbuf(1);
     inser(fosa[157],'*',cnves,ren1,0); tranlin(1,true); (*decl.acu*)
     inser(fosa[487],'*',cnves,ren1,0); tranlin(1,true);
  end; (* del if nves *)

  inser(fosa[254],'/',cnves,ren1,0); tranlin(1,true); (* decl.las _vas*)

 (* generar proc. _aesva para actu. estad. finales de variables *)
 ren1:=fosa[253]; tranlin(3,true);
 if nves<>0 then
 begin
  elarr:=false;  ivest:=0;  INDANT:=1;
  presv(pvf);    (* generar las _vas[i]:=var; *)
 end;
 ren1:=fosa[21]; tranlin(3,true);    (* end del _aesva *)

    limpbuf(1);limpbuf(2);


end; (* del crprout *)

(************************************************************** GCLI *)
procedure gcli(nomn:st10;tip:st2;numl:integer); (* gen.lista nomb.lis*)
var j:integer;  cj:string[5];
begin
for j:=1 to numl do
begin  str(j,cj);
 new(plc); plc^.nl:=''''+tip+'_'+nomn+' '+cj+' '''; plc^.p:=nil;
 if plcf=nil then plcf:=plc else plca^.p:=plc; plca:=plc
end
end;

procedure ponenla;   (* poner EL en lis.de antec.y suc.del ant.*)
 begin
  while pna<> nil do 
   begin
    pna^.nueli:=nod^[k].el; (* poner en lis.ant. num.de el del suc.*)
    (**** no interesaria si no son nodos D (solo una el) *********)
    poelels; (* pon. el del k en lista suc. del antec. del k *)
    pna:=pna^.pns (* ver el antecesor siguiente *)
   end
 end;

(*d95*) var _k: integer;
begin  IF W THEN BEGIN WRITELN('ORGANIZAR RED');READln(UT);
        READln(UT);READln(UT);READln(UT); END;
       {IF W THEN IMPNOD;}
 for _k:=1 to n do       (* poner sucesores con su numero     *)
  begin k:=_k;
   nod^[k].apna:=nil;  (* por ahora no hay antecesores  *)
   if k>1 then nod^[k-1].nextl:=nod^[k].nextl; (* indic.li.nod sig *)
   if nod^[k].sub<0 then (* si quedo con -1 desde revision,no hubo dec*)
     error('node with illegal subscript '+nod^[k].nom);
   pnf:=nod^[k].apns; (* apunta al primer nodo siguiente *)
   if pnf<>nil then
    begin    (* hay suc.explicitos (o es NOSUC) , verificar y numerar *)
    if pnf^.nom='NOSUC' then begin nod^[k].apns:=nil; pnf:=nil end;
IF W THEN WRITELN('SUCESORES INICIALES DE ',NOD^[K].NOM,' LIN ',NOD^[K].NEXTL);
     while pnf<>nil do  (* para cada sucesor            *)
      begin
       nom:=pnf^.nom; j:=1; (*buscar en lista *)
IF W THEN WRITELN(NOM);
       while (nom<>nod^[j].nom) and (j<=n) do j:=j+1;
       if j>n then error('not defined succesor '+nom);
       pnf^.num:=j; pnf:=pnf^.pns (* numerar y ver siguiente *)
      end;
IF W THEN READln(UT)
    end
    else    (* no hay suc.explicitos, poner implic. el siguiente  *)
     begin  (*a no ser que k sea nodo E,O,A,C o antecesor de I o ultimo,*)
      if (nod^[k].tipo='E') or (k=n) or (nod^[k+1].tipo='I') or
       (nod^[k].tipo='O') or (nod^[k].tipo='A') or (nod^[k].tipo='C')
       or (nod^[k+1].tipo='A')
       then  nod^[k].apns:=nil (* no suc.a nodo E I o O sin suc.expli.*)
       else  (* no tipo E ni ultimo sin suc.explicito, suc. el sig.  *)
        begin  new(pnf); nod^[k].apns:=pnf;
         pnf^.nom:=nod^[k+1].nom;
IF W THEN BEGIN WRITELN('SUC.DE DEFECTO ',PNF^.NOM,
                         '   CON SUBINDICE ',NOD^[K+1].SUB); READln(UT)
          END;
         str(nod^[k+1].sub,pnf^.sub);
        { pnf^.sub:='ino';}  (* subindice de defecto del suc.impl. *)
         pnf^.num:=k+1; pnf^.pns:=nil;
       end
     end
  end;
 nod^[n].nextl:=block[2]; (* linea siguiente del ultimo es INIT *)

 for _k:=1 to n do (* poner cada uno como antecesor en sus sucesores *)
  begin  k:=_k;
   pnf:=nod^[k].apns;
   while pnf<>nil do  (* recorrer lista de sucesores    *)
    begin j:=pnf^.num;
     if nod^[k].tipo='C' then nod^[j].antc:=true;
     if nod^[j].tipo='I' then
        error('I type node succesor of '+nod^[k].nom);
     if (nod^[j].tipo='C') and (nod^[k].tipo<>'C')
      then error('C type node succesor of '+nod^[k].nom);
     if (nod^[k].tipo='L') and (nod^[j].tipo='L') then
     error('L type node succesor of L type node '+nod^[k].nom);
     new(pna); pna^.nom:=nod^[k].nom; pna^.num:=k; pna^.pns:=nil;
     str(nod^[k].sub,iin);pna^.sub:=iin;
      if nod^[j].apna=nil then nod^[j].apna:=pna
       else begin pn:=nod^[j].apna; (******mejor usar ap. al ultimo*)
             while pn<>nil do  begin pnh:=pn; pn:=pn^.pns end;
             pnh^.pns:=pna
            end;
     pnf:=pnf^.pns;  (* ver el sucesor siguiente *)
    end
  end;

  (************ asignar numeros de lista  y contar los de estad.****)

for _k:=1 to n do  (* asignar listas internas *)
 begin  k:=_k;
  ch:=nod^[k].tipo;(* nodo tipo LDR u O con IL asignar il *)
  if (ch='L') or (ch='R') or ((ch='O') and (nod^[k].il=-1))
   then begin nod^[k].il:=nuli;nuli:=nuli+nod^[k].sub;
         gcli(nod^[k].nom,'IL',nod^[k].sub)
        end;
 end;

nnest:=0;

for _k:=1 to n do   (* para todos los nodos k ver EL a asignar *)
 begin k:=_k;
  nod^[k].nant:=1;   (*numero antecesores 1 (por ahora)*)
  if nod^[k].est then nnest:=nnest+1;   (*numero con estadistica*)
  pna:=nod^[k].apna;        (*ap. a lista de antecesores*)
    if pna<>nil then nna:=pna^.num; (* ap.al primer ant. num.=nna *)



 case nod^[k].tipo of  (*procesar segun el tipo*)

 'A': if pna<>nil then error('Node '+nod^[k].nom+' with predecessor');
 'O': if pna<>nil
       then                (*si hay antecesor*)
        if nod^[k].el=0   (*si no se declaro EL es error*)
         then error('Node '+nod^[k].nom+' without EL')
         else              (*si se declaro darle numero*)
          begin
           nod^[k].el:=nuli;
           nuli:=nuli+nod^[k].sub;
           gcli(nod^[k].nom,'EL',nod^[k].sub); (* generar nom.list.de TRACE *)
           ponenla;
          end;

 {Delphi Para nodo Subsystem 17.3.2001 Se revito, exe2 mal VER  01.02.2002}
 'E': if pna=nil
       then              (*si no hay antecesores error*)
        error('Node '+nod^[k].nom+' without predecessor')
       else              (*si hay darle numero a la EL*)
        begin
         nod^[k].el:=nuli;
         nuli:=nuli+nod^[k].sub;
         gcli(nod^[k].nom,'EL',nod^[k].sub); (* generar nom.list.de TRACE *)
         ponenla;
        end;
// }
 {'E',}'G','R':  {Delphi Para nodo Subsystem 17.3.2001, agregado E}
     begin
      if pna=nil   (*si no hay antecesores error*)
       then error('Node '+nod^[k].nom+' without predecessor');

       (*hay antecesor, si es tipo L encadenar*)
      pn:=pna; (*busca antecesor L*)
      while (pn<>nil) and (nod^[pn^.num].tipo<>'L') do pn:=pn^.pns;
      if (pn<>nil)
        then       (*hay un L antecesor, pn lo apunta en lista de ant.*)
         begin
          nna:=pn^.num;  (*numero del L antecesor*);
          pnla:=nod^[nna].apns; (*apunta a primer sucesor del antec.L*)
            if  pnla^.num=k
             then    (*el primer sucesor del L anterior es el procesado*)

              begin
               if nod^[nna].sub<>nod^[k].sub
                then
                 error('mismatch dimension nodes '+
                   nod^[k].nom+' '+nod^[nna].nom);
              (*encadenar EL del proc. con IL del L antecesor*)

               nod^[k].el:=nod^[nna].il; (* el es la il del ant *)
               nod^[k].subel:=nod^[nna].subel; (* con su dimens  *)
               nod^[k].nant:=nod^[nna].sub; (* num.de ante.se usa en GR*)
              end

         end  (*de hay L antecesor*)

       else  (*tipo G R pero no tiene antecesor tipo L producir las EL*)
           begin
            nod^[k].el:=nuli;
            nuli:=nuli+nod^[k].sub;
            gcli(nod^[k].nom,'EL',nod^[k].sub) (* generar nom.list.de TRACE *)
           end;
      ponenla;
     end; (*del case G R*)



  'L':if pna=nil then error('L type node without predecessor '+nod^[k].nom)
       else
        begin
         {Subsystem 15.3.2001 ? REVERTIDO }
         if nod^[nod^[k].apns^.num].tipo='E' then
          error('node E first succesor of '+nod^[k].nom); 
         nod^[k].el:=nuli;  (*anotar numero primera EL*)
         nuli:=nuli+nod^[k].sub; (*actualizar contaje EL*)
         gcli(nod^[k].nom,'EL',nod^[k].sub); (*generar nombre EL del TRACE*)
         while pna<> nil do (* pon. el en lis.de antec.y suc.del ant.*)
          begin
           pna^.nueli:=nod^[k].el;(*pon.en lis.ant. num.de el del suc.*)
         (**** no interesaria si no son nodos D (solo una el) *******)
           poelels; (* pon. el del k en lista suc. del antec. del k *)
           pna:=pna^.pns (* ver el antecesor siguiente *)
         end;
        end;

  'I': begin
       ulni:=k; noni:=noni+1; (*numero del ultimo nodo I, contar nodos I *)
       if nod^[k].dec=false then (* nodo I no declarado poner regis *)
        begin  str(k,cjn);          (*gen registro : *)
         inser(fosa[1],'*',cjn,ren1,0); tranlin(1,true);
         inser(fosa[2],'*',cjn,ren1,0); tranlin(1,true);
          str(k,nic);
          gelcaseup(k); (*generar elem.del case de 4 up***  *)
        end;
       nod^[k].reg:=true
       end;

  'D':begin
     IF W THEN BEGIN WRITELN('***********TIPO D'); READLN(UT) END;
       if pna=nil then
       error('D type node without predecessor '+nod^[k].nom);
   IF (NOD^[K].SUB>1)   (**PROVISIONAL***)
   THEN ERROR('subscripted node D ');
       nod^[k].nant:=0; (* contador de antecesores *)
         while pna<>nil do (* para cada antecesor *)
          begin
           if nod^[k].est then nnest:=nnest+1; (* en arr.de estad.se anotan antec.*)
           nod^[k].nant
             :=nod^[k].nant+NOD^[PNA^.NUM].SUB; (* contar antecesores *)
           (*si es antecesor L encadenar*)
           if nod^[pna^.num].tipo='L' then pna^.nueli:=nod^[pna^.num].il
            else    (* anotar en list.antec. el numero de la primera *)
             begin  (* el, que son tantas como LA SUMA de las dimen.*)
              pna^.nueli:=nuli;
              nuli:=nuli+NOD^[PNA^.NUM].SUB*nod^[k].sub;
              {}
              gcli(nod^[k].nom,'EL',
              {} nod^[k].sub*NOD^[PNA^.NUM].SUB);
             end;  (* se anotan las el del nodo k en antec. L aunque *)
    (* se supone que no interesan sucesores de nodo L (prohib.SENDTO?*)
           poelels; (* poner el del k en lista de suc. del antecesor *)
           pna:=pna^.pns
          end; (* del while pna *)
          IF W THEN BEGIN
           WRITELN('NUMERO DE ANTECESORES ',NOD^[K].APNA^.NUM);READLN(UT)
           END;
      end (* del 'D' *)


 end (* del case *)
end; (* del for *)

(* declaraciones de arreglos de apuntadores y parm.de colas *)
if nuli=1 then nulic:='1' (*no hubo listas:arreglos dim. 1..1*)
          else str(nuli-1,nulic);
ren1:=fosa[282]; tranlin(1,true);
inser(fosa[171],'*',nulic,ren1,0); tranlin(1,true); (*listas ap.ll fl*)
inser(fosa[3]  ,'*',nulic,ren1,0); tranlin(1,true); (*type list.estad*)
ren1:=fosa[4];tranlin(1,true); (*tipo ap.a list.estad y var ap.list.est*)
ren1:=fosa[5];tranlin(1,true); (*var ap.list.est*)
inser(fosa[369],'*',nulic,ren1,0); tranlin(1,true); (*num.de listas*)
limpbuf(1);

fintr; (*terminar transmision de upvr uprv *) (*generar elim y newr*)
geneli;gennewr; limpbuf(3);

(* declarar tipo _arrv para variables de _rkf; si no hay ec. dif.
  poner el absolute en IT (cualquier fijo) *)
if bhvcon then str(ivcon,civcon)
          else begin privarc:='IT';civcon:='1' end;
inser(fosa[257],'*',civcon,ren1,0); tranlin(1,true);
IF W THEN BEGIN WRITELN('PRIVARC ',PRIVARC);READln(UT) END;
inser(fosa[271],'/',privarc,ren1,0); tranlin(1,true); (*var _y arrv abs.*)

bvcon:=false;

(*inicializar procedimient :inieli*)
 ren1:=fosa[493]; tranlin(3,true);
 ren1:=fosa[490]; tranlin(3,true);
 ren1:=fosa[491]; tranlin(3,true);
 ren1:=fosa[492]; tranlin(3,true);
 ren1:=fosa[21];tranlin(3,true); (* end com *)

(* inicializar procedimiento com. Ver si hay inicializ. de recursos *)
ren1:=fosa[73];tranlin(3,true); (* proc.com time:=0; _es:=false; *)
for _k:=1 to n do  (* generar decl.e inic.de defecto de las capac. R *)
 begin k:=_k;
  if nod^[k].tipo='R' then recr(K); {hacer en ug7 agrvini}
  if nod^[k].tipo='C' then decon;
 end;
ren1:=fosa[21];tranlin(3,true); (* end com *)
if pcff<>nil then gedefunc; (* generar decl. de funciones valuadas *)
if not best then begin ren1:=fosa[173]; tranlin(3,true);
                  end;(*prstabegend  fantasmas  *)
                 crprout;

(*generar dec. arreglo BLCK y constante de nombres de listas *)
str(n,nst);
inser(fosa[163],'*',nst,ren1,0); tranlin(1,true);
inser(fosa[287],'*',nulic,ren1,0); tranlin(1,true); (*cons_ll ar.of_st10 *)
if nuli=1 then begin ren1:='''EL_V'');';tranlin(1,false) end  (*fantasma*)
else
begin
IF W THEN
 BEGIN WRITELN('LISTAS DE MENSAJES');
  PLC:=PLCF;
  WHILE PLC<>NIL DO BEGIN WRITELN(PLC^.NL); PLC:=PLC^.P END;
  READln(UT)
 END;
 plc:=plcf; ren1:=plc^.nl; tranlin(1,false); plc:=plc^.p; (*prim.sin , *)
 while plc<>nil do
 begin
  ren1:=','+plc^.nl; tranlin(1,false); plc:=plc^.p
 end;
 ren1:=');'; tranlin(1,false);
end;

 gecocano; (*generar constantes de caracteristicas de nodos*)



(* generar constantes de nombres de tablas y variables asociadas *)
if ntab=0 then cntab:='1' else str(ntab,cntab);
inser(fosa[288],'/','v',ren1,0); inser(ren1,'*',cntab,ren1,0);
tranlin(1,true);
if ntab=0 then begin ren1:='''_VFA'');'; tranlin(1,false) end (*fanta*)
else
begin
 plt:=pltf; ren1:=''''+plt^.v+''''; tranlin(1,false);
 plt:=plt^.p; (*prim.sin , *)
 while plt<>nil do
 begin
  ren1:=','+''''+plt^.v+''''; tranlin(1,false); plt:=plt^.p
 end;
 ren1:=');'; tranlin(1,false);
end;
inser(fosa[288],'/','t',ren1,0); inser(ren1,'*',cntab,ren1,0);
tranlin(1,true);

if ntab=0 then begin ren1:='''_TFA'');'; tranlin(1,false) end (*fanta*)
else
begin
 plt:=pltf; ren1:=''''+plt^.t+''''; tranlin(1,false);
 plt:=plt^.p; (*prim.sin , *)
 while plt<>nil do
 begin
  ren1:=','+''''+plt^.t+''''; tranlin(1,false); plt:=plt^.p
 end;
 ren1:=');'; tranlin(1,false);
end;
if pdb<>nil then prdecdb; (*procesar declaraciones de tablas DBASE*)
IF W THEN IMPNOD;
1:end; (* fin de bnet organizar nodos *)

(*********************************************************PROPROP**)
procedure proprop; (* procesar llamada a procedimiento PASCAL *)
var tipofp:string[10]; numpp:integer;
begin
IF W THEN BEGIN WRITELN('PROCED. O FUNCION PASCAL ',NOM); READln(UT) END;
tipofp:=tipo; numpp:=pva^.npar;
IF W THEN WRITELN('NUMERO DE PARAMETROS ',NUMPP);
if numpp<>0
  then
     begin  ik:=0; bfunpg:=true; recid;
      if ch<>'(' then error('( expected');
      k:=k+1;
      while (ch<>')') and (ik<numpp) do begin recexpr; ik:=ik+1  end;
      if ch<>')' then
       (*ver parametro opcional de RESET o REWRITE*)
       if ((ij=8) or (ij=9)) and (ch=',')
        then
         begin recexpr;
         end
        else error(') missing or incorrect parameter number');
      bfunpg:=false;
     end;
end;
(********************************************************** GEANS *)
procedure geans(bac:boolean); (* gen.envio aut.a nodos su.y act.reg.*)
 begin
   pna:=nod^[jn].apns;  (* apuntar a primer sucesor, si no hay es 00 *)
   if pna<>nil then calel(pna^.nueli,pna^.sub,cels) else cels:='00';
    (* en cels poner el con subin. *)
   if bac then begin
    ren1:=fosa[33]; tranlin(4,false) end; (*tran. upvr(#nod);*)
    inser(fosa[18],'.',cels,ren1,0);tranlin(4,false);  (*_agr*)
    if pna<>nil then pna:=pna^.pns;(*ver si hay mas suces.*)
    while pna<>nil do  (* para otros sucesores si hay tran. copy
                          envia al final*)
     begin
      calel(pna^.nueli,pna^.sub,cels); (* en cels poner el con subin. *)
      inser(fosa[27],'.',cels,ren1,0);
      inser(ren1,'/','_px',ren1,0);
      inser(ren1,'*','A',ren1,0);
      inser(ren1,'$','_ll['+cels+']',ren1,0);
      tranlin(4,false); pna:=pna^.pns;
     end;
  end;



(**********************************************************RECCOMI *)
procedure reccomi; (* recoger comienzo de instruccion en prins *)
begin bexpsu:=false;
IF W THEN
 BEGIN WRITELN('RECOGER COMIENZO DE INSTRUCCION ',NOM); READln(UT) END;
if lb<lbf then  (* hacer si no nos excedimos del nodo o secc.INIT *)
begin
 bprins:=true; nom4:=nom;
 clarec;
(*d95 27.4.98* besia:=pva^.est; *)  (* clasificar y guardar indic. de estad. *)
(* *) if pva = nil then besia:=true else besia:=pva^.est;
 if not besia then
 if (tipo='ARRAY') or (pva^.typtyp='ARRAY') then
  if bexp  (* si es experimental con un subindice *)
   then begin bexpsu:=true;
         recid; if ch<>'[' then error('[ expected'); k:=k+1;
         recid; nom4:=nom4+'['+nom+']';
         recid; if ch<>']' then error('] expected'); k:=k+1;
         kc:=2;
       end
   else if not besia then
    begin recid; verspar(pva^.dim); KC:=2 end; (***************ojo*)

  if tipo='STRING' then
   begin recid; if ch='[' then verspar(1) end;

 if (kc=2) and besia {and (not binit) and hayest}  then
       begin proesva end; (*proc.est.en NETWORK si se pidio*)
 if (kc=1) and (ch='#') then kc:=20; (* asignador de arreglos *)
 if (kc=1) and (ch='@') then kc:=24; (*instruccion de INPUT*)
 if (kc=1) and (ch='%') then kc:=25; (*instruccion de report*)
end;
end;
(********************************************************GESTANEC **)
procedure gestanec; (*generar estadisticas anteriores de ec.dif*)
label 1;
var nomec:st10; bnoest:boolean; necdi,necdifo1,necdi1:integer;
(*d95*) var _i: integer;
begin
IF W THEN
BEGIN
WRITELN('VER SI HAY QUE GENERAR ESTADISTICAS. NOM ',NOM);
PLVC:=PLVCF;
WHILE PLVC<>NIL DO BEGIN WRITELN(PLVC^.NOM,' ',PLVC^.SUBN,' ',PLVC^.NECDI);
PLVC:=PLVC^.PS END;  READln(UT);
END;
  nomec:=nom;
  bnoest:=true;
  (*si procesa RETARD busca solo primera del grupo*)
  if bdelay
   then begin necdi1:=necdifo; necdifo1:=necdi1 end
   else begin necdi1:=necdif;    necdifo1:=necdifo end;
IF W THEN WRITELN('BUSCAR VARIABLE ',NOM,' ',NECDIFO1,' a ',NECDI1);
if bdelay then goto 1;
IF W THEN READln(UT);
  for _i:={necdifo to necdi do} necdifo1 to necdi1 do (*para cada ecuacion
                                                     del grupo*)
  begin i:=_i;
   plvc:=plvcf;                (*busca su variable*)
   while (plvc^.necdi<>i) do  plvc:=plvc^.ps;
   nom:=plvc^.nom;
IF W THEN WRITELN('BUSCAR VARIABLE ',NOM,' ',I); IF W THEN READln(UT);
   busidar;   (*busca variable en arbol*)
   if pva^.est then
    begin
     if bnoest then  (*begin al comenzar*)
      begin ren1:=fosa[20]; tranlin(ptra,true); bnoest:=false end;
     if pva^.ind=1
      then begin str(pva^.nvl,invae); cindes:='['+invae+']' end
      else begin str(pva^.nvl-1+plvc^.subn,invae);
             cindes:='['+cindes+'+'+invae+']'
           end;
      inser(fosa[522],'.',cindes,ren1,0);
      inser(ren1,'/',plvc^.nom,ren1,0); tranlin(ptra,true);
      inser(fosa[523],'.',cindes,ren1,0);
      inser(ren1,'/',plvc^.nom,ren1,0); tranlin(ptra,true);
      inser(fosa[521],'.',cindes,ren1,0);
      inser(ren1,'/',plvc^.nom,ren1,0); tranlin(ptra,false);

    end;

  end;
  if not bnoest then begin ren1:=fosa[21]; tranlin(ptra,true) end;
  nom:=nomec;
  1:
end;

(********************************************************GESTPOEC **)
procedure gestpoec; (*generar estadisticas posteriores de ec.dif*)
label 1;
var nomec:st10; bnoest:boolean; necdi:integer;
(*d95*) var _i: integer;
begin
IF W THEN WRITELN('VER SI HAY QUE GENERAR ESTADISTICAS. NOM ',NOM);
  nomec:=nom;
  bnoest:=true;
  if bdelay then necdi:=necdifo else necdi:=necdif;
  for _i:=necdifo to necdi do  (*para cada ecuacion del grupo*)
  begin  i:=_i;
   if bdelay then goto 1;
   plvc:=plvcf;                (*busca su variable*)
   while (plvc^.necdi<>i) do  plvc:=plvc^.ps;
   nom:=plvc^.nom;
   busidar;   (*busca variable en arbol*)
   if pva^.est then
    begin
     if bnoest then  (*begin al comenzar*)
      begin ren1:=fosa[20]; tranlin(ptra,true); bnoest:=false end;
     if pva^.ind=1
      then begin str(pva^.nvl,invae); cindes:='['+invae+']' end
      else begin str(pva^.nvl-1+plvc^.subn,invae);
             cindes:='['+cindes+'+'+invae+']'
           end;
      inser(fosa[524],'.',cindes,ren1,0);
      inser(ren1,'/',plvc^.nom,ren1,0); tranlin(ptra,true);
      inser(fosa[525],'.',cindes,ren1,0);
      inser(ren1,'/',plvc^.nom,ren1,0); tranlin(ptra,false);
      inser(fosa[526],'.',cindes,ren1,0); tranlin(ptra,false);

    end;

  end;
  if not bnoest then begin ren1:=fosa[21]; tranlin(ptra,true) end;
  nom:=nomec;
  1:
end;

(********************************************************** GRKF  *)
procedure grkf; (* generar _rkf(m,n)  ;          *)
begin
  becdif:=false;
  (*revisar variables entre necdifo y necdif y generar estadisticas
    anteriores para las que se piden estadisticas*)

 { gestanec; } (*generar estadisticas anteriores*)

  str(necdifo,cem); str(necdif,cen);
  case metod of
   1:ren1:='_rkf(*,/);';
   2:ren1:='_eul(*,/);';
   3:ren1:='_rk4(*,/);';
  end;
  if not fingr then ren1:=ren1+';';
  inser(ren1,'*',cem,ren1,0); inser(ren1,'/',cen,ren1,0);
  tranlin(ptra,true); (* puesto _rkf(m,n); o el que sea *)

 { gestpoec;} (*generar estadisticas posteriores*)
  bdelay:=false; noreta:=0;
end;
(***********************************************************PRPOCA*)
procedure prpoca; (*procesar apuntador a campo*)
begin
 nom:=nom4; busidar;
 (*!!!!!!!!buscar en tabtypp y si no esta es error*)
 if false   then error('pointer type expected');
 k:=k+2; recid; (*recoger nombre de campo !!!!!!!!verificar*)
 if not b then error('field name expected '+nom);
 recid; (*deberia ser :=  *)
end;

end.