unit ug6; (* INSTR.PASCAL Y GLIDER PROCED. AUXILIAR DE PRIN *)
           (* AUXILIAR DE COMPILACION DE NODOS  *)

interface
uses ug1,ug2,ug3,ug4,ug5 {, crt};
procedure ledardb;   (*leer encabezamientos de archivo DBASE*)
procedure ledcadb; (*leer descritores de campos DBASE*)
procedure typarb; (*pone tipo a variables de arbol*)
procedure prcomp   ; (* procesar instruccion compuesta *)
procedure prif     ;
procedure prfor ;
procedure prrepeat ;
procedure prcase   ;
procedure prgoto   ;
procedure prdonode;
procedure prdoevent; (* procesar DOEVENT *)
procedure prins;
procedure propre;

implementation

(*****************************************************LEERENC****)
procedure ledardb;   (*leer encabezamientos de archivo DBASE*)
var i,j:integer;
begin
(*Lectura de los registros de informacion *)
reset(ardbase,1); (*apuntar al primero y poner de largo 1*)

(*lee de archivo descr., en area ledbase, 32 registros de largo 1
  en resul quedan la cantidad realmente leida*)
blockread(ardbase,ledbase,32 {,resul});
 numreg:=ledbase.numreg;
{ writeln('Fecha ultima actualizacion     ',
           ledbase.fecha[1],' ',ledbase.fecha[2],' ',ledbase.fecha[3]);
 writeln('Numero de registros            ',numreg);
 writeln('Numero de bytes en enc.        ',ledbase.bytenc);
 writeln('Numero de bytes en el registro ',ledbase.byrec);
 writeln;
}
 if numreg>nmaxrdb then nmaxrdb:=numreg; (*anotar numero maximo de registros*)
 numcdb:=((ledbase.bytenc-1) div 32) -1; (*numero de descriptores de campos*)
{ writeln('Numero de campos en el registro ',numcdb); }
 end;

procedure ledcadb; (*leer descritores de campos DBASE*)
 (*en ledbase estan los datos del archivo*)
 var j:integer;
 begin
  numcdb:=((ledbase.bytenc-1) div 32) -1; (*numero de descriptores de campos*)
  blockread(ardbase,ledbase,32 {,resul});  (*leer descriptor de campo*)
  pdesc:=addr(ledbase);                 (*apuntador a lo leido  ? *)
  longcdb:=pdesc^.largo;
  tipcdb:=pdesc^.tipo;
  decidb:=pdesc^.deci;
  nomcdb:=''; (*recoger nombre; !ojo! los de pdesc tienen 0 y no blanco*)
  j:=1; while ord(pdesc^.nomb[j])>=48  do  (*no pasar los ceros*)
         begin  nomcdb:=nomcdb+pdesc^.nomb[j]; j:=j+1 end;
   for j:=j to 11 do nomcdb[j]:=' ';
{   for j:=1 to 11 do WRITE(ORD(NOMCDB[J]):3); WRITELN;
  write('Nombre del campo ',nomcdb);
  write('  Tipo ',tipcdb);
  writeln('  Largo ',longcdb);
  writeln;

ch:=readkey;
}
end;

(********************************************************** GETR *)
procedure getr(i:integer;nom:st10);
 (* generar transf. ni:=nodo,i=1 si indice, nom:var.de reg. G *)
var chc:string[2]; nomo:string[74];
 begin
 chc:=copy(nom,1,2);
IF W THEN BEGIN WRITELN('PONER TRANSF V <-> R ',NOM);READln(UT) END;
 if chc<>'O_' then  (* el nombre no es de clase O_ *)

 begin
  ren1:=fosa[7+i];inser(ren1,'*',nic,ren1,0);   (* reg:=var o for etc*)
  inser(ren1,'@',nom,ren1,0); inser(ren1,'/',nom,ren1,0);
  if i=1 then begin inser(ren1,'$',iin,ren1,0);
                    inser(ren1,'&',isu,ren1,0);
              end; tranlin(3,false);
  ren1:=fosa[9+i];inser(ren1,'*',nic,ren1,0);   (* var:=reg *)
  inser(ren1,'@',nom,ren1,0); inser(ren1,'/',nom,ren1,0);
  if i=1 then begin inser(ren1,'$',iin,ren1,0);
                    inser(ren1,'&',isu,ren1,0)
              end;
  new(ptrx); ptrx^.pls:=nil; ptrx^.con:=ren1; ptrl^.pls:=ptrx; ptrl:=ptrx
 end

 else (* el nombre de var es clase O_  *)
  begin  nomo:=nom; delete(nom,1,2);
   ren1:=fosa[7+i];inser(ren1,'*',nic,ren1,0);  (* reg:=var_o *)
   inser(ren1,'@',nomo,ren1,0); inser(ren1,'/',nom,ren1,0);
   if i=1 then begin inser(ren1,'$',iin,ren1,0);
                     inser(ren1,'&',isu,ren1,0);
               end;
   new(ptro); ptro^.pls:=nil; ptro^.con:=ren1; ptrol^.pls:=ptro;
   ptrol:=ptro ;

   ren1:=fosa[9+i];inser(ren1,'*',nic,ren1,0);  (* var_o:=reg *)
   inser(ren1,'@',nomo,ren1,0); inser(ren1,'/',nom,ren1,0);
   if i=1 then begin inser(ren1,'$',iin,ren1,0);
                     inser(ren1,'&',isu,ren1,0)
               end;
   new(ptrxo); ptrxo^.pls:=nil; ptrxo^.con:=ren1; ptrlo^.pls:=ptrxo;
   ptrlo:=ptrxo
  end
end;

(************************************************ALMVCONT***)
procedure almvcont;   (*almacenar variable continua*)
var numret1,cjx:st10; nomvir:cont;
(*d95*) var _j: integer;
       begin

        pv^.typ:='REAL';     (*poner en lista de variables continuas*)
        pv^.ret:=0;
        pv^.est:=false;
        new(plvc); plvc^.nom:=pv^.nom; plvc^.subn:=0; plvc^.necdi:=0;
         plvc^.ps:=nil; (*elem.lista*)
        if plvcf=nil then plvcf:=plvc   (*si no hay va primero*)
                     else plvcl^.ps:=plvc; (*si hay va ultimo*)
        plvcl:=plvc;                     (*apunta al ultimo*)
        plvc^.ret:=0;   (*en principio no es de retardo*)
        ivcon:=ivcon+1;
        bvcon:=true;    (*procesa variable continua*)
IF W THEN BEGIN WRITELN('ALMACENADA VARIABLE CONTINUA ',PLVC^.NOM);
            {UT:=READKEY;} readln(UT);  END;
IF W THEN WRITELN('VA A GENERAR VARIABLES INTERMEDIAS DE RET.');

        val(numret,nretar,j); str(nretar-1,numret1);

        if besret and (nretar>1)
         then    (*es de retardo; generar decl. e intermedias*)
          begin
IF W THEN WRITELN('GENERANDO VARIABLES INTERMEDIAS DE RET.');
           inser(fosa[489],'*',numret1,ren1,0);  (*se declaran numret-1*)
           inser(ren1,'%',pv^.nom,ren1,0); tranlin(1,true);
           plvc^.ret:=nretar;  (*poner orden del ret. en var.salida*)
           for _j:=1 to nretar-1 do   (*guardar intermedias en lista*)
            begin j:=_j;                    (*de continuas*)
             str(j,cjx);
             new(plvc);
             plvc^.nom:='_'+pv^.nom+'_DEL';   (*guardar nombre e indice*)
             plvc^.subn:=j; plvc^.subs:=cjx;  (*como numero y como str.*)
             plvc^.necdi:=0; plvc^.ps:=nil;   (*elemento de lista*)
             plvc^.ret:=0;
             plvcl^.ps:=plvc; (*si hay va ultimo*)
             plvcl:=plvc;                     (*apunta al ultimo*)
IF W THEN WRITELN('GUARDADA VAR.INTERMEDIA RET***** ',plvc^.nom,' ',j );
             ivcon:=ivcon+1;
            end;
            pv^.est:=false;  (*por ahora no hay estadisticas*)
            pv^.ret:=nretar; (*indicar retardo en arbol*)

        {    nuvaco:=nuvaco+1;
            listecva;    }
          end      (*de var intermedia if besret*)
       end;        (*de var continua*)
(**********************************************ALARVCON****)
procedure alarvcon;  (*almacenar arreglo continuas
      se ponen tantas en lista como la dimension*)
var cjx:st10;
(*d95*) var _j: integer;
        begin
IF W THEN WRITELN('GENERAR ELEM.ARREGLO DE VAR.CONTINUAS');
         if pv^.dim>1 then error('more than one subscript');
         pv^.typel:='REAL';    (*las continuas son de tipo real*)
         pv^.ret:=0;
         pnx:=pv^.apind;       (*apuntador a valor subind. mim. y max.*)
         for _j:=pnx^.min to pnx^.max do
          begin j:=_j;
           str(j,cjx);
           new(plvc); plvc^.nom:=pv^.nom;   (*guardar nombre e indice*)
           plvc^.subn:=j; plvc^.subs:=cjx;  (*como numero y como str.*)
           plvc^.necdi:=0; plvc^.ps:=nil;   (*elemento de lista*)
           plvc^.ret:=0;
           if plvcf=nil then plvcf:=plvc
                             (*si no hay va primero*)
                        else plvcl^.ps:=plvc; (*si hay va ultimo*)
           plvcl:=plvc;                     (*apunta al ultimo*)
IF W THEN WRITELN('GUARDADA VAR.CONTINUA******** ',plvc^.nom,
             '  ', plvc^.subs );
          ivcon:=ivcon+1;
          end;
         if bprocp or bfunp then error('variable CONT in procedure');
         bvcon:=true;
        end;

(********************************************************* TYPARB *)
procedure typarb; (* pone tipo y largo de var.apuntadas en arbol   *)
        (* si estan (reg.G) verifica el tipo y gen. transf.de upvr *)
var cjx:st10; pcareu:ptlcare;
begin
 plv:=plvf; ch1:=';';
IF W THEN WRITELN('^^^^^^^^^^^^ENTRA A TYPARB');
 while plv<>nil do (* recorrer lista apunt. poner o verif. tipo    *)
 begin pv:=plv^.pv;
IF W THEN BEGIN
  WRITELN('LISTA APUNTADORES PV^.TYP=',PV^.TYP,'  NOM2=',NOM2);
  WRITELN('SE PUSO TIPO A *******    ',PV^.NOM); READln(UT) END;
   if pv^.typ=''
    then    (*poner tipo en elemento del arbol*)
     begin
      pv^.typ:=nom2;  (* poner tipo en arbol    *)
      pv^.typel:=typel; (* poner tipo de elemento arreglo *)
      pv^.long:=lc;   (* poner largo en arbol   *)
      pv^.ind:=indi;   (*dimension de ultimo subind.*)
      pv^.apind:=pnxf;  (* poner apunt. a lista min max indices *)
      pv^.dim:=dime;  (* poner dimension        *)
      pv^.typtyp:=typtyp; (*poner tipo del tipo*)
      pv^.apre:=parca; (*apuntara a lista de campos*)
      pv^.ret:=0;      (*supuesta no de retardo*)
      pv^.est:=false;

 (******!!!!!!! si el tipo del tipo es arreglo apuntar a datos de numero de
 subin. y lista de valores min.y max de los subindices tomardos en prarray*)
IF W THEN WRITELN('PTYP^.NOM ',PTYP^.NOM,'  PTYP^.TIPO ',PTYP^.TIPO);

      if (ptyp^.nom<>'ARRAY') and (ptyp^.tipo='ARRAY')
       then
        begin
IF W THEN BEGIN WRITELN('ES UN ARREGLO TIPO DECLARADO Y EL PRIMERSUB.ES ');
  PNX:=PTYP^.APIND; WRITELN(PNX^.MAX);  END;
         pv^.apind:=ptyp^.apind; pv^.dim:=ptyp^.nsub
        end;


IF W THEN BEGIN IF BPROCE THEN WRITELN('ES VARIABLE PROCEDIMIENTO');
                          READln(UT) END;
      if ptyp^.tipo='PROCEDURE' then  begin pv^.npar:=ptyp^.npar; end;

      pv^.tipop:=bproce; (* true si es variable tipo PROCEDURE*)

      if (nom2='CONT') then almvcont; (*var.cont.simple;
                                        poner REAL y agr. a lista*)

   (*si es arreglo de var.continuas, generar cada elemento*)
       if (nom2='ARRAY') and (pv^.typel='CONT') then alarvcon;

      if typel='FREQ' then   (*poner en lista de variables FREQ*)
       begin pv^.typel:='REAL';
        new(pfrmx);  (*poner en lista*)
        if pfrmf=nil then pfrmf:=pfrmx else pfrmx^.ps:=pfrma;
        pfrmx^.nom:=pv^.nom; pfrmx^.ps:=nil; pfrma:=pfrmx;
       end;

     end; (*fin de poner tipo en elemento de arbol*)


IF W THEN WRITELN('PTYP^.NOM ',PTYP^.NOM,'  PTYP^.TIPO ',PTYP^.TIPO);
    if  (ptyp^.nom<>'RECORD') and (ptyp^.tipo='RECORD')
     then
      begin

IF W THEN BEGIN WRITELN('ES UN RECORD TIPO DECLARADO; PRIMERA VAR:  ');
  PARCA:=PTYP^.APRE; WRITELN(PARCA^.NOM);  END;
         pv^.APRE:=ptyp^.apre;
      end;

    if nom2='GPOINTER' then
     begin (*agregar los apunt. a anterior *)
      nom3:='B_'+pv^.nom; tipo:=nom2;
      bg:=true; stvname(true,nom3); bg:=false; (*poner en arbol*)
      btran:=false;
      ren1:=ch1+nom3; ch1:=','; tranlin(1,false);
     end;

  if bdeclr then   (*si es campo de mensaje generar transf. upvr etc.*)
   begin
    if pv^.dim>1 then error('more than one subscript in field');
    if copy(pv^.nom,1,2)<>'O_' then getr(pv^.dim,pv^.nom); (* si es reg.G gener.transf. *)
    (*de las que no son O_ generar transf. O_ *)
    if copy(pv^.nom,1,2)<>'O_' then getr(pv^.dim,'O_'+pv^.nom);
   end;
  plv:=plv^.ps;      (*ver si sigue lista de tipos*)

 end; (*de revisar lista de variables y poner tipos en arbol*)

 (*agregar repetidas a lista de generar las _up rv vr rvo vro*)
{ pcare:=pcaref;
 while pcare<>nil do    (*revisar lista de repetidas*)
  begin
    getr(dime,pcare^.nom); (*ir a generar lista de transferencias*)
    pcareu:=pcare;
    pcare:=pcare^.ps; dispose(pcareu);  (*eliminar la vista*)
  end; pcaref:=nil;

 }
   if nom2='GPOINTER' then
    begin IF W THEN WRITELN('SE AGREGA :_pl; de b^_');
     ren1:=':_pl;'; tranlin(1,false); btran:=true; recid;
    end;
 (***************** hacer el dispose ************************)
IF W AND (PV^.TYPTYP='POINTER')  THEN
 BEGIN WRITELN('GUARDADA VARIABLE ',PV^.NOM,' TIPO ',PV^.TYP,' LA CUAL ES ',
 PV^.TYPTYP);  PARCA:=PV^.APRE;
 IF PVA^.TYPTYP='RECORD' THEN
 WRITELN('Y QUE APUNTA A SUBARBOL COM.POR ',PARCA^.NOM); READln(UT);
 END;

IF W THEN
BEGIN
 PLVC:=PLVCF;
 WHILE PLVC<>NIL DO
  BEGIN WRITELN('',PLVC^.NOM); PLVC:=PLVC^.PS END; READln(UT);
END;

end;

(********************************************************* PRCOMP *)
procedure prcomp   ; (* procesar instruccion compuesta *)
begin IF W THEN WRITELN('PRCOMP  ');
 begend:=begend+1;
 while nom<>'END' do prins;
 recid; if not b and (ch=';')  then k:=k+1;
        if b and(nom<>'ELSE') and (nom<>'END') then
                 error('incorrect compound statement');

 begend:=begend-1;
IF W THEN BEGIN WRITELN('PROCESADA INS.COMP NOM ',NOM,' CH ',CH,
                      ' PL^.CON[K] ',PL^.CON[K]); READln(UT) END;
end;

(********************************************************** PRIF  *)
procedure prif     ;
begin
 IF W THEN BEGIN WRITELN('PRIF    '); READln(UT) END;
 recexpr; if nom<>'THEN' then error('THEN missing or misplaced');
 prins;
 if nom='ELSE' then prins;
IF W THEN WRITELN('PROCESADO IF ');
end;

(******************************************************** PRWHILE *)
procedure prwhile  ;
begin IF W THEN BEGIN WRITELN('PRWHILE '); READln(UT) END;
 recexpr; if nom<>'DO' then error('DO missing or misplaced'); prins;
IF W THEN WRITELN('PROCESADO WHILE')
end;

(******************************************************** PRFOR  *)
procedure prfor ;
 label 1;
 begin IF W THEN BEGIN WRITELN('PRFOR   '); READln(UT) END;
   prins;
  if (nom<>'TO') and (nom<>'DOWNTO')
   then begin error('TO or DOWNTO expected');goto 1 end;
  recexpr;
  if nom<>'DO' then begin error('DO expected');goto 1 end;
  prins;
IF W THEN WRITELN('FOR PROCESADO');
1:end;

(****************************************************** PRREPEAT *)
procedure prrepeat ;
begin IF W THEN BEGIN WRITELN('PRREPEAT'); READln(UT) END;
 repunt:=repunt+1;
 while nom<>'UNTIL' do prins; recexpr;
 IF W THEN WRITELN('PROCESADO REPEAT');
 repunt:=repunt-1;
end;

(******************************************************* PRCASE *)
procedure prcase   ;
 procedure recle; (* rec.lista de escalares del case *)
  begin           (*!!!!!! verificar tipo !!!***)
   while ch<>':' do
    begin
     if ch='''' then
      begin
       k:=k+1; recid;
       if (ch<>'''') and (k-m>1) then error('illegal CASE list');
       k:=k+1; recid; (* rec.sig. a ' es , o : *)
      end
      else
       begin
        if not b then error('identifier expected');
        recid; (*rec.sig. , o : *)
       end;

     if (ch<>':') and (ch<>',')
       then error('illegal CASE list');
     if ch=',' then begin k:=k+1;recid end; (* rec. el ' o iden.sig. *)
    end ; k:=k+1;  (* saltar el : *)
   end;

 begin  (*comienza procesado del CASE*)
IF W THEN BEGIN WRITELN('PRCASE  '); READln(UT) END;
 casend:=casend+1;
 recexpr;
 if nom<>'OF' then error('OF expected'); recid;
 (*procesar casos*)
 while (nom<>'END') and (nom<>'ELSE') do
 begin (*recoger lista const. : instruccion y ELSE instruccion *)
  recle; (*recoge encabezamiento del caso*)
  prins; k:=k+1;  (* rec.lo que sigue a instruccion *)
  if nom<>'END' then recid;
 end;
 if nom='ELSE' then
  begin prins; k:=k+1; recid;
   if nom<>'END' then error('END expected')
  end;
IF W THEN WRITELN('VA  A VER QUE SIGUE AL CASE ; END o ELSE');
   recid;
   if (ch=';') or (nom='END') or (nom='ELSE')
    then begin k:=k+1; tranhas(k,ptra);ki:=k end
    else error('; or END or ELSE expected');
 casend:=casend-1;
 IF W THEN WRITELN('PROCESADA INS.CASE CASEND=',CASEND);
end;

(********************************************************PRGOTO *)
procedure prgoto   ;
(* marta 11.7.2001 begin IF W THEN WRITELN('PRGOTO  '); READln(UT);*)
begin IF W THEN begin WRITELN('PRGOTO  '); READln(UT); end;
 recid; (* recoger label *)
 plab:=nod^[jn].plab; b:=true;
   while b and (plab<>nil) do
    begin if plab^.nom=nom then b:=false;
     plab:=plab^.pls
    end;
 if b then error('label not declared');
 tranhas(k,ptra);  finpro(false)
end;

(**********************************************************PRDONODE *)
procedure prdonode; (* procesar DONODE *)
begin
 tranhas(m,ptra); ki:=k; (* saltar ident. DONODE *)
 IF W THEN BEGIN WRITELN('CJN ',CJN);READln(UT) END;
 inser(fosa[184],'*',cjn,ren1,0); tranlin(ptra,true);
 prins; tranhas(k,ptra); ki:=k; limpbuf(ptra);
end;

(**********************************************************PRDOEVENT *)
procedure prdoevent; (* procesar DOEVENT *)
begin
 tranhas(m,ptra); ki:=k; (* saltar ident. DOEVENT *)
 ren1:=fosa[185]; tranlin(ptra,true);
 prins; tranhas(k,ptra); ki:=k; limpbuf(ptra);
end;

(********************************************************PRDELAY**)
procedure prdelay;  (*instruccion RETARD(N,SAL,RET,<EXPR.ENTRADA>); *)
 var varsal,oreta,retard,prim,seg,cii:st10; ii:integer;
(*d95*) var _j: integer;
 begin
  bdelay:=true;
  if nod^[jn].tipo<>'C' then error('RETARD in node not C');
  tranhas(m,ptra);   (*transmitir lo anterior a RETARD*)
  btran:=false;      (*inhibir transmision a prog.objeto*)
  recid; if ch<>'(' then errca('('); k:=k+1;
  recid; (* recoge lo que sigue al ( , debe ser numero*)
  if not bent then error('integer expected');
  oreta:=nom;        (*guardar orden del retardo*)
  val(oreta,noreta,j);
  recid; if ch<>',' then errca(','); k:=k+1;
  recid; (*recoger variable de salida; buscar en tabla fun.cont.*)
  varsal:=nom;
  necdifo:=necdif+1;
  relvarcon(varsal);    (*revisar lista var.cont.poner num.ec.dif
                          y de intermedias*)
  for ii:=1 to noreta-1 do
   begin str(ii,cii);relvarcon('_'+varsal+'_DEL'+'['+cii+']'); end;
  recid; if ch<>',' then errca(','); k:=k+1;
  recid;            (*recoger variable de retardo*)
  if not bnumer
   then  (*si no es numero*)
    begin
     busidar;  (*ver si es variable REAL*)
     if not bva and (pva^.typ<>'REAL')
      then error('REAL variable or number expected');
    end;
  retard:=nom;
  recid; if ch<>',' then errca(','); k:=k+1;
  {if becdif        (*elim. pues se fuerza fin de grupo*)
   then nedgr:=nedgr+1
   else}
   encfec;  (*encab.de _fec ndegr:=1 necdifo*)
  necdif:=necdifo; (*reponer necdif a valor original; ya se restaura:*)
  str(necdif,cen);
  ren1:=cen+':_fec:=('; tranlin(8,true);   (*linea del case, comienzo*)
  ptra:=8; btran:=true; ki:=k;
  recexpr; (*recoge expresion de entrada*)

  tranhas(k-1,ptra);  btran:=false;
  if noreta>1   (*ret>1 generar primera; ret:=1 generar unica*)
   then ren1:='-'+'_'+varsal+'_DEL[1])*'+oreta+'/'+retard
   else ren1:='-'+varsal+')*'+oreta+'/'+retard ; tranlin(8,false);

  if ch<>')' then errca(')'); nedgr:=nedgr+1;
  btran:=true;
  finpro(false);
  btran:=false;
  tranhas(k,ptra);
  seg:='1';
  for _j:=1 to noreta-2 do  (*generar lineas del case de _fec*)
   begin j:=_j;
    necdif:=necdif+1; nedgr:=nedgr+1;
    str(j,prim); str(j+1,seg); str(necdif,cen);
    ren1:=cen+':_fec:=(_'+
      varsal+'_DEL['+prim+']-_'+varsal+'_DEL['+seg+'])*'+oreta
            +'/'+retard+';';
    tranlin(8,true);
   end;
  if noreta>1 then
  begin
   nedgr:=nedgr+1; necdif:=necdif+1;
   str(necdif,cen);     (*ultima linea del case*)
   ren1:=cen+':_fec:=(_'+varsal+'_DEL['+seg+']-'+varsal+')*'+
                    oreta+'/'+retard+';'; tranlin(8,true);
  end;
  IF W THEN WRITELN('NECDIFO ',NECDIFO,'  NECDIF ',NECDIF);
  IF W THEN READln(UT);
  fingr:=true; (*forzar el fin de grupo PODRIA NO HACERSE!!!!!!*)
  ptra:=4; btran:=true; nom:=varsal; nedgr:=0;
end;

(********************************************************PRACTI*)
{procedure practi;
 var nodn:string[4];
 begin  (* procesa ACT(NODO[IN],EXPRESION) o DEACT  *)
    if binit then bacti:=true; (*anotar hubo ACT en INIT*)
    recid; if ch<>'(' then errca('('); k:=k+1;
    reno(true);recid; if nom2='' then nom2:='1';
    if ij=31
     then  (* es DEACT *)
      begin
      str(i,nodn);
      if nod^[i].tipo='C'
       then inser(fosa[335],'*',nod^[i].nom,ren1,0)
       else inser(fosa[371],'*',nodn,ren1,0);
       tranlin(ptra,true);
       recid; k:=k+1; ki:=k
      end
     else (* es ACT *)
      begin
       if (nod^[i].tipo='R')
        then error('ACT forbidden for node type R');
       if ch<>',' then errca(',');k:=k+1;
       if (nod^[i].tipo='C')
        then pracc
        else     (* es ACT nodo no C *)
         begin
          inser(fosa[29],'*',nic,ren1,0);inser(ren1,'/',nom2,ren1,0);
          tranlin(ptra,false); btran:=true; ki:=k;
          recexpr;
         end
      end;
    if ch<>')' then error('ACTIVATE illegaly ended');
    tranhas(k,ptra); btran:=false;
    finpro(false);  btran:=true;
    end;
   }
(*********************************************************PRECREA***)
 procedure prcrea;
   var numens:st10;
   begin (* procesar CREATE(NODO o MESS) INSTRUCCION  *)
      balt:=true; bcrea:=true; bmess:=false;
      if jn<>nnuant then ncrea:=ncrea+1; (*contar nodos con CREATE*)
      recid; if ch<>'(' then errca('('); k:=k+1;
      reno(false);
      if bc then
       begin butamess;
        if not bmessfo then error('node or message name expected');
        ccn:=pmess^.num; bmess:=true;
       end;
      if (not bmess) and (not nod^[i].reg)
       then error('CREATE with node without message');
      recid; if ch <> ')' then errca(')'); k:=k+1;
      if not bmess then str(i,ccn);
      ren1:=fosa[20]; tranlin(ptra,true);  (*begin*)
      inser(fosa[166],'*',ccn,ren1,0); tranlin(ptra,true); (*new gt _px *)

      (*incr.num.mess y poner numero de nodo en mess.*)
      str(ncrea+ulni,numens);
      inser(fosa[161],'*',numens,ren1,0); inser(ren1,'%',cjn,ren1,0);
      tranlin(ptra,true);

      inser(fosa[169],'*',ccn,ren1,0); tranlin(ptra,false);
      ren1:=fosa[20]; tranlin(ptra,false); (* begin de asociada*)
      btran:=true; ki:=k;
      bextr:=false; (*el SENDTO no debe extraer*)
      prins; (* proc. y transmitir INSTRUCCION *)
      tranhas(m,ptra); ki:=m;
      inser(fosa[167],'*',ccn,ren1,0); tranlin(ptra,false); (* upvr *)
      ren1:=fosa[21]; tranlin(ptra,false); (* end *)
      finingl; (* finalizar instr. CREATE *)
      balt:=false; bcrea:=false;
      nnuant:=jn; (*guardar numero de nodo*)
      bextr:=true;
     end;
(***********************************************************PREXTR***)
procedure prextr;
  begin (* proc. EXTR(<LISTA>,<APUNTADOR>) <INSTRUCCION>)  *)
   balt:=false;  (*uso esqueletos alternativos  com. 3/1998*)
   brel:=true; binext:=true;
   recid; if ch<>'(' then errca('('); k:=k+1;
   ren1:=fosa[20]; tranlin(ptra,true); (* begin de la instr.gli.*)
   recap; (*inicializa y recoge POINTERG en nomx numlista en ren3 *)
   ren1:='_pu:='+nomx+';' ; tranlin(ptra,true); (*instr de pasar a _pu *)
   inser(fosa[304],'/',nomx,ren1,0); inser(ren1,'.',ren3,ren1,0);
   tranlin(ptra,true);
   recid;
   if ch<>')' then errca(')'); k:=k+1;
   inser(fosa[322],'/','_pu',ren1,0); tranlin(ptra,true); (*mens.a o_var*)
   ren1:=fosa[20]; tranlin(ptra,true);  (* begin de <instruccion> *)
   btran:=true; ki:=k;
   ren5:=ren3; (*para usar en el SENDTO*)  (*30/3/98*)
   prins;
   tranhas(m,ptra); ki:=m;
   ren1:=fosa[21]; tranlin(ptra,true);  (* end de <instruccion> *)
   finingl; (* finalizar instr. G ponerle end *)
   brel:=false; binext:=false;
  end;

procedure prpreem;
  begin (* proc. PREEMPTION(<exp.logica>,REMA)<instruccion> *)
      if nod^[jn].tipo<>'R' then error('PREEMPTION illegal in this node');
      bpree:=true; brem:=false; balt:=true;
      nomp:=nod^[jn].nom;             bnpree:=false;
      ren1:=fosa[20]; tranlin(ptra,true); (* begin del PREE *)
      recid; if ch<>'(' then errca('('); k:=k+1; ki:=k;
      if nod^[jn].sub>1 then nomp:=nod^[jn].nom+'[ino]' else nomp:=nod^[jn].nom;
      inser(fosa[224],'/',nomp,ren1,0); tranlin(ptra,true);(*if f_R=0 *)
      inser(fosa[233],'*',cnil,ren1,0); tranlin(ptra,true);(*_pu uprvo*)
      ren1:=fosa[228];  tranlin(ptra,true); (*if cond.log de desalojo*)
      btran:=true; bfunpg:=true; (*permite , despues de expresion*)
      recexpr;    (* se recoge expresion logica *)
      bfunpg:=false;  (*k apunta a despues de , *)
      tranhas(k-1,ptra);
      btran:=false;
      if ch=','
       then
        begin recid;
         if nom<>'REMA'
          then error('REMA expected')
          else begin busidar; (* ver si se declaro REMA *)
                if not bva then error('not message with REMA');
                brem:=true; recid
               end
        end;
        ren1:=')'; tranlin(ptra,false); (*cierre de cond.logica*)
      if ch<>')' then errca(')'); k:=k+1; ki:=k;
      inser(fosa[225],'*',cnil,ren1,0); inser(ren1,'/',nomp,ren1,0);
      tranlin(ptra,true);
      inser(fosa[236],'/',nomp,ren1,0); tranlin(ptra,false);
      if brem then begin ren1:=fosa[226]; tranlin(ptra,true) end;
      ren1:=fosa[227]; tranlin(ptra,false);
      btran:=true;
      ren1:=fosa[20]; tranlin(ptra,true); (* begin de la instruccion *)

      prins; (* procesa instruccion del PREEMPTION *)
      tranhas(m,ptra); ki:=m;
      ren1:=fosa[21]; tranlin(ptra,true); (* end de la instruccion *)
      ren1:=fosa[44]; tranlin(ptra,true); (* end end de if if *)
      finingl; (* finalizar el PREEMPTION *)
       bpree:=false; balt:=false; bnpree:=true; {1998}
  end;

(***************************************************PRSCAN*******)
 procedure prscan;
 var lista:string[5];
  begin (* SCAN(<LISTA>,\<APUNTADOR>\)<INSTRUCCION>  *)
   balt:=false; bsca:=true; bnst:=true; bextra:=bextr;
   recid; if ch<>'(' then errca('('); k:=k+1;
   busli(ren3); (* numero de nodo en i2, num. lista en ren3 *)
   lista:=ren3;
   ren5:=ren3;   {1997}
   recid;
   if ch=')' then
    begin (* no hay apuntador *)
     apmen:='_pu'; apant:='_pa';
    end
    else
    begin (*hay apuntador*)
     if ch<>',' then errca(','); k:=k+1;
     recid; (* recoger apuntador *)
     apmen:=nom; apant:='B_'+nom
    end;
     inser(fosa[283],'*',lista,ren1,0);
     inser(ren1,'/',apmen,ren1,0);
     inser(ren1,'&',apant,ren1,0);tranlin(ptra,true); (*begin pu bsc*)
     inser(fosa[284],'/',apmen,ren1,0);; tranlin(ptra,true);
     (* while bsc and _pu<>nil do begin*)
     inser(fosa[322],'/',apmen,ren1,0); tranlin (ptra,false);
     recid; if ch<>')' then errca(')'); k:=k+1;
     ki:=k;
    btran:=true; bextr:=true;     (* si hay SENDTO debe extraer *)

    prins;

    tranhas(m,ptra); ki:=m;
    ren1:=';'; tranlin(ptra,false);
    bextr:=bextra;
   { if bnst then begin  }
    inser(fosa[303],'/',apmen,ren1,0); tranlin(ptra,true);
   { end;  }
    inser(fosa[347],'/',apmen,ren1,0); tranlin(ptra,true);
    inser(fosa[349],'/',apmen,ren1,0); inser(ren1,'&',apant,ren1,0);
     tranlin(ptra,true);
    inser(fosa[348],'*',lista,ren1,0); inser(ren1,'/',apmen,ren1,0);
    tranlin(ptra,true);
    ren1:=fosa[21]; tranlin(ptra,true); (* end del while *)
    ren1:='_bsc:=false;'; tranlin(ptra,true);  (*10/4/1998*)
    finingl;
    bsca:=false; balt:=false;
  end;

 procedure prrel;
  begin (* REL(<LISTA>,<EXPRESION LOGICA)<INSTRUCCION. *)

   balt:=false; brel:=true;
   recid; if ch<>'(' then errca('('); k:=k+1;
   busli(ren3); (* numero de nodo en i2,indice en cind, lista en ren3 *)
   irel:=i2; cinrel:=cind; nomrel:=nom2; (* por si INSTRUCION las altera*)
   if nod^[irel].sub>1 then cindr:='['+cind+']'  else cindr:=' ';
   inser(fosa[247],'*',ren3,ren1,0);tranlin(ptra,true); (*begin pu extrel*)
   ren1:=fosa[248]; tranlin(ptra,true);  (* while _pu<>nil and  *)
   ren1:=fosa[249]; tranlin(ptra,true); (*begin exalo ; if *)
   recid; if ch<>',' then errca(','); k:=k+1; ki:=k;
   btran:=true;
   recexpr; (* se recoge expresion logica *)
   tranhas(k-1,ptra); ki:=k; btran:=false;
   if ch<>')' then errca(')');
   ren1:=fosa[250]; tranlin(ptra,true); (* then extrel true else  pu *)
   ren1:=fosa[21]; tranlin(ptra,true);  (* end del while _pu<>nil and *)
   inser(fosa[251],'*',ren3,ren1,0); tranlin(ptra,true); (*if extrel extr*)
   btran:=true;
   ren1:=fosa[20]; tranlin(ptra,true);  (* begin de <instruccion> *)
   prins;
   tranhas(m,ptra); ki:=m;
   ren1:=fosa[21]; tranlin(ptra,true);  (* end de <instruccion> *)
   str(irel,ci2);
   inser(fosa[252],'*',ci2,ren1,0); tranlin(ptra,true); (*if _ox<0 *)

   (* ajuste u_RXX f_RXX de nodo RXX de donde se quito elemento *)
   if nod^[irel].sub>1 then nomr:=nod^[irel].nom+'['+nomrel+']'
                       else nomr:=nod^[irel].nom (*nombre con o sin subi*);
   {inser(fosa[187],'*',nomr,ren1,0);tranlin(PTRA,true); (*if 1 0 _use 1 0 *)
   inser(fosa[188],'*',nomr,ren1,0);tranlin(ptra,false);(* si no _use=use *)
   }
   inser(fosa[89], '*',nomr,ren1,0);tranlin(ptra,false);(* aj free  *)
   bnfree:=true; nom2:={cinrel} nomrel;
   acesura(irel);        (* estadistica anterior del u_rxx *)
   inser(fosa[175],'*',nomr,ren1,0);tranlin(ptra,false);(* aj used *)
   acesurp(164);   (* estadistica posterior del u_rxx *)
   bnfree:=false;
   ren1:=fosa[21]; tranlin(ptra,true); (* end del if extrel *)
   finingl;
   brel:=false;
  end;

(*******************************************************PRSELECT*****)
{
 procedure prselect;
  begin (* proc. SELECT(NODOS:CANTIDAD;.....)<INSTRUCCION> *)
IF W THEN WRITELN('ENTRA A SELECT NOM,CH ',NOM, CH);
       if nod^[jn].tipo<>'D' then error('SELECT in node not D');
       bsel:=true; bexpr:=false; bextra:=bextr;
       nsel:=nsel+1;
       str(nsel,cnsel); cend:=0;(*cuen.select y begin *)
        ren1:=fosa[20]; tranlin(5,false);cend:=cend+1;(* begin de SELECT *)
       if ch<>'(' then errca('('); k:=k+1;
        reno(false); (*recoger nodo i , si no es queda bc=true *)

        while not bc do (* procesar lista de nodos, hasta FALEXPE *)
         begin
          busel(jn,i,ren3,true);(*bus.el para sel.*)
          inser(fosa[55],'.',cnsel,ren1,0);             (* generar    *)
          inser(ren1,'/',ren3,ren1,0); tranlin(5,false);(* prs#se(el) *)
          recid; (* debe seguir , o ) *) k:=k+1; bc:=true;
          if ch=',' then
           begin reno(false); IF W THEN WRITELN('SIGUE NODO ',NOM1) end
         end;

        (* end del select a modaux!!!!pendiente!!!!!!!!!!!!!!!!!!1 *)
        (* creacion del procedure en modnet *)
        inser(fosa[56],'.',cnsel,ren1,0); tranlin(4,false); ptra:=4;
        bfin:=false; k:=k+1; (* poner k despues del )   *)
        if (nom='') and (ch=')')
         then begin bfin:=true;nom1:='FIRST' end
         else nom1:=nom;
        if nom1='LAST' then ren1:=fosa[63] else ren1:=fosa[62];
        tranlin(4,false); (* poner _px:=_ll[el] o _px:=_fl[el] *)
        if (nom1='FIRST') or (nom1='LAST')
         then ren1:=fosa[64]
         else
          if (nom1='ALL') then  ren1:=fosa[36]
        (* si no debe ser expresion entera *)
           else begin bexpr:=true;
                 ren1:=fosa[58]; tranlin(4,false); (* k:=1;while...and k<= *)
                 k:=m; (* se recoge expr.  ent.!!!!!!!!!!*)
                 btran:=true; ki:=k; recexpr; tranhas(k,ptra);ki:=k;
                  if ch<>')' then errca(')');
                 btran:=false; ren1:=fosa[59];
                end;
         ren1:=ren1+fosa[32]; tranlin(4,false);  (* uprv(_px^.r); *)

         (* transmitir instrucciones se espera SENDTO, extr de el *)
         bextr:=true; btran:=true; cnel:='el'; ki:=k;
         prins;
         tranhas(m,ptra); ki:=m;
         bextr:=bextra;
         if bexpr then begin ren1:=fosa[65];tranlin(4,false) end;
         inser(fosa[87],'.',cnel,ren1,0); tranlin(4,false);(*end while*)
         ren1:=fosa[21]; tranlin(4,false); (* end del _prs *)
         bsel:=false;
         ptra:=5;   (*************verificar !!!!!!!!!!!!!!!!!!*)
         finingl;
      end;
}

 procedure prselect; (* proc. SELECT(NODOS:CANTIDAD;.....)<INSTRUCCION> *)
    type tprlino=^tlino;  (*lista de nodos*)
           tlino=record
             nom:st10;
            limi:string[10];
            lisu:string[10];
            elm1:cont;  (*numero de EL menos 1*)
              ps:tprlino;
                 end;
    var plino,plinof,plinoa:tprlino; ccend,limi,lisu:st10;
        elm1:cont;

    procedure bunosel; (*buscar nodo en el SELECT*)
      begin
        recid;
        butanod; (*recoger nodo i , si no es queda bc=true *)
        if bc then error('node name expected') ;nom1:=nom;
        if nod^[i].sub>1 then
         begin recid; if ch<>'[' then error('[ expected'); k:=k+1;
          recid; limi:=nom;
          recid;
          if (ch='.') and (pl^.con[k+1]='.')
              then begin k:=k+2; recid;
                    if b then lisu:=nom else error('wrong subscript')
                   end
              else if ch=']' then lisu:=limi else error('wrong subscript');
          recid; if ch<>']' then error('] expected'); k:=k+1;
         end;  NOM2:='1';
          busel(jn,i,elm1,true);(*bus.el para sel.*)
      end;

procedure genprs; (*generar llamadas a procesador SELECT*)
begin
 plino:=plinof;
 while plino<>nil do
  begin
   ren1:='_prs'+ccend+'('+
   plino^.elm1+','+nom+','+plino^.limi+','+plino^.lisu+');' ;
   tranlin(ptra,false);
   plino:=plino^.ps
  end;
end;

  begin (* proc. SELECT(NODOS:NUMSELEC;....)<INSTRUCCION> *)
IF W THEN WRITELN('ENTRA A SELECT NOM,CH ',NOM, CH);
       if nod^[jn].tipo<>'D' then error('SELECT in node not D');
       bsel:=true; bexpr:=false; bextra:=bextr;
       nsel:=nsel+1;
       str(nsel,cnsel); cend:=0;(*cuen.select y begin *)
        ren1:=fosa[20]; tranlin(5,false);
        cend:=cend+1;(* begin de SELECT *)
        str(cend,ccend); 
       recid;
       if ch<>'(' then errca('(');
        while ch<>')' do
         begin
          plinof:=nil;
           while ch<>':' do  (*recoger nodos en lista*)
            begin
             limi:='1'; lisu:='1'; 
             k:=k+1;  (*se espera nodo*)
             bunosel; (*busca nodo datos en nom1,i,limi,lisu *)
             new(plino); plino^.nom:=nom; plino^.ps:=nil;
                         plino^.limi:=limi; plino^.lisu:=lisu;
                         plino^.elm1:=elm1;
             if plinof=nil then plinof:=plino
                           else plinoa^.ps:=plino; plinoa:=plino;
             recid; (*recoger lo que sigue a nodo*)
             if (ch<>':') and (ch<>',') then error(': or , expected');
            end;
          k:=k+1; recid; (*numero o variable entera*)
          genprs;  (*generar llamadas a procesador de SELECT*)
          recid;
          if (ch<>';') and (ch<>')' )  then error('; or ) expected');
         end;    (*del while ch<>')'  *)
         k:=k+1;

        (* end del select a modaux!!!!pendiente!!!!!!!!!!!!!!!!!!1 *)
        (* creacion del procedure en modnet *)
        inser(fosa[56],'.',cnsel,ren1,0); tranlin(4,false); ptra:=4;

         ren1:=fosa[58];  tranlin(4,false); (* begin for _is:=i1...*)
         ren1:=fosa[263]; tranlin(4,false); (* while...and k<=_val *)
         ren1:=fosa[26];  tranlin(4,false); (* begin for _is:=i1...*)

         (* transmitir instrucciones se espera SENDTO, extr de el *)
         bextr:=true; btran:=true; cnel:='_el'; ki:=k;
         prins;
         tranhas(m,ptra); ki:=m;
         ren1:=';'; tranlin(4,false);
         bextr:=bextra;
         if bexpr then begin ren1:=fosa[65];tranlin(4,false) end;
         ren1:=fosa[65]; tranlin(4,true);
         inser(fosa[87],'.',cnel,ren1,0); tranlin(4,false);(*end while*)
         ren1:=fosa[44]; tranlin(4,false); (* end del _prs *)
         bsel:=false;
         ptra:=5;   (*************verificar !!!!!!!!!!!!!!!!!!*)
         finingl;
      end;
(*******************************************************PRSORT******)
 procedure prsort;
  begin (* procesar SORT(<LISTA>,<CAMPO>,A|D);  *)
       recid; if ch<>'(' then errca('('); k:=k+1;
       busli(ren3);
       inser(fosa[323],'/',ren3,ren1,0);
       recid; if ch<>',' then errca(','); k:=k+1;
       recid; busidar;
       (* verificar si es campo *)
       if not (pva^.vame and bva) then error('message field expected '+nom);
       inser(ren1,'*',nom,ren1,0);
       recid; if ch<>',' then errca(','); k:=k+1;
       recid;
       if (nom<>'A') and (nom<>'D') then error('A or D expected');
       inser(ren1,'.',nom,ren1,0); tranlin(ptra,true);
       recid; if ch<>')' then errca(')'); k:=k+1;
       finpro(false); btran:=true
      end;
(***********************************************************PRCOPY***)
 procedure prcopy;
  begin (* procesar COPY(<VARIABLE>) <INSTRUCCION>  *)
     { if (nod^[jn].tipo ='L') or ((nod^[jn].tipo='R') and not brelea)
       then error('COPY illegal in this node');
      }
      bsp:=true; balt:=true; bcopy:=true;
      recid; if ch<>'(' then errca('('); k:=k+1;
      recid; noms:=nom;
      recid; if ch<>')' then errca(')'); k:=k+1; ki:=k;
      ren1:=fosa[210]; tranlin(ptra,true); (* _exal(_px)  ac1 acc *)
      inser(fosa[211],'*',noms,ren1,0); tranlin(ptra,true); (*for icopy*)
      ren1:=fosa[212]; tranlin(ptra,true); (* newr new(_pu) *)
      ren1:=fosa[213]; tranlin(ptra,true); (* pu r.....pu x *)
      ren1:=fosa[20]; tranlin(ptra,true); (* begin<instruccion> *)
      bextra :=bextr; bextr:=false; btran:=true;

      prins;       (* <instruccion> ch=; o b con END o ELSE *)
      tranhas(m,ptra); ki:=m;  (*terminar transmision de asociada*)
                               (*por transmitir ; END o ELSE *)
      ren1:=fosa[21]; tranlin(ptra,true); (* end de <instruccion asoc.> *)
      ren1:=fosa[214]; tranlin(ptra,true); (*if _acc then error end for*)
      ren1:=fosa[215]; tranlin(ptra,true); (*  acc=ac1 (rest) *)

finingl; (* fin de instruccion asociada *)
bsp:=false; balt:=false; bextr:=bextra; bcopy:=false;
end;

(**************************************************PRSYNCHR***)
 procedure prsynchr;
  (* procesar SYNCHRONIZE o ASSEMBLE *)
    begin
     if bstate or (nod^[jn].tipo in ['L','I','D','E','R'])then
     error('SYNCHRONIZE o ASSEMBLE illegal in this node');

     ball:=false; bequ:=false; ij1:=ij;
     bextra:=bextr; (*guardar condicion de extrac.de SENDTO*)
     bsa:=true; balt:=true;
     recid; if ch<>'(' then errca('('); k:=k+1;
     recid; (* recoge lo que sigue al (  *)

     if ij1=3
      then
       begin  (*es ASSEMBLE*)
        if nom='ELIM'
         then tyas:=1
         else if nom='FIRST' then tyas:=2
                             else error('ELIM, FIRST expected');
         recid;
         if ch<>',' then errca(','); k:=k+1;
         recid   (*recoge lo que sigue a  ,  *)
       end;

      if nom='ALL' then begin ball:=true; noms:='2' end
                               else noms:=nom;
     (*sust. llamada a _iniass( * ); cnel  *)
     inser(fosa[201],'*',cnel,ren1,0);tranlin(ptra,true);(*pa ac1 _px *)
     inser(fosa[192],'*',cnel,ren1,0);  (*while l[2]>=noms and <>nil do be *)
     inser(ren1,'/',noms,ren1,0); tranlin(ptra,true);
     recid; if ch<>',' then errca(',');  k:=k+1;
     recid;
     if nom='EQUFIELD'
      then begin bequ:=true; recid;
            if ch<>'(' then error('( missing in EQUFIELD'); k:=k+1;
            recid; nomf:=nom; (* campo de sincroniz. en nomf *)
       busidar;
      { if not (pva^.vame and bva) then
       error('message field expected '+nom);
       }  (*eliminado 05081996*)
            recid; if ch<>')' then error(') missing in EQUFIELD');
            k:=k+1; recid; (* busca ) *)
            k:=k+1;
           end
       else  k:=m;  (* volver a comienzo expresion logica *)
       ki:=k;
     if nexl=0 then  (* si es primer SYNCR ,enc. de funcion _cl *)
      begin          (* function _cl(....):boolean; begin case n1 of *)
       rewrite(modlog);
       ren1:=fosa[198]; tranlin(7,true); ren1:=fosa[208]; tranlin(7,true);
      end;
     nexl:=nexl+1; str(nexl,cnexl);
     inser(fosa[199],'*',cnexl,ren1,0); tranlin(7,true); (* *:begin  *)
     ptra:=7; btran:=true;
     if not bequ
      then recexpr  (************debe ser logica o EQUFIELD *)
      else begin (* la expr.logica  O_nomf=nomf al case en modlog *)
            inser(fosa[200],'*',nomf,ren1,0); tranlin(7,false);
           end;

     if ch<>')' then errca(')');  (* k queda despues de ) *)
     tranhas(k-1,7); ki:=k;
     ren1:=') end;'; tranlin(7,false);  (* end; del elemento del case *)
     ptra:=4;
     if ball then noms:='maxint';
     inser(fosa[193],'*',noms,ren1,0); (*sinc(var_ent,n.exp.logica) *)
     inser(ren1,'/',cnexl,ren1,0); tranlin(ptra,true);
   (* segun sea EQUFIELD  o <exp-logica> *)

     if ball then noms:='>=2' else noms:='='+noms;
     inser(fosa[194],'*',noms,ren1,0); tranlin(ptra,true); (*if ks=>=*)
     if ij1=3 then          (*_aas:=true;_plas:=_pc^.p1*)
      begin ren1:=fosa[205];tranlin(ptra,true)  end; (*ASSE*)
     ren1:=fosa[195]; tranlin(ptra,true); (* while _pc *)
     if ij1=3 then begin ren1:=fosa[206];tranlin(ptra,true) end; (*ASSE*)

     ren1:=fosa[217]; tranlin(ptra,true); (*exal(_pu); uprv *)
    {  if (ij1=3) and (tyas=3) then (*si ASS gen copia.que sust.a la actu*)
       begin
        ren1:=fosa[380]; tranlin(ptra,true);  (*_newr etc*)
        ren1:=fosa[381]; tranlin(ptra,true);  (*_pa^.pa:=_pu; etc*)
        inser(fosa[382],'*',cnel,ren1,0); tranlin(ptra,true);
                                      (*if _fl[*]=_pu etc.*)
        ren1:='_pu:=_pa;'; tranlin(ptra,true);
       end;
     }
     bextr:=true; btran:=true;
                  (* en SENDTO ver de donde se extrae  *)
IF W THEN BEGIN WRITELN('A PRINS DESDE SYNCHRONIZE'); READln(UT) END;
     ren1:=fosa[20]; tranlin(ptra,true); (* begin<instruccion> *)
 IF W THEN WRITELN('VIENE INSTRUCCION DEL SYNCH O ASSE ');

     prins;       (* <instruccion> ch=; o b con END o ELSE *)

 IF W THEN WRITELN('*************************************************');
 IF W THEN BEGIN WRITELN(' FIN INSTR.ASOCIADA');
                 WRITELN('CH ',CH);
                 WRITELN(' PL^.CON[K] ',PL^.CON[K]);
                 WRITELN('  NOM  ',NOM);
               READln(UT) END;

     if ch=';' then tranhas(k,ptra) else tranhas(m,ptra); ki:=k;
     ren1:=fosa[21]; tranlin(ptra,true);

     ren1:=fosa[202]; tranlin(ptra,true);  (* if _acc then error *)
     if ij1=3 then
     begin ren1:=fosa[21]; tranlin(ptra,true) end; (*ASSE*)
     (*sust. llamada a ililisin; *)
     ren1:=fosa[196]; tranlin(ptra,true);  (* _as  _pc dispose *)

     if ij1=3 then   (*generar encad.o elim.de lista ensamblados*)
      begin         (*poner primero if _acc then begin extr(_pu *)
       inser(fosa[209],'*',cnel,ren1,0);tranlin(ptra,true);
       case tyas of  (* ELIM FIRST NEW *)
        1: ren1:=fosa[207]; (*_elim(_pu^.r,,_pu; *)
        2: begin ren1:=fosa[301]; (*if_pc<>nil_pu^.p:=_pc^.p1else*)
            tranlin(ptra,true);
            ren1:=fosa[386]; tranlin(ptra,true);
            ren1:=fosa[387]; tranlin(ptra,true);
            ren1:=fosa[388]; tranlin(ptra,true);
            ren1:=fosa[30];  tranlin(ptra,true); (*tie.end de if_acc*)
            ren1:=fosa[28];
           end;
        3: ren1:=fosa[383]; (*_pas^.p    _pas*  _pu^.p *)
       end;
       tranlin(ptra,true);
       if tyas<>2 then begin ren1:=fosa[21]; tranlin(ptra,true) end;
      end; (*ASSE*)

     inser(fosa[197],'*',cnel,ren1,0); tranlin(ptra,true);
     if nod^[i].tipo='G' then  (* si es G restituir _acc, variables y *)
     begin                    (* si se quito poner _px nil           *)
      inser(fosa[203],'*',cnel,ren1,0); tranlin(ptra,true); (*restit.*)
       ren1:=fosa[135]; tranlin(ptra,true); (*if px<>nil exal(_px); uprv *)
     end;
     (* fin instr.generadas SYNCH ,falta el end(;) *)
     bextr:=bextra;
     IF W THEN BEGIN WRITELN(' FIN INSTR.ASOCIADA  CH ',CH,' NOM ',NOM);
               READln(UT) END;
     if not b and (ch=';')
      then ren1:=fosa[21]   (* end; del SYNCH o ASSE *)
      else if (nom<>'END') and (nom<>'ELSE')
            then error('SYNCHRONIZE or ASSEMBLE illegaly ended')
            else begin ki:=m-1; ren1:=fosa[30] end; (* end del SYNC o ASSE*)
     tranlin(ptra,false);
     bsa:=false; balt:=false;
  end;

 procedure prdeass;
   begin (*procesar DEASSEMBLE*)
     (*solo en nodos G (no en STATE) D E y R (en RELEASE)*)
     if bstate or (nod^[jn].tipo in ['L','I'])
        or ((nod^[jn].tipo='R') and not brelea)
     then
     error('DEASSEMBLE illegal in this node');  (*15/4/1998*)

         bdea:=true;
         tranhas(m,ptra); ki:=k;
         ren1:=fosa[20]; tranlin(ptra,true); (* begin de la instr.gli.*)
         ren1:=fosa[384]; tranlin(ptra,true);
         ren1:=fosa[385]; tranlin(ptra,true);
         inser(fosa[322],'/','_pu',ren1,0); tranlin(ptra,true);(*_uprvo(_pu*)
         ren1:=fosa[20]; tranlin(ptra,true);  (* begin de <instruccion> *)
         btran:=true;
         bextr:=true;
         prins;
         tranhas(m,ptra); ki:=m;
         ren1:=fosa[21]; tranlin(ptra,true);  (* end de <instruccion> *)
         ren1:='_pu:=_pas; end end;' ; tranlin(ptra,true);
         {ren1:=fosa[32]; tranlin(ptra,true);} (*******??********)
         finingl;        (*ve final y pone end de inst.G *)
         bdea:=false;
         (*en nodos D E R (RELEASE) ya esta extraido el representante
           poner llave de extraccion en false para el SENDTO*)
         if nod^[jn].tipo in ['D','E','R']  then  bextr:=false;
        end;


(***********************************************************  PROGLI *)
procedure progli; (* procesar procedimientos glider *)
   begin (* procesar procedimientos GLIDER *)
    if bexp then error('illegal procedure in EXPER');
    btran:=false; tranhas(m,ptra); (*supri.tran.autom.
                                     y trans.lo anterior*)
 KI:=M;
 case ij of   (* ij=posicion en tabla stgli *)

  1,31:practi;

  2:   pragr;

  5:   prcrea;

  6:  prendsimul;

  8:  prextr;

 10:  prbeginscan;

 16:  prpoin;

 17:  prpreem;

 18:  prscan;

 19:  prselect;

 20:  prsend;  (*procesar SENDTO*)

 22,3: prsynchr;

 23:   prsort;

 24:  prcopy;

 13,9: prlifi;

 15:  prorder;

 25:  prstop;

 26:  prstopall;

 27:  prstat;
 51:  prstat;  (*menu*)
 11:  prgo;

 12:  prgoall;

 28:  prfree;

 29:  prnotfree;

 30:  prrel;

 32:  prtab;

 33: prclrstat;

 34: prstopscan;

 35: prupdate;

 36: prtrans;

 37: prreplic;

 38,39:prextfel;

 40: prmethod;

 41: prdeass;

 42: prgraf;

 43: prdestroy;

 44: prpause;

 45: prtrace;

 46: pruntrace;

 47: begin  (*procesar asignacion a arreglos ASSI   ( # )  *)
      {tranhas(m,ptra);} prasrrar
     end;

 48: begin   (*instruccion de INTI (entrada interactiva @)*)
      {tranhas(m,ptra);} btran:=false; recid;  (*recoger variable*)
      binput:=true;
      prinput;  (*recoger instr.de input y generar llamada a proc.*)
      ki:=k; btran:=true;
     end;

 49: begin   (*instruccion de REPORT (salida % o OUTG)*)
      {tranhas(m,ptra);} btran:=false; recid;  (*recoger variable*)
      binput:=false;
      prinput;  (*recoger instr.de input y generar llamada a proc.*)
      ki:=k; btran:=true;
     end;

 50: prdelay;
 52,53: prblock;

 54: prdisfel;
 55: prload;
 56: prunload;
 57: prdbup;

   end (* end del case kc:=15 *)

 end; (*del progli *)

(********************************************************* PROPRE *)
 procedure propre; (* proc. IT, USE, STAY, etc :=EXPRESION *)
 var chi:char;
 begin  (* comienza procesando y transmitiendo :=EXPRESION *)
IF W THEN BEGIN WRITELN('ES IT USE O STAY');READln(UT) END;
  tranhas(m,ptra); (* transm.lo anterior a IT,USE o STAY *)
  ki:=m;
  ren1:=fosa[20]; tranlin(ptra,true); (* intercalar begin *)
  chi:=nom[1]; (* en chi queda I,U,S,etc. *)
  absigu; (*  ver :=   *)
  hayest:=false;
  prinsim(false);   (* procesar despues de := en adelante (inst.simple) *)
  if not b and (ch=';')
   then begin tranhas(k,ptra); ki:=k end
   else if (nom='ELSE') or (nom='END')
         then
          begin tranhas(m,ptra);ki:=m;ren1:=';'; tranlin(ptra,false) end
         else error('; or END or ELSE expected');
  case chi of
   'I':begin (* procesar IT:=EXPRESION *)
        inser(fosa[16],'*','_n',ren1,0); tranlin(ptra,false)
       end;
   'N':begin (* procesar NT:=EXPRESION *)
        inser(fosa[334],'*','_n',ren1,0); tranlin(ptra,false)
       end;
   'S':begin if nod^[jn].tipo<>'R' then error('STAY in not R type node');
       ren1:=fosa[41]; tranlin(4,false);  (* poner _sta true *)
       if nod^[jn].apns=nil then error('STAY in node without succesor');
       if brem then (* hubo PREEMPTION con REMA *)
        begin
        ren1:=fosa[235]; tranlin(ptra,true); (* if REMA<>0 , stay:=REMA*)
        end;
       end;
   'U':begin buse:=true
       end;
  end;      (* poner el end o end; *)
  if b then ren1:=fosa[30] else ren1:=fosa[21]; tranlin(ptra,false);
 end;

(********************************************************** PRINS *)
procedure prins; (* procesar instruccion hasta linea lbf *)
label 1; var bcont:boolean; cir:st10; k1:integer;
begin
bcont:=false;
IF W THEN BEGIN
WRITELN('*******************ENTRADA A PRINS  ');
WRITELN('VER SI SIGUE INSTRUCCION.  LINEA ',LB, '   LBF ',LBF);
WRITELN(PL^.CON); READln(UT) END;

recid;   (* recoger comienzo de instr. "handle" !!!!!*************)

if ch=''''  then   (* es ecuacion diferencial !!!!!!!!!!!*)
 begin
  if not bnodc then error('derivatives only in C node');
  necudi:=necudi+1;
  if fingr then (* se termino el grupo por END o ELSE   *)
   begin
     grkf; fingr:=false;  (* ver aqui el METHOD !!!!!!!!*)
   end;

   prcont; goto 1
 end  (*procesar ecdif *)

 else           (*no es ecuacion diferencial*)
  if becdif     (* se venia procesando ecdif *)
  then          (* comienzo despues de ecdif;llamar _rkf u otro *)
   begin
    grkf         (* ver aqui el METHOD *)
   end;

 (* desgraciadamente , ver si es label *)

 if bprno then (* se esta procesando nodo *)
  begin
   plab:=nod^[jn].plab; blab:=true;
   while b and (plab<>nil) do
    begin if plab^.nom=nom then blab:=false;
     plab:=plab^.pls
    end;
   if not blab then (* es label *)
     begin
      recid;
IF W THEN WRITELN('HALLO LABEL ');
      if ch<>':' then errca(':'); k:=k+1; goto 1
     end;
  end;

(* ver si es instruccion vacia *)
if not b and (ch=';') then begin k:=k+1; goto 1 end;


reccomi; (* rec. com. de instr. no ecuacion difer. ni label ni vacia*)
         (*ver ug4?*)

IF W THEN WRITELN('SE RECOGIO COMIENZO INST. ','CH ',CH,' PL^.CONK ',PL^.CON[K]);
IF W THEN BEGIN WRITELN('INSTRUCCION QUE COMIENZA CON ',NOM,' ',CH);
                WRITELN(' KC ',KC); READln(UT) END;
 if lb>=lbf then goto 1;
 case kc of
  1:if ch=';' (* es caracter *)
     then begin IF W THEN BEGIN WRITELN('INSTR. VACIA');
      READln(UT) END ;k:=k+1;goto 1 end;
  2:begin   (* instr. simple var predefinida o comun, ec.diferencial
               o nombre de proc o func PASCAL *)
IF W THEN WRITELN('VARIABLE DE TIPO ',TIPO);

    if tipo='PRE'
    then begin  propre end
    else
    begin  (* ver si es nombre de procedimiento *)
IF W THEN WRITELN('VARIABLE DE TIPO ',TIPO);
     if tipo='PROCP'
      then
       begin
IF W THEN WRITELN('VA A PROCESAR PROCED.PASCAL');
        proprop; tranhas(k,ptra);
        btran:=false; finpro(false); btran:=true;
IF W THEN BEGIN WRITELN('PROCESADO LLAMADA A PROC. NOM ',NOM, ' CH',CH,
                ' PL^.CON[K] ',PL^.CON[K]); READln(UT) END;
       end

      else
       begin
IF W THEN WRITELN('VARIABLE DE TIPO ',TIPO,' ASIGNATIVA');
  (* suponemos que es nombre de variable asi que es asignativa *)
        if not bexpsu (* si no era EXPER con subin.guardar por si es EXPER. *)
        then begin nom4:=nom; bexpsu:=false end;
        if pl^.con[k]='=' then k:=k-1; (*por si salto : en recexpr  *)

        recid; (* buscar :   o bien  [  de campo de record*)
        if ch='[' then begin verspar(pva^.dim); b:=false; recid end;

        if (ch='^') and (pl^.con[k+1]='.') then prpoca; (*apu.a camp*)

       if b or ((ch<>':') and (pl^.con[k+1]<>'='))
        then
         begin
IF W THEN BEGIN WRITELN('EJECUTAR SI ES VAR.PROC. ',PVA^.NOM);READln(UT) END;
          if pva^.tipop
           then
            begin
             IF W THEN BEGIN WRITELN('PASA A PRFUNP NPAR ',PVA^.NPAR); READln(UT) END;
             prfunp; goto 1
            end (*ejec de var.proced.*)
          else error(':= expected');
         end;
        k:=k+2;
        prinsim(true) ; (* es variable *)
       end
    end
   end;

  3:if nom='END' then begin IF W THEN writeln('INSTR. VACIA');
    ch:=';';goto 1 end
    else begin error('illegal begining of statement');goto 1 end;

  4:  (* asignar valor a nodo tipo R individual o llamada a nodo *)
       begin  nom1:=nom; k1:=m;
        recid; k:=k-1; nom:=nom1; m:=k1; (*restituir k m nom *)
        if ch='('
         then prntc else prntr;
       end;

  5: prfunv;  (*procesar funcion valuada en expresion !!ojo ver CLAREC*)

  6: printab;

  8:begin (* TSIM *)
     btsim:=true; (* Llave terminac.true *)
     absigu; (* buscar y elim. el := *)
     hayest:=false; (*no hay estadisticas de TSIM*)
     prinsim(false)
   end;

  9:begin if bexp then error('not allowed statement in EXPER');
     case r of
      1:prcomp; 2:prif; 3:prwhile; 4:prfor; 5:prrepeat; 6:prcase;
      7:prgoto; 9:prdonode; 10:prdoevent;
     end;
    end;
  13:; (* es UNTIL *)
  15: progli; (* procesar procedimientos GLIDER *)
  17: prrewr;

  18:begin (* procesar variables experimentales *)
      bexp:=true; nexp:=0; bexpa:=true;
      if not binit then error('no EXPER in INIT');
      ki:=k;
     end;
  19:begin (* ENDEXP final de  EXPER *)
      if not bexp then error('ENDEXP without EXPER');
      bexp:=false; ki:=k end;
  20:begin tranhas(k,ptra); k:=k+1; (*saltar el # *) prasrrar end;

  21:prpas;

  23:prrand;

  24:begin (*instruccion de INPUT*)  binput:=true;
      btran:=false; tranhas(k,ptra); k:=k+1; (*saltar el @ *)
      recid; (*se supone variable*)
      prinput; (*recoger instr.de input y generar llamada a proc.*)
      ki:=k; btran:=true;
    end;
  25:begin (*instruccion de REPORT*) binput:=false;
      btran:=false; tranhas(k,ptra); k:=k+1; (*saltar el % *)
      recid; (*se supone variable*)
      prinput; (*recoger instr.de output y generar llamada a proc.*)
      ki:=k; btran:=true;
    end;
  26:prreport; (*REPORT*)
  27:prendrep; (*ENDREPORT*)
  28:prfunva;  (*funcion valuada definicion en INIT*)

end; (* del case externo *)         kc:=0;


1:if lb>=lbf (*si termino INIT o nodo*)
  then (*verif. cierres BEGIN END  CASE END REPEAT UNTIL*)
  begin
   if begend<>0 then
    begin
     if binit then writeln('En procedimiento INIT')
              else writeln('Ver nodo ',  nod^[jn-1].nom );
     error('BEGIN END do not match in INIT or previous node')
    end;
   if casend<>0 then
    begin
     if binit then writeln('En procedimiento INIT')
              else writeln('Ver nodo ',  nod^[jn-1].nom );
     error('CASE END do not match in INIT or previous node')
    end;
   if repunt<>0 then
    begin
     if binit then writeln('En procedimiento INIT')
              else writeln('Ver nodo ',  nod^[jn-1].nom );
     error('REPEAT UNTIL do not match in INIT or previous node')
    end;
  end;

bprins:=false;
IF W THEN BEGIN WRITELN('********SALIDA PRINS CH ',CH,

                        ' PL^.CON[K] ',PL^.CON[K]);READln(UT) END;
end; (* de prins *)



end.