unit Ggraphic;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  tipos, venmenu, ppgraph, Grids, ExtCtrls;
{ENLACE /control}

type
  TFGgraphic = class(TForm)
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ListBox2: TListBox;
    Label3: TLabel;
    Label4: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StringGrid1: TStringGrid;
    Button4: TButton;
    StringGrid2: TStringGrid;
    Shape1: TShape;
    Shape2: TShape;
    Shape3: TShape;
    Shape4: TShape;
    Shape5: TShape;
    Shape6: TShape;
    Shape7: TShape;
    Shape8: TShape;
    Shape9: TShape;
    Shape10: TShape;
    Shape11: TShape;
    Shape12: TShape;
    Shape13: TShape;
    Shape14: TShape;
    Label5: TLabel;
    Button5: TButton;
    Button6: TButton;
    Shape15: TShape;
    Shape16: TShape;
    Label6: TLabel;
    ColorDialog1: TColorDialog;
    Edit1: TEdit;
    Label7: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    procedure VarDepSelected(Sender: TObject);
    procedure SacarDepens(Sender: TObject);
    procedure SiAcepta(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CambiaColor(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StringGrid2KeyPress(Sender: TObject; var Key: Char);
    procedure RecogeTama(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid1Exit(Sender: TObject);
    procedure StringGrid2SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure StringGrid2Exit(Sender: TObject);
  private
    { Private declarations }
    procedure LimpiarGrid(Sender: TStringGrid);
  public
    { Public declarations }
  end;

  TpTGgraph = ^TGgraph;
  TGgraph = record
              vi: integer;
              Gmaxv,Gminv:array[1..15] of real;
              vd:array[1..14] of integer;
            end;

  procedure ggraph;

var
  FGgraphic: TFGgraphic;
  SiHayVarDeps, SacaVarDep, TerminaDatos, ListaConfiguracion,
  TerminaGraficos, NuevoGrafico: boolean;
  pTGgraph: TpTGgraph;
  ListaGgraph: TList;
  Omaxv,Ominv:array[1..15] of real;
  _maxGraphicsG: integer;
  _windowsizeG: boolean;  _windowHeightG, _windowWidthG: integer;
  OrdenColor1: integer;
  LastCol1, LastRow1, LastCol2, LastRow2: integer; // SetEditMode

implementation

{$R *.DFM}

procedure ggraph;

label 1, 2;      //31.5.2001
var filena:string; fil:text; nomvar,nume:string[50];
    nc,iGG,iTGG,l,u,j1,nd{,vi,kx,ky,xin,yin,ks,xmax,ymax,xmin,ymin,kgr,
    dx,dy,linx,detect,grm,ptext,nvd,nvd1,ndx,k,jgr,jgr1,
    nex,ney,nent,ndecx,sig,ejey,kp,vda,vd1}:integer;
    {n:array[1..2] of integer; }
    xx{,ri,TC,mx,maxvi,minvi}:real;
    bc,esvar:boolean; def:char; Gch: word;
    nvari,nime,nom:string[50];
    nvar:array[1..15] of string[50];
    {vd,}lgr,ndy,coly,ndecy:array[1..14] of integer;
    vari,{Gmaxv,Gminv,}Gx:array[1..15] of real;
    Gcol:array[1..15] of word;
    {color:string[12];}
    Gcoderr: integer;
    Encontro: boolean;
    gg_buff: string;
 const tabcol:array[0..16] of TColor=(clBLACK,clAqua,clGREEN,clBlue,
  clRED,clFuchsia,clYellow,clSilver,clWhite,clOlive,clNavy,
  clLime,clTeal,clPurple,clMaroon,clLtGray,clDkGray);

begin
  {SiHayVarDeps:=false; SacaVarDep:=false;
  TerminaDatos:=false; ListaConfiguracion:=false;
  TerminaGraficos:=false;  NuevoGrafico:=false;}
  _maxGraphicsG:=_maxGraphics;
  _windowsizeG:=_windowsize;  _windowsize:=true;
  _windowHeightG:=WindowHeight; windowHeight:=400;
  _windowWidthG:=windowWidth;   windowWidth:=400;
  if _maxGraphics <> 0 then CerrarGraficos;
  FGgraphic.Show;
 (*Conseguir nombre de archivo,abrirlo y leer nombres de variables*)
 with FGgraphic do begin
 repeat
  if not OpenDialog1.Execute then goto 1;
  filena:=OpenDialog1.Filename;
  Gch:=mrCancel;
  assignFile(fil,filena);
{$I-}
  reset(fil);
{$I+}
  if IORESULT <>0 then
  begin Gch:=MessageDlg('File not found. (Abort or Retry) ',mtError,
        [mbCancel,mbRetry],0);
   if Gch = mrCancel then goto 1;
  end;
 until Gch=mrCancel;

 OrdenColor1:=Shape1.ComponentIndex;
 closeFile(fil); reset(fil);
 nc:=0; bc:=false;
 repeat
  readln(fil,nomvar);  (*leer nombres de variables hasta # *)
  if {ord(}nomvar[1]{)}<> '#' {35} then
   begin nc:=nc+1; nvar[nc]:=nomvar;   end else bc:=true;
 until bc;
 Button6.Enabled:=false;
 {ListBox1.Clear;  ListBox2.Clear;  ComboBox1.Clear;
 LimpiarGrid(StringGrid1);    LimpiarGrid(StringGrid2);
 ListBox1.Invalidate;  ListBox2.Invalidate;  ComboBox1.Invalidate;
 StringGrid1.Invalidate;  StringGrid2.Invalidate; }
 for iGG:=1 to nc do begin ListBox1.Items.Add(nvar[iGG]+'  ');
                           ComboBox1.Items.Add(nvar[iGG]+'  ');
                     end;
 ComboBox1.ItemIndex:=0;
 (*hallar minimos y maximos de las variables*)
  for iGG:=1 to nc do begin Omaxv[iGG]:=-1.7e38; Ominv[iGG]:=1.7e38 end;
  nd:=0;  bc:=false;
  repeat
    nd:=nd+1;
    iGG:=1;
    //for iGG:=1 to nc do
    while (iGG <= nc) and not bc do
     begin
      read(fil,xx);
      if not eof(fil) then
       begin
        if xx>Omaxv[iGG] then Omaxv[iGG]:=xx;
        if xx<Ominv[iGG] then Ominv[iGG]:=xx;
        iGG:=iGG+1;
       end else bc:=true;
     end;
     {if not eof(fil) then readln;}
  until bc;
  if iGG < nc then Dec(nd);
  nd:=nd-1;
  str(nd,gg_buff);
  Label1.Caption:='Number of Data lines '+gg_buff;
  _maxGraphics:=0;
  ListaGgraph:=TList.Create;  ListaGgraph.Capacity:=1000;
repeat   {hasta not NewGraphic}
 Button6.Enabled:=false; {NewGraphic}  Button4.Enabled:=false; {Apply}
 ListBox2.Enabled:=true;  ComboBox1.Enabled:=true;  Edit1.Enabled:=false;
 Edit2.Text:=IntToStr(WindowHeight);   Edit3.Text:=IntToStr(WindowWidth);
 SiHayVarDeps:=false; SacaVarDep:=false;
 TerminaDatos:=false; ListaConfiguracion:=false;
 TerminaGraficos:=false;  NuevoGrafico:=false;

 ListBox2.Clear;
 LimpiarGrid(StringGrid1);    LimpiarGrid(StringGrid2);
 ListBox2.Invalidate;
 StringGrid1.Invalidate;  StringGrid2.Invalidate;

 New(pTGgraph);  ListaGgraph.Add(pTGgraph);
 with pTGgraph^ do begin
  (*pedir variable independiente extremos formato tips color*)
  vi:=1; ComboBox1.ItemIndex:=0; Button2.Enabled:=false; {Eliminar sel}
  ListBox2.Clear;  ListBox2.Invalidate;
  for iGG:=1 to nc do
     begin
        Gmaxv[iGG]:=Omaxv[iGG];  Gminv[iGG]:=Ominv[iGG];
     end;
  (*ver si se usan valores de defecto*******************)
  { Delphi: ver despues

    ndx:=10;          (*valores de defecto*)

    (******if***************)
    repeat
     str(ndx,gg_buff);
     writeln('Number of divisions of axis indep.variable '+gg_buff);
     write_pan('C to continue/other to modify '); ch:=upcase(readkey_pan);
     writeln_pan('');
     if ch<>'C' then
     begin
      write_pan('Number of divisions must be ');
      readln_pan(gg_buff); val(gg_buff,ndx,gg_err);
      readln(ndx);
     end;
    until ch='C'; writeln_pan('');
    (*********end****)

   }
  (*Variables dependientes*)

  repeat
   Application.ProcessMessages;
  until SiHayVarDeps or TerminaGraficos;
  if TerminaGraficos then goto 2;      //Delphi 31.5.2001 goto 1
  for iGG:=0 to ListBox1.Items.Count-1 do
  begin
   if ListBox1.Selected[iGG] then
      ListBox2.Items.Add(ListBox1.Items.Strings[iGG])
  end;
  if ListBox2.Items.Count = 0 then goto 2; //GGraph solo 14.12.2001
  Button2.Enabled:=true;
  repeat
   repeat
    Application.ProcessMessages;
   until TerminaDatos or SacaVarDep or TerminaGraficos;
   if SacaVarDep and (ListBox2.ItemIndex<>-1) then
   begin SacaVarDep:=false; iGG:=ListBox2.ItemIndex;
         ListBox2.Items.Delete(iGG);
         ListBox2.Invalidate;
   end;
   if TerminaDatos then
     if ListBox2.Items.Count > 14 then
        begin MessageDlg('More than 14 dependent variables',mtError,[mbOK],0);
              TerminaDatos:=false;
        end;
 until TerminaDatos or TerminaGraficos;
 if TerminaGraficos then goto 2;  //31.5.2001 goto 1
// ShowMessage('Variable Independiente: '+nvar[vi]);
Button4.Enabled:=true; {Apply}
ListBox2.Enabled:=false;  ComboBox1.Enabled:=false;
StringGrid1.EditorMode:=true;  StringGrid2.EditorMode:=true;
_Comenzando:=true; CreaUnGrafico; // Incrementa _maxGraphics
Edit1.Text:='Graphic '+IntToStr(_maxGraphics);
Edit1.Enabled:=true;

(*saltar nombres de variables y # *)
reset(fil); for iGG:=1 to nc+1 do  readln(fil,nomvar);
{with _Grafico[1] do
begin }
(*TRAZADO DE LOS GRAFICOS*)
   (*poner puntos iniciales *)
  for iGG:=1 to nc do read(fil,Gx[iGG]); (*leer primera linea de datos*)
//  ShowMessage('Leyo primera fila');

 for j1:=1 to ListBox2.Items.Count do
 begin
  iGG:=1; Encontro:=false;
  while (iGG<=ListBox1.Items.Count) and not Encontro do
  begin
    if ListBox2.Items[j1-1] = ListBox1.Items[iGG-1] then Encontro:=true
    else Inc(iGG);
  end;
  vd[j1+1]:=iGG;
  TShape(Components[Shape1.ComponentIndex+j1-1]).Brush.Color:=tabcol[j1];
  {Poner datos para permitir configurar}
  StringGrid1.Cells[0,j1]:= FloatToStrF(Gminv[iGG],ffGeneral,12,2);
  StringGrid1.Cells[1,j1]:= FloatToStrF(Gmaxv[iGG],ffGeneral,12,2);
  StringGrid1.Cells[2,j1]:= '1'; // Ancho de lnea
  with _Grafico[_maxGraphics] do begin
       _fgr1[j1+1]:=8;_fgr2[j1+1]:=1;  _nomv[j1+1]:=nvar[iGG];
        colv[j1+1]:=tabcol[j1];{alcanzan colores porque no hay mas de 14 vars}
        _x[j1+1]:=Gx[iGG];
        _minv[j1+1]:=Gminv[iGG]; _maxv[j1+1]:=Gmaxv[iGG];
  end;

  {_Grafico[1].x[j1+1]:=x[iGG];
  _Grafico[1].minv[j1+1]:=minv[iGG]; _Grafico[1].maxv[j1+1]:=maxv[iGG]; }
 end;  {for j1}
 (*with _Grafico[_maxGraphics] do begin
      _minv[1]:=Gminv[vi]; _maxv[1]:=Gmaxv[vi];
      for j1:=1 to 15 do linewidth[j1]:=1; PorGgraphic:=true;
 end; *)
 StringGrid2.Cells[0,0]:= FloatToStrF(Gminv[vi],ffGeneral,12,2);
 StringGrid2.Cells[1,0]:= FloatToStrF(Gmaxv[vi],ffGeneral,12,2);
 StringGrid2.Cells[2,0]:= '1'; // Ancho de lnea
 LastCol1:=-1; LastCol2:=-1;   LastRow1:=-1; LastRow2:=-1;
 with _Grafico[_maxGraphics] do begin
      for j1:=1 to 15 do linewidth[j1]:=1;
      PorGgraphic:=true;
 end;
//ShowMessage('Puso Minimos y Maximos');
 repeat
    Application.ProcessMessages;
 until ListaConfiguracion or TerminaGraficos;
 with _Grafico[_maxGraphics] do begin
      _minv[1]:=Gminv[vi]; _maxv[1]:=Gmaxv[vi];
 end;
 if TerminaGraficos then goto 2;  //31.5.2001 goto 1
//ShowMessage('Va al grafico');
  with _Grafico[_maxGraphics] do begin
    _tg:='X'; nv:=1+ListBox2.Items.Count;
    col:=Shape16.Brush.Color {BLACK}; _titul:=Edit1.Text;
    _fgr1[1]:=8;_fgr2[1]:=1;  _nomv[1]:=nvar[vi];
    colv[1]:=Shape15.Brush.Color {WHITE};
    _x[1]:=Gx[vi];

  end;
  _Grafico[_maxGraphics]._graph;
 end; {With pTGraphh ^}
 Button6.Enabled:=true;  NuevoGrafico:=false;
 repeat
   Application.ProcessMessages;
 until NuevoGrafico xor TerminaGraficos;
until not NuevoGrafico;

 end; {with FGraphic}
 FGgraphic.Visible:=false;

 for iGG:=1 to nd-1 do  {Para cada registro del archivo}
 begin
    for j1:=1 to nc do read(fil,Gx[j1]);
    for iTGG:=1 to _maxGraphics do begin
    pTGgraph:=TptGgraph(ListaGGraph.Items[iTGG-1]);
     with {TptGgraph(ListaGGraph.Items[iTGG-1])} pTGgraph^ do begin
        _Grafico[iTGG]._x[1]:=Gx[vi];
        for j1:=1 to _Grafico[iTGG].nv-1 {ListBox2.Items.Count} do
            _Grafico[iTGG]._x[j1+1]:=Gx[vd[j1+1]];
     end;  {with}
        _Grafico[iTGG]._graph;
     end; {for iTGG}
 end; {for iGG}
 2: CloseFile(fil);    //31.5.2001

 1: if _maxGraphics <> 0 then CerrarGraficos;
    _maxGraphics:=_maxGraphicsG; // Restaura numero de graficos
    _windowsize:=_windowsizeG;
    windowHeight:=_windowHeightG;  windowWidth:=_windowWidthG;
    ListaGgraph.Free;
    with FGgraphic do begin
      ListBox1.Clear; ListBox2.Clear; ComboBox1.Clear;
      ListBox1.Invalidate; ListBox2.Invalidate; ComboBox1.Invalidate;
      LimpiarGrid(StringGrid1);    LimpiarGrid(StringGrid2);
      StringGrid1.Invalidate;  StringGrid2.Invalidate;
    end;
    FGgraphic.Close;
end;

procedure TFGgraphic.LimpiarGrid(Sender: TStringGrid);
var aCol, aRow: integer;
begin
 with Sender do
  for aCol:=0 to ColCount-1 do
   for aRow:=FixedRows to RowCount-1 do Cells[aCol,aRow]:=' ';
end;

procedure TFGgraphic.VarDepSelected(Sender: TObject);
begin
  SiHayVarDeps:=true;
end;

procedure TFGgraphic.SacarDepens(Sender: TObject);
begin
  SacaVarDep:=true;
end;

procedure TFGgraphic.SiAcepta(Sender: TObject);
begin
  TerminaDatos:=true;
end;

procedure TFGgraphic.ComboBox1Change(Sender: TObject);
begin
  pTGgraph^.vi:=ComboBox1.ItemIndex+1;
end;


procedure TFGgraphic.Button4Click(Sender: TObject);
begin
  ListaConfiguracion:=true;
end;

procedure TFGgraphic.StringGrid1KeyPress(Sender: TObject; var Key: Char);
var Z, ZO: real; P: integer; coderr: integer;
procedure ErrorMaxMin(const Mensaje: string);
begin MessageDlg(Mensaje,mtError,[mbOK],0);
      coderr:=1;
      with StringGrid1 do
       if Col < 2 then
          Cells[Col,Row]:=FloatToStrF(ZO,ffGeneral,12,2)
       else Cells[Col,Row]:='1'; {ancho lnea 1 por defecto}
end;
begin
  if Key = #13 then
  with StringGrid1 do
   with pTGgraph^ do begin
    if Col = 2 then val(Cells[Col,Row],P,coderr)
    else begin
           if Col=0 then ZO:=Gminv[vd[Row+1]]
           else          ZO:=Gmaxv[vd[Row+1]];
           val(Cells[Col,Row],Z,coderr);
         end;
  if coderr<>0 then ErrorMaxMin('Invalid number')
  else begin
     if Col = 0 then {columna de minimos}
       if Z > Gminv[vd[Row+1]] then ErrorMaxMin('Minimum > current minimum')
       else   begin Gminv[vd[Row+1]]:=Z;
                    _Grafico[_MaxGraphics]._minv[vd[Row+1]]:=Z; end
     else if Col = 1 then
       if Z < Gmaxv[vd[Row+1]] then ErrorMaxMin('Maximum < current maximum')
       else   begin Gmaxv[vd[Row+1]]:=Z;
                    _Grafico[_MaxGraphics]._maxv[vd[Row+1]]:=Z; end
     else if (P<1) or (P>4) then ErrorMaxMin('Line with must be 1..4')
          else _Grafico[_MaxGraphics].linewidth[vd[Row+1]]:=P;
     if coderr=0 then
     if Col < 2 then Cells[Col,Row]:=FloatToStrF(Z,ffGeneral,12,2)
     else            Cells[Col,Row]:=IntToStr(P);
  end;
  end;
end;



procedure TFGgraphic.FormActivate(Sender: TObject);
begin
  with StringGrid1 do begin
       Cells[0,0]:='Minimum';   Cells[1,0]:='Maximum';  Cells[2,0]:='Line';
  end;
end;

procedure TFGgraphic.Button5Click(Sender: TObject);
begin
  TerminaGraficos:=true;
end;

procedure TFGgraphic.Button6Click(Sender: TObject);
begin  {New Graphic}
  NuevoGrafico:=true;
end;

procedure TFGgraphic.CambiaColor(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var Orden: integer;
begin

  Orden:=TShape(Sender).ComponentIndex - OrdenColor1 + 1;
  if Orden <= ListBox2.Items.Count then
  begin
    if ColorDialog1.Execute then
    begin
       _Grafico[_maxGraphics].colv[pTGgraph^.vd[Orden+1]]:=
        ColorDialog1.Color;
       TShape(Sender).Brush.Color:=ColorDialog1.Color;
    end;
  end else
  if Sender = Shape15 then
    if ColorDialog1.Execute then
      begin
       _Grafico[_maxGraphics].colv[1]:=ColorDialog1.Color;
       TShape(Sender).Brush.Color:=ColorDialog1.Color;
      end else else
  if Sender = Shape16 then
    if ColorDialog1.Execute then
      begin
       _Grafico[_maxGraphics].col:=ColorDialog1.Color;
       TShape(Sender).Brush.Color:=ColorDialog1.Color;
      end;
end;


procedure TFGgraphic.StringGrid2KeyPress(Sender: TObject; var Key: Char);
var Z, ZO: real; coderr: integer;
procedure ErrormaxMin(const Mensaje: string);
begin MessageDlg(Mensaje,mtError,[mbOK],0);
      coderr:=1;
      with StringGrid2 do
       Cells[Col,Row]:=FloatToStrF(ZO,ffGeneral,12,2);
end;
begin
  if Key = #13 then
  with StringGrid2 do
   with pTGgraph^ do begin
    if Col=0 then ZO:=Gminv[vi] else ZO:=Gmaxv[vi];
    val(Cells[Col,Row],Z,coderr);
  if coderr<>0 then ErrorMaxMin('Invalid number')
  else begin
     if Col = 0 then {columna de minimos}
       if Z > Gminv[vi] then ErrorMaxMin('Minimum > current minimum')
       else   begin Gminv[vi]:=Z;
                    _Grafico[_MaxGraphics]._minv[1]:=Z; end
     else
       if Z < Gmaxv[vi] then ErrorMaxMin('Maximum < current maximum')
       else   begin Gmaxv[vi]:=Z;
                    _Grafico[_MaxGraphics]._maxv[1]:=Z; end;
     if coderr=0 then Cells[Col,Row]:=FloatToStrF(Z,ffGeneral,12,2);
  end;
  end;
end;

procedure TFGgraphic.RecogeTama(Sender: TObject);
var coderr: integer;  tama: integer;
begin
  val(TEdit(Sender).Text,tama,coderr);
  if coderr=0 then
   if (tama > 0) then
    if Sender = Edit2 then
     if tama <= Screen.Height then WindowHeight:=tama else else
     if tama <= Screen.Width  then WindowWidth:=tama;
end;


procedure TFGgraphic.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var Z, ZO: real; P: integer; Co, Ro, coderr: integer;
procedure ErrorMaxMin(const Mensaje: string);
begin MessageDlg(Mensaje,mtError,[mbOK],0);
      coderr:=1;
      with StringGrid1 do
       if Co < 2 then
          Cells[Co,Ro]:=FloatToStrF(ZO,ffGeneral,12,2)
       else Cells[Co,Ro]:='1'; {ancho lnea 1 por defecto}
end;
begin
{ShowMessage(IntToStr(LastCol1)+' ACol: '+IntToStr(ACol)+
            ' '+IntToStr(LastRow1)+' ARow: '+IntToStr(ARow));}
  if (LastCol1<>ACol) or (LastRow1<>ARow) then
    if LastCol1=-1 then begin LastCol1:=ACol;  LastRow1:=ARow; end
    else
      {if LastValue1<>StringGrid1.Cells[LastCol1,LastRow1] then}
    begin
        Co:=LastCol1;  Ro:=LastRow1;
        LastCol1:=ACol;  LastRow1:=ARow;
{ShowMessage('Cambiando: '+IntToStr(Co)+' ACol: '+IntToStr(ACol)+
            ' '+IntToStr(Ro)+' ARow: '+IntToStr(ARow));}
     with StringGrid1 do
      with pTGgraph^ do
      begin
        if Co = 2 then val(Cells[Co,Ro],P,coderr)
        else begin
               if Co=0 then ZO:=Gminv[vd[Ro+1]]
               else         ZO:=Gmaxv[vd[Ro+1]];
               val(Cells[Co,Ro],Z,coderr);
             end;
        if coderr<>0 then ErrorMaxMin('Invalid number')
        else
        begin
          if Co = 0 then {columna de minimos}
          if Z > Gminv[vd[Ro+1]] then ErrorMaxMin('Minimum > current minimum')
          else   begin Gminv[vd[Ro+1]]:=Z;
                    _Grafico[_MaxGraphics]._minv[vd[Ro+1]]:=Z; end
          else if Co = 1 then
          if Z < Gmaxv[vd[Ro+1]] then ErrorMaxMin('Maximum < current maximum')
          else   begin Gmaxv[vd[Ro+1]]:=Z;
                    _Grafico[_MaxGraphics]._maxv[vd[Ro+1]]:=Z; end
          else if (P<1) or (P>4) then ErrorMaxMin('Line with must be 1..4')
          else _Grafico[_MaxGraphics].linewidth[vd[Ro+1]]:=P;
          if coderr=0 then
          if Co < 2 then Cells[Co,Ro]:=FloatToStrF(Z,ffGeneral,12,2)
          else           Cells[Co,Ro]:=IntToStr(P);
        end;
      end;
    end;
end;

procedure TFGgraphic.StringGrid1Exit(Sender: TObject);
var ARow: integer;
begin
  if LastCol1<>-1 then
  if LastRow1=1 then ARow:=2 else ARow:=1;
  StringGrid1SetEditText(Sender,LastCol1,ARow,'');
end;

procedure TFGgraphic.StringGrid2SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
var Z, ZO: real; Co, Ro, coderr: integer;
procedure ErrorMaxMin(const Mensaje: string);
begin MessageDlg(Mensaje,mtError,[mbOK],0);
      coderr:=1;
      with StringGrid2 do
          Cells[Co,Ro]:=FloatToStrF(ZO,ffGeneral,12,2);
end;
begin
  if (LastCol2<>ACol) then
    if LastCol2=-1 then LastCol2:=ACol
    else
    begin
        Co:=LastCol2;  Ro:=0;
        LastCol2:=ACol;
     with StringGrid2 do
      with pTGgraph^ do
      begin
               if Co=0 then ZO:=Gminv[vi]
               else         ZO:=Gmaxv[vi];
               val(Cells[Co,Ro],Z,coderr);
        if coderr<>0 then ErrorMaxMin('Invalid number')
        else
        begin
          if Co = 0 then {columna de minimos}
          if Z > Gminv[vi] then ErrorMaxMin('Minimum > current minimum')
          else   begin Gminv[vi]:=Z;
                    _Grafico[_MaxGraphics]._minv[vi]:=Z; end
          else if Co = 1 then
          if Z < Gmaxv[vi] then ErrorMaxMin('Maximum < current maximum')
          else   begin Gmaxv[vi]:=Z;
                    _Grafico[_MaxGraphics]._maxv[vi]:=Z; end;
          if coderr=0 then
             Cells[Co,Ro]:=FloatToStrF(Z,ffGeneral,12,2)
        end;
      end;
    end;
end;

procedure TFGgraphic.StringGrid2Exit(Sender: TObject);
var ACol: integer;
begin
  if LastCol2<>-1 then ACol:=1-LastCol2;
  {if LastCol2=1 then ACol:=0 else ACol:=1; }
  StringGrid2SetEditText(Sender,ACol,0,'');
end;

end.
