unit inpout;  (*procedimientos de entrada y salida*)
interface
uses Dialogs, Controls, SysUtils, tipos, uGlMemo, wdgraph, uPresen,
uPresen2;
{ENLACE /control}

type str80=string[80]; var ch:char;
type _arreal=array[1..1] of real; _arrealptr=^_arreal;
var _par:_arrealptr; _countlin:word;

type _arinte=array[1..1] of integer; _arinteptr=^_arinte;
var _pai:_arinteptr;  _ss:str80; _ke:integer;
{d95}  _AuxF: text; _AuxFN: string;

procedure _Presenta;
procedure _InitMemos;
procedure _WinPause;
procedure _WinMensaje(Mensa: string);
procedure _ModoInterrupcion(Modo: boolean);
procedure _CloseGraph;
procedure _ClearDevice;
procedure _WarningDlg(s: string);
procedure _ErrorDlg(s: string);
procedure _inss(var z:str80;var u:text;b:boolean;f1:integer; tit:str80);
procedure _ress(var z:str80;var u:text;b:boolean;f1:integer; tit:str80);
procedure _insr(var z:real;var u:text;b:boolean; f1,f2:integer;tit:str80);
procedure _insi(var z:integer;var u:text;b:boolean; f1:integer;tit:str80);
procedure _insl(var z:longint;var u:text;b:boolean; f1:integer;tit:str80);
procedure _resr(var z:real;var u:text;b:boolean;f1,f2:integer;tit:str80);
procedure _resi(var z:integer;var u:text;b:boolean;f1:integer;tit:str80);
procedure _inar(_p:_arrealptr;var u:text;b:boolean; f1,f2:integer;
               in1,in2:integer;tit:str80);
procedure _inai(_p:_arinteptr;var u:text;b:boolean; f1:integer;
               in1,in2:integer;tit:str80);    (****)
procedure _rear(_p:_arrealptr;var u:text;b:boolean; f1,f2:integer;
               in1,in2:integer;tit:str80);
procedure _reai(_p:_arinteptr;var u:text;b:boolean; f1:integer;
               in1,in2:integer;tit:str80);    (***)
procedure _BorraTemporalFiles;  //Delphi 1.6.2001

implementation

procedure _Presenta;
begin Presenta; end;

procedure _InitMemos;
begin
  _BorraTemporalFiles;  //Delphi 1.6.2001
  InitMemos;
end;

procedure _WinPause;
begin
   Continua;
end;

procedure _WinMensaje(Mensa: string);
begin UnMensaje(Mensa); end;

procedure _ModoInterrupcion(Modo: boolean);
begin ModoInterrupcion(Modo);  end;

procedure _CloseGraph;
begin CloseGraph; end;

procedure _ClearDevice;
begin ClearDevice; end;

procedure _WarningDlg(s: string);
begin  MessageDlg(s,mtWarning,[mbOK],0); end;

procedure _ErrorDlg(s: string);
begin  MessageDlg(s,mtError,[mbOK],0); end;

procedure readr(var z:real); (*leer real*)
begin
 {dp} repeat
 {dp readln(_ss);} _ss:=InputBox('DATA','Enter real value','0'); {dp}
 val(_ss,z,_ke);
 if _ke<>0 then  {writeln} _ErrorDlg('Invalid character ' + _ss[_ke]);
 until _ke=0;
end;

procedure readi(var z:integer); (*leer entero*)
begin
 {dp} repeat
 {dp readln(_ss);} _ss:=InputBox('DATA','Enter integer value','0'); {dp}
 val(_ss,z,_ke);
 if _ke<>0 then  {writeln}_ErrorDlg('Invalid character ' + _ss[_ke]);
 until _ke=0;
end;

procedure readar(_p:_arrealptr; k:integer); (*leer arreglo reales*)
var sind: string[10];
begin
 {dp} str(k:4,sind);
 {dp} repeat
 {dp readln(_ss);}
 _ss:=InputBox('DATA','Enter real value for element '+sind,'0'); {dp}
 val(_ss,_p^[k],_ke);
 if _ke<>0 then  {writeln} _ErrorDlg('Invalid character ' + _ss[_ke]);
 until _ke=0;
end;

procedure readai(_p:_arinteptr; k:integer); (*leer arreglo enteros*)
var sind: string[5];
begin
 {dp} str(k:4,sind);
 {dp} repeat
 {dp readln(_ss);}
 _ss:=InputBox('DATA','Enter integer value for element '+sind,'0'); {dp}
 val(_ss,_p^[k],_ke);
 if _ke<>0 then  {writeln} _ErrorDlg('Invalid character ' + _ss[_ke]);
 until _ke=0;
end;


procedure readl(var z:longint); (*leer entero*)
begin
 {dp} repeat
 {dp readln(_ss);} _ss:=InputBox('DATA','Enter long integer value','0'); {dp}
 val(_ss,z,_ke);
 if _ke<>0 then  {writeln} _ErrorDlg('Invalid character ' + _ss[_ke]);
 until _ke=0;
end;

procedure _inss(var z:str80;var u:text;b:boolean; f1:integer; tit:str80);
begin
 {writeln;
 writeln(tit,'  ',z:f1);
 writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin write('New value of '); write(tit,' '); readln(z) end;
until  ch='C';
writeln; }
 z:=InputBox('Confirm or modify:',tit,copy(z,1,f1));

end;

procedure _ress(var z:str80;var u:text;b:boolean; f1:integer; tit:str80);
begin
{d95
 writeln;
 writeln(tit,' ', z:f1,'  ');
 if b then
  begin }
   writeln(u);
   writeln(u,tit,' ', z:f1,'  ');
  {d95 16.5.2001 close(u); VerArchivoSalida(_nomars); Append(u);}
 { end;
 ch:=readkey; _WinPause; }
end;

procedure _insr(var z:real; var u:text;b:boolean;f1,f2:integer;tit:str80);
var sreal, srealt: string[25]; zt: real;
begin

{repeat
 writeln;
 write(tit,'  ');}
 if (f1>0) and (f2>=0) then {writeln} str(z:f1:f2,sreal)
  else if (f1>0) and (f2<0) then {writeln} str(z:f1,sreal)
  else if (f1<0) and (f2<0) then {writeln} str(z,sreal);
 {writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin
   repeat
    begin write('New value of '); write(tit,' '); readr(z) end;
   until _ke=0;
  end;
until  ch='C';
writeln;     }
 srealt:=InputBox('Confirm or modify:',tit,sreal);
 repeat
   _ke:=0;
   if (sreal<>srealt) then
   begin
     val(srealt,zt,_ke);
     if _ke<>0 then
     begin {writeln} _ErrorDlg('Invalid input');
           srealt:=InputBox('Confirm or change data',tit,srealt);
     end
     else z:=zt;
   end;
 until _ke=0;

end;

procedure _insi(var z:integer;var u:text;b:boolean; f1:integer;tit:str80);
var sint, sintt: string[25]; zt: integer;
begin
{writeln;
repeat
 write(tit,'  '); }
 if (f1>0) then {writeln} str(z:f1,sint)
  else {writeln} str(z,sint);
 {writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin
   repeat
    begin write('New value of '); write(tit,' '); readi(z) end;
   until _ke=0;
  end;
until  ch='C';
writeln;  }
sintt:=InputBox('Confirm or modify:',tit,sint);
 repeat
   _ke:=0;
   if (sint<>sintt) then
   begin
     val(sintt,zt,_ke);
     if _ke<>0 then
     begin {writeln} _ErrorDlg('Invalid input');
           sintt:=InputBox('Confirm or cange data',tit,sintt);
     end
     else z:=zt;
   end;
 until _ke=0;

end;

procedure _insl(var z:longint;var u:text;b:boolean; f1:integer;tit:str80);
var sint, sintt: string[50]; zt: longint;
begin
{writeln;
repeat
 write(tit,'  ');}
 if (f1>0) then {writeln} str(z:f1,sint)
  else {writeln} str(z,sint);
 {writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin
   repeat
    begin write('New value of '); write(tit,' '); readl(z) end;
   until _ke=0;
  end;
until  ch='C';
writeln;}

sintt:=InputBox('Confirm or modify:',tit,sint);
 repeat
   _ke:=0;
   if (sint<>sintt) then
   begin
     val(sintt,zt,_ke);
     if _ke<>0 then
     begin {writeln} _ErrorDlg('Invalid input');
           sintt:=InputBox('Confirm or change data',tit,sintt);
     end
     else z:=zt;
   end;
 until _ke=0;

end;

procedure _resr(var z:real;var u:text;b:boolean;f1,f2:integer;tit:str80);
begin
{d95
 writeln;
 write(tit,'  ');
 if b then
  begin }
   writeln(u);
   write(u,tit,'  ');
{  end;
 if (f1>0) and (f2>=0) then writeln(z:f1:f2)
  else if (f1>0) and (f2<0) then writeln(z:f1)
  else if (f1<0) and (f2<0) then writeln(z);
 if b then
  begin }
   if (f1>0) and (f2>0) then writeln(u,z:f1:f2)
    else if (f1>0) and (f2<0) then writeln(u,z:f1)
    else if (f1<0) and (f2<0) then writeln(u,z);
  {d95 16.5.2001 close(u); VerArchivoSalida(_nomars); Append(u);}
  {end; }
  (*IF ((_OUTF='CON') OR (_OUTF='con')) d95 AND  (WHEREY>=18)
    THEN  begin ch:=readkey; clrscr; gotoxy(1,1); end;} *)
end;

procedure _resi(var z:integer;var u:text;b:boolean;f1:integer;tit:str80);
begin
{d95
 writeln;
 write(tit,'  ');
 if b then
  begin  }
   writeln(u);
   write(u,tit,'  ');
{  end;

 if (f1>0) then writeln(z:f1)
  else writeln(z);

 if b then }
  if (f1>0) then writeln(u,z:f1)
            else writeln(u,z);
 {d95 16.5.2001 close(u); VerArchivoSalida(_nomars); Append(u);}
  {ch:=readkey;}
end;

procedure _inar(_p:_arrealptr;var u:text;b:boolean; f1,f2:integer;
               in1,in2:integer;tit:str80);
var ff,km,k,ki,j:integer; modificar: word; sind, sreal: string[25];

begin
{d95} _AuxFN:='$CON4';
      AssignFile(_AuxF,_AuxFN);
{d95 se muestran los datos escritos a AuxF en una ventana}
repeat
 Rewrite(_AuxF);
 writeln(_AuxF);
 writeln(_AuxF,tit,'  ');
 if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff;
 ki:=in1;
 while ki<=in2 do
  begin
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(_AuxF,k:f1);k:=k+1; j:=j+1 end;
   writeln(_AuxF);
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     if (f1>0) and (f2>0) then write(_AuxF,_p^[k]:f1:f2)
      else if (f1>0) and (f2<0) then write(_AuxF,_p^[k]:f1)
      else if (f1<0) and (f2<0) then write(_AuxF,_p^[k]);
     k:=k+1; j:=j+1
    end;
    writeln(_AuxF); writeln(_AuxF);
    ki:=k;
    Close(_AuxF);
    VerArchivoSalida(_AuxFN);
  end;
{ writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin
   repeat
    write('Number of element to modify '); readi(k);
    if (k<in1) or (k>in2) then
     begin writeln('Subscript out of range '); _ke:=1 end;
   until _ke=0;
   repeat
    write('New value of '); write(tit,' ',k,' '); readar(_p,k) ;
   until _ke=0
  end;
until  ch='C'; }
   modificar:=MessageDlg('Modify any element ?',mtConfirmation,
                         [mbYes, mbNo],0);
   if modificar=mrYes then
   begin _ke:=0;
     repeat
       sind:=InputBox('Element index','Enter integer value',' '); {dp}
       val(sind,k,_ke);
       if _ke<>0 then  {writeln} _ErrorDlg('Invalid input');
     until (_ke=0) and ((k>=in1) and (k<=in2));
     repeat
       sreal:=InputBox('Element '+sind,'Enter new real value:',' ');
       val(sreal,_p^[k],_ke);
       if _ke<>0 then  {writeln} _ErrorDlg('Invalid input');
     until _ke=0;
   end;
 until modificar=mrNo;

end;

procedure _inai(_p:_arinteptr;var u:text;b:boolean; f1:integer;
                in1,in2:integer;tit:str80);
var ff,km,k,ki,j:integer; modificar: word; sind, sint: string[25];
begin
{d95} _AuxFN:='$CON4';
      AssignFile(_AuxF,_AuxFN);
{d95 se muestran los datos escritos a AuxF en una ventana}
repeat
 Rewrite(_AuxF);
 writeln(_AuxF);
 writeln(_AuxF,tit,'  ');
 if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff;
 ki:=in1;
 while ki<=in2 do
  begin
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(_AuxF,k:f1);k:=k+1; j:=j+1 end;
   writeln(_AuxF);
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     if (f1>0) then write(_AuxF,_p^[k]:f1)
      else write(_AuxF,_p^[k]:8);
     k:=k+1; j:=j+1;
    end;
    writeln(_AuxF); writeln(_AuxF);
    ki:=k;
    Close(_AuxF);
    VerArchivoSalida(_AuxFN);
  end;
 {writeln('C to continue, other to Modify'); ch:=upcase(readkey);
 if ch<>'C' then
  begin
   repeat
    write('Number of element to modify '); readi(k);
    if (k<in1) or (k>in2) then
     begin writeln('Subscript out of range '); _ke:=1 end;
   until _ke=0;
   repeat
    write('New value of '); write(tit,' ',k,' '); readai(_p,k) ;
   until _ke=0;
  end;
until  ch='C'; }

   modificar:=MessageDlg('Modify any element ?',mtConfirmation,
                         [mbYes, mbNo],0);
   if modificar=mrYes then
   begin _ke:=0;
     repeat
       sind:=InputBox('Element index','Enter integer value',' '); {dp}
       val(sind,k,_ke);
       if _ke<>0 then  {writeln} _ErrorDlg('Invalid input');
     until (_ke=0) and ((k>=in1) and (k<=in2));
     repeat
       sint:=InputBox('Element '+sind,'Enter new real value:',' ');
       val(sint,_p^[k],_ke);
       if _ke<>0 then  {writeln} _ErrorDlg('Invalid input');
     until _ke=0;
   end;
 until modificar=mrNo;

end;

procedure _rear(_p:_arrealptr;var u:text;b:boolean;f1,f2:integer;
                in1,in2:integer;tit:str80);
var ff,km,k,ki,j:integer;
begin
{d95
 writeln;
 writeln(tit,'  ');
 if b then
  begin }
   writeln(u);
   writeln(u,tit,'  ');
{  end;

if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff;
 ki:=in1;
 while ki<=in2 do
  begin  k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(k:f1);k:=k+1; j:=j+1 end;
   writeln;
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     if (f1>0) and (f2>0) then write(_p^[k]:f1:f2)
      else if (f1>0) and (f2<0) then write(_p^[k]:f1)
      else if (f1<0) and (f2<0) then write(_p^[k]);
     k:=k+1; j:=j+1
    end;
    writeln; writeln;
    ki:=k
  end;
if b then
begin }
if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff;
 ki:=in1;
 while ki<=in2 do
  begin  k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(u,k:f1);k:=k+1; j:=j+1 end;
   writeln(u);
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     if (f1>0) and (f2>0) then write(u,_p^[k]:f1:f2)
      else if (f1>0) and (f2<0) then write(u,_p^[k]:f1)
      else if (f1<0) and (f2<0) then write(u,_p^[k]);
     k:=k+1; j:=j+1;
    end;
    writeln(u); writeln(u);
    ki:=k
  end;
 {d95 close(u); 16.5.2001  VerArchivoSalida(_nomars); Append(u);  }
 {end;
  ch:=readkey;}
end;

procedure _reai(_p:_arinteptr;var u:text;b:boolean;f1:integer;
               in1,in2:integer;tit:str80);
var ff,km,k,ki,j:integer;
begin
{d95
 writeln;
 writeln(tit,'  ');
 if b then
  begin }
   writeln(u);
   writeln(u,tit,'  ');
 { end;

 if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff; (*maximo de elementos por linea*)
 ki:=in1;
 while ki<=in2 do
  begin
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(k:ff) ;k:=k+1;j:=j+1 end;
   writeln;
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     write(_p^[k]:ff);
     k:=k+1; j:=j+1
    end;
    writeln; writeln;
    ki:=k
  end;

 if b then
 begin }
 if (f1>0) then ff:=f1 else ff:=8;
 km:=72 div ff;
 ki:=in1;
 while ki<=in2 do
  begin
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin write(u,k:ff);k:=k+1;j:=j+1 end;
   writeln(u); writeln(u);
   k:=ki; j:=1;
   while (j<=km) and (k<=in2) do
    begin
     write(u,_p^[k]:ff);
     k:=k+1; j:=j+1;
    end;
    writeln(u); writeln(u);
    ki:=k
  end;
  {d95 16.5.2001 close(_ars); VerArchivoSalida(_nomars); Append(u);  }
  {end;
  ch:=readkey;}
end;

procedure _BorraTemporalFiles;  //Delphi 1.6.2001
begin
if FileExists('$CON1') then DeleteFile('$CON1');
if FileExists('$CON2') then DeleteFile('$CON2');
if FileExists('$CON3') then DeleteFile('$CON3');
end;

end.