unit ug3;  (* CREA LINEAS BUSCA BLOQUES Y NODOS *)
interface
uses ug1,ug2{, crt};
procedure prdecdb; (*procesar declaraciones de tablas DBASE*)
procedure crealin; (* crea lista de lineas elimina vacias *)
procedure retit; (* pasar TITLE al MOD.EC, buscar NET      *)
procedure buside; (* buscar INIT y reconocer nodos *)
procedure prinput; (*procesar INPUT*)
procedure prreport; (*procesar REPORT*)
procedure prca; (* procesar un arreglo de constantes *)
procedure gefre(i:integer); (* gen.instr.de lib.recur.de nodo jn (parametro) *)
procedure gllc; (* generar llamadas a nodos C antecesores *)
procedure finingl; (* fin de instruccion GLIDER con asociada *)
procedure reinap; (* recoger indice de apuntador *)
procedure recap; (* recoge lista y apuntador; deja en ren3 y nomx *)
procedure acesura(jn:integer);    (* actual.estad. used anterior  *)
procedure acesurp(esif:integer); (* actual.estad. used posterior *)
procedure busel(i,jn:integer;var ren:cont;bsel:boolean);
procedure gelcaseup(i:integer);(* genera comienzo linea case up*** reg. i *)
procedure busid; (* busca identificador hasta eof a partir de pos k *)
procedure buschar(cht:char;var bch:boolean);
procedure versich(var bchar:boolean);
procedure buspoco;  (* buscar el ; y recoger lo que sigue           *)
procedure buclade; (* busca clase de declaracion en taclade *)
procedure verpar; (*ver si es palabra reservada*)

implementation

(*****************************************************PRDECDB**)
procedure prdecdb; (*procesar declaraciones de tablas DBASE*)
var arrtdb:array[1..4] of char; typ:char;
    nomb,nomb1,cnur,cnurt,cnuc,cnum,finvar:st10;
    i,j,k,num,nucamp,m:integer; cop:string[2];
begin
 (*generar constantes de valores de numeros naturales*)
 ren1:='const ';tranlin(1,true);
 for i:=1 to nmaxrdb do
  begin
   str(i,cnum); ren1:='_nu'+cnum+':integer='+cnum+';' ;
   tranlin(1,false);
  end;
 (*generar declaraciones de tipos y variables para tablas DBASE*)

 pdba:=pdb;
 while pdba<>nil do
  begin
   dimdb:=pdba^.dim;
   (*generar constantes de la tabla*)
   str(pdba^.nur,cnur); str(pdba^.nuc,cnuc);
   inser(fosa[515],'*',pdba^.nom,ren1,0); (*n_grupo:  _nv_grupo: etc.*)
   inser(ren1,'&',cnur,ren1,0);
   inser(ren1,'#',cnuc,ren1,0); tranlin(1,true);

   str(pdba^.nur,cnur); 

   (*generar declaraciones de tipos para arreglos de los campos*)
   if pdba^.prime  then

   begin
   (*iniciar lista de nombres de campos de un grupo*)
   new(pdereg); pdereg^.nom:=pdba^.nom; pdereg^.ps:=nil;
   pderega:=pdereg; pderegf:=pdereg;

   pdcdb:=pdba^.apc;  (*apuntador a primer campo dbase*)
   for i:=1 to 4 do arrtdb[i]:=' ';

   nucamp:=0; (*contador de campos*)
   while pdcdb<>nil do  (*revisar datos de campos*)
    begin   nucamp:=nucamp+1;
     if nucamp>dimdb then
      begin
       typ:=pdcdb^.tip[1];
       j:=1; while (arrtdb[j]<>' ') and (arrtdb[j]<>typ) do j:=j+1;
       if arrtdb[j]=' ' then
        begin arrtdb[j]:=typ;
         nomb:=pdba^.nom+typ;
         cnurt:='';
         if dimdb>1
          then  (*hallar subindices del tipo*)
           begin
            cop:=',';
            ptori:=pdba^.nori;    (*apuntar a lista tablas de originales*)
            while ptori<>nil do   (*para todas las originales*)
             begin
              pdadb:=pdb;         (*apuntar a primero de lista de campos*)
              while pdadb<>nil do (*buscar en lista de registros*)
               begin
                if pdadb^.nom = ptori^.nom then
                 begin
                  if ptori^.ps=nil then cop:=' ';
                  str(pdadb^.nur,cnum); cnurt:=cnurt+'1..'+cnum+cop;
                 end;
                pdadb:=pdadb^.ps;
               end;
              ptori:=ptori^.ps
             end;

           end else cnurt:='1..'+cnur;
         cnurt:='';
         if dimdb>1
          then  (*hallar subindices del tipo*)
           begin
            cop:=',';
            ptori:=pdba^.nori;    (*apuntar a lista tablas de originales*)
            while ptori<>nil do   (*para todas las originales*)
             begin
              pdadb:=pdb;         (*apuntar a primero de lista de campos*)
              while pdadb<>nil do (*buscar en lista de registros*)
               begin
                if pdadb^.nom = ptori^.nom then
                 begin
                  if ptori^.ps=nil then cop:=' ';
                  str(pdadb^.nur,cnum); cnurt:=cnurt+'1..'+cnum+cop;
                 end;
                pdadb:=pdadb^.ps;
               end;
              ptori:=ptori^.ps
             end;

           end else cnurt:='1..'+cnur;
         ren1:='type _*=array[&] of $;';
         inser(ren1,'&',cnurt,ren1,0);inser(ren1,'$',pdcdb^.tip,ren1,0);
         inser(ren1,'*',nomb,ren1,0);
         tranlin(1,true);
        end;
      end;   (*del if nucamp*)

     pdcdb:=pdcdb^.ps;
    end;
    end; (*del if prime *)

   (*generar declaraciones de tipos para arreglos de los campos*)
   if pdba^.prime then   (*solo para el primero del grupo*)
    begin
    (*iniciar lista de declaracion de registros de apuntadores a campos*)
    (*declaracion de los tipos de esas listas _ty_<tabla>=record*)
     ren1:='_ty_*=record ';            (*era 516*)
     inser(ren1,'*',pdba^.nom,ren1,0); tranlin(ptra,true);

     pdcdb:=pdba^.apc;  (*apuntador a primer campo dbase*)
     nucamp:=0; (*contador de campos*)
     while pdcdb<>nil do  (*revisar datos de campos*)
      begin   nucamp:=nucamp+1;
       if nucamp>dimdb then
        begin
        (*elementos de tipo registro de apuntadores*)
        ren1:=pdcdb^.nom+':^_'+pdba^.nom+pdcdb^.tip[1]+';';
        tranlin(ptra,false);

        end;
       pdcdb:=pdcdb^.ps;
     end;
     ren1:=fosa[21]; tranlin(ptra,false); (*end tipo reg.tipo apunt.*)

     (*generar tipo registro para leer registros de datos*)
     ren1:='_tle_'+pdba^.nom+'=record '; tranlin(1,true);
     pdcdb:=pdba^.apc;  (*apuntador a primer campo dbase*)

     while pdcdb<>nil do
      begin
       str(pdcdb^.long,cnuc); nomb:=pdcdb^.nom;
       inser(fosa[517],'*',nomb,ren1,0); inser(ren1,'&',cnuc,ren1,0);
       tranlin(1,true);
       pdcdb:=pdcdb^.ps;
      end;
     ren1:=fosa[21]; tranlin(1,true);



    (*generar area de lectura del registro para los del grupo*)
     inser('var _le_*:_tle_*;','*',pdba^.nom,ren1,0); tranlin(1,true);
    (*y el complemento del buffer del area de lectura*)
     ren1:='_cle_'+pdba^.nom+':array[1..180] of char;';tranlin(1,false);
   (*generar constantes de nombres de campos y valores de esos nombres*)
   (*guardarlos en el arbol*)
     bg:=true;
     nom:='NOM_'+pdba^.nom;  (*guardar NOM_<nom.tabla>*)
     tipo:='ARRAY'; dime:=1; stvname(true,nom);
     tipo:='INTEGER'; lc:=2;
     nom:='N_'+pdba^.nom;    stvname(true,nom);

     if pdba^.dim=1 then   (*en las tablas simples guardar valores*)
      begin                (*del primer campo y generar nombres*)
       inser(fosa[518],'*',pdba^.nom,ren1,0); inser(ren1,'&',cnur,ren1,0);
       tranlin(1,true);

 (*constantes de nombres del primer campo*)
       ptori:=pdba^.nori; cop:=', ';
       while ptori<>nil do
        begin nom:=ptori^.nom;
         ren1:=''''+nom+''''+cop; tranlin(1,false);
         bg:=true; tipo:='INTEGER'; stvname(true,nom);
         ptori:=ptori^.ps;
         if ptori^.ps=nil then cop:=');' ;
        end;

     ren1:='var ';tranlin(ptra,true);
     ptori:=pdba^.nori;  num:=0;
     while ptori<>nil do
      begin  num:=num+1; str(num,cnum);
       inser(fosa[519],'*',ptori^.nom,ren1,0); inser(ren1,'&',cnum,ren1,0);
       tranlin(1,false);
       ptori:=ptori^.ps;
       if ptori^.ps=nil then cop:=');' ;
      end
    end;  (*de generar constantes y valores de campos*)

    end; (*del if prime!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!11*)

    if not pdba^.prime then
     begin
      new(pdereg); pdereg^.nom:=pdba^.nom; pdereg^.ps:=nil;
      pderega^.ps:=pdereg; pderega:=pdereg;;
     end;
    pdba:=pdba^.ps;

    (*si se acabo el grupo escribir var <lista nombres>:_ty_<primero>*)
    if (pdba=nil) or pdba^.prime  then 
     begin
      ren1:='var '; tranlin(ptra,true);
      pdereg:=pderegf;
       while pdereg<>nil do
        begin
         if pdereg^.ps=nil then finvar:=':_ty_'+pderegf^.nom+';'
                           else finvar:=',';
         ren1:=pdereg^.nom+finvar; tranlin(ptra,false);
         pdereg:=pdereg^.ps;
        end;
      pdereg:=pderegf;
       while pdereg<>nil do (*dispose de lista de tablas*)
        begin pderega:=pdereg; pdereg:=pdereg^.ps; dispose(pderega) end
     end;
  end;     (*de la revision de tablas*)

end;

(*******************************************************CREALIN***)
procedure crealin; (* crea lista de lineas elimina vacias *)
(*d95*) var _i: integer;
(*7.12.2003*) linea: string;
(*procedure pasmay;
 var _i: integer;
BEGIN
for _i:=1 to 81 do
begin
ch:=pl^.con[_i];
if (ch>='a') and (ch<='z') then pl^.con[_i]:=upcase(ch);
end
END; *)

begin  IF W THEN BEGIN WRITELN('ENTRADA A CREALIN') ; READln(UT) END;
  nom:=''; btran:=false; im:=0;

  reset(art); ren:='';
  new(pl); plf:=pl;
  (*delphi*) for _i:=1 to 81 do ren:=ren+el; pl^.con:=ren;
  (*delphi for _i:=1 to 255 do ren:=ren+el; pl^.con:=ren;*) (*pl^.con lleno de &*)
  {7.12.2003
  readln(art,pl^.con); (*pl^.con:=pl^.con+el;*) }
  readln(art,linea); //7.12.2003
  if length(linea) > 80 then pl^.con:=copy(linea,1,80) //7.12.2003
  else                       pl^.con:=linea; //7.12.2003
  lb:=1;

  while not eof(art) and (nom<>'END.')  do
   begin pla:=pl; new(pl); pla^.pls:=pl; (*delphi*) pl^.con:=ren;
   {7.12.2003
    readln(art,pl^.con); (*delphi pl^.con:=pl^.con+el;*) }
    readln(art,linea); //7.12.2003
    if length(linea) > 80 then pl^.con:=copy(linea,1,80) //7.12.2003
    else                       pl^.con:=linea; //7.12.2003
    lb:=lb+1;
    (*MARTA 24.11.99 Eliminar caracter TAB*)
    for _i:=1 to length(pl^.con) do if ord(pl^.con[_i])=9 then pl^.con[_i]:=' ';
   (*anotar en nom los 4 primeros caracteres no blancos*)
(*LINUX*) if length(pl^.con) > 3 then
      begin k:=1;
       while pl^.con[k]=' ' do k:=k+1; (* elimina blancos *)
       (*delphi*) if (length(pl^.con)-k+1) > 3 then begin
       nom:=copy(pl^.con,k,4);
       for _i:=1 to 4 do nom[_i]:=upcase(nom[_i]);
       (*delphi*) end;
      end
   end;
if (nom<>'END.') then
 error('END. missing or misplaced');
 closeFile(art);
 pla:=pl; new(pl); pla^.pls:=pl; pl^.con:='$'; pl^.pls:=nil;
IF W THEN
  BEGIN WRITELN(' CREADAS LINEAS');
   PL:=PLF;
   WHILE PL<>NIL DO BEGIN WRITELN(PL^.CON); PL:=PL^.PLS END;
   READln(UT) END;
pl:=plf;  (* apuntar al comienzo *)
end;        (* fin del procedure crealin                            *)



(********************************************************** RETIT *)

procedure retit; (* pasar TITLE al MOD.EC, buscar NET      *)
label 1;
(*d95*) var _i: integer;
procedure rectit(var lb:integer; var ctit:boolean); label 1;
(* busca titulo y si lo hay lo pone como comentario en MOD.EC      *)
(* ctit queda false si encontro NETWORK                             *)
(* en lb queda numero ultima linea revisada                         *)
(*d95*) var _i: integer;
begin
pl:=plf; lb:=0; k:=1; recid; if berr then goto 1;
{GL2000 if nom<>'TITLE'
 then ERROR('No hay TITLE')
 else
  begin } (* hay titulo, recogerlo                                   *)
   {delete(pl^.con,m,5);} (* eliminar TITLE de linea en proceso       *)
   (*GL2000 write(modec,'(*'); writeln(modec,pl^.con);*)
   pl:=pl^.pls;
   ctit:=true; ls:=ls+1;
   while ctit and (pl^.con[1]<>'$') do
    begin lb:=lb+1; k:=1;
     {GL2000 while pl^.con[k]=' ' do k:=k+1;}
     while (k<=length(pl^.con)) and (pl^.con[k]=' ') do k:=k+1;
     (* elimina blancos *)
     {GL2000} if (length(pl^.con)-k+1) > 6 then
     begin
       nom:=copy(pl^.con,k,7); for _i:=1 to 7 do nom[_i]:=upcase(nom[_i]);
       if nom='NETWORK'  then
       begin
IF W THEN BEGIN WRITELN('SE HALLO NETWORK LB=',LB); READln(UT) END;
         lb:=lb+1; ctit:=false
       end
       {GL2000} else begin pl:=pl^.pls; ls:=ls+1 end;
       {GL2000} end
     else
     begin {GL2000 writeln(modec,pl^.con);}
      pl:=pl^.pls; ls:=ls+1 end;
     end;
    {GL2000 writeln(modec,'*)')}
1:end;      (* fin procedimiento rectit de recoger TITLE *)

begin                       (*comienza retit *)

{delphi 13.11.2000 I:=POS('.',ARCHEN);
 ASSIGN(MODEC,COPY(ARCHEN,1,I)+'PRO'); En Delphi no se confunde con main}
ASSIGN(MODEC,dirname+'PRU.PAS');
IF W THEN WRITELN(I,' ','PRU.PAS');
 rewrite(modec);
 for _i:=1 to 3 do block[_i]:=0;
 rectit(lb,ctit);
 if ctit then begin error('NETWORK missing or misplaced'); goto 1 end
         else begin lb:=lb+1; block[1]:=lb; pl:=pl^.pls end;

(* escribir encabezamiento del programa objeto *)
(*eliminar lo que sigue, se pasa a ug7 27/10/1998*)
(*for _i:=1 to 13 do writeln(modec,enca[_i]);
IF W THEN BEGIN
FOR _I:=1 TO 3 DO WRITE(' ',BLOCK[_I]);READln(UT) END;*)
1:end;  (* fin del procedure retit                                  *)




(********************************************************* BUSIDE *)
procedure buside; label 1; (* buscar INIT y reconocer nodos *)
var besunit:boolean;
(********************************************************** BUNOD *)
procedure bunod; label 1; (* si linea empi. con nombre busca nodo *)
var bnod,bloc:boolean;u:integer;

procedure busubnod(bprin:boolean); (* rec.sub.prin. o suce.*)
 begin k:=k+1; recid; (* recoger subindice *)
  (********verificar si nom variable entera o entero *****)
  if bprin then          (* recoger 1..numero ]  *)
  begin
   if nom<>'1' then bnod:=false
   else
    if (pl^.con[k]<> '.') or (pl^.con[k+1]<>'.')
     then bnod:=false
     else
      begin
       k:=k+2; recid;
       val(nom,nodpos.sub,cod);
       if cod<>0 then bnod:=false
      end
  end
  else pn^.sub:=nom;  (* poner subindice (en char) al sucesor *)

  recid;
  if ch<>']' then bnod:=false
   else begin b:=true; fi:=false; end; (* si es princ.indicar hubo sub.*)
  k:=k+1  (* el k queda despues de ] *)
 end;

function bulinod(nomnod:st10):boolean; (* busca en lista de nodos *)
                                       (* true si lo encuentra    *)
var plno:ptrno; bnha:boolean;
begin plno:=pnof; bnha:=true;
 while bnha and (plno<>nil) do
  begin if plno^.nom=nomnod then bnha:=false else plno:=plno^.pns end;
bulinod:= not bnha;
end;

begin   (* comienza bunod *)  fi:=false; u:=2; bnsub:=false;
 bloc:=false;
IF W THEN BEGIN WRITELN('BUSCA POSIBLE NODO '); READln(UT) END;
nodpos.nom:=nom;    (* recoger nombre nodo posible  *)
lb1:=lb;
nodpos.sub:=1; nodpos.tamr:=1; nodpos.reg:=false; nodpos.est:=false;
nodpos.lb:=lb; nodpos.pl:=pl; (* posicion y apuntador a la linea *)
nodpos.antc:=false; nodpos.pns:=nil; nodpos.plab:=nil;
(*si es primero de una unit (hubo MODULE) anotar numero de unit*)
if besunit or (n=0) then nodpos.uni:=numunt else nodpos.uni:=0;
besunit:=false;
IF W THEN BEGIN WRITELN('VA A PREPARAR LISTA SUCESORES'); READln(UT) END;
new(pn); pnf:=pn; (* preparar elem.lista sucesores *)
nodpos.apns:=nil; nodpos.dec:=false; (* no declarado hasta ahora *)
(* poner tipo provisional segun letra inicial *)
if nom[1] in ['G','L','I','D','E','R','C','A'] then nodpos.tipo:=nom[1]
                                       else nodpos.tipo:='O';
recid;   bnod:=true; (* buscar lo siguiente a nom inic. [ : o id ***)

IF W THEN WRITELN('BUSCA LO QUE SIGUE A NOM INICIAL ');

while (not ((ch=':') and (pl^.con[k+1]=':')) and bnod
      or (b and bnod) ) and not bloc do

begin
IF W THEN WRITELN('COMIENZA BUSQUEDA DE LO QUE SIGUE A NODO***');
 if b
  then (* posible lista sucesores o no es nodo *)
   begin

IF W THEN
 WRITELN(NOM,' ES UN POSIBLE NODO SUCESOR, PL^.CON[K+1] ',PL^.CON[K+1]);

    if nom='LABEL' then
     begin
      while ch<>';' do
       begin
        recid;      (* recoger label *)
        if b then   (* es label *)
         begin
          new(plab); plab^.pls:=nil; plab^.nom:=nom;
          if nodpos.plab=nil then nodpos.plab:=plab
                             else plaa^.pls:=plab;
          plaa:=plab;
         end;
        recid; if (ch<>',') and (ch<>';') then error('; or , expected');
        k:=k+1;
       end;  recid; (* ver que sigue a label  *)
     end
    else         (*no label posible sucesor*)
    if nom<>'VAR'
     then
      begin     (* no es lista VAR locales, posible sucesor *)
       if nodpos.apns<>nil
        then begin pna:=pn; new(pn);pna^.pns:=pn end
        else nodpos.apns:=pn ; (* si es prim.suc. lo apunta apns  *)
        pn^.nom:=nom; pn^.sub:='1';pn^.pns:=nil; (* form elem.de lis.suc.*)

        recid;   (* ver lo que sigue a ese otro nom es , o : o [ o no nodo *)
                 (* O es blanco y puede seguir LABEL o VAR 15.2.2001*)
        if b
         then
         {15.2.2001 Todavia puede ser LABEL o VAR } begin
           if (nom<>'LABEL') and (nom<>'VAR') then
           bnod:=false  (* sigue aun otro nombre !!!! ,sin , *)
         end {Fin 15.2.2001}
         else              (* sigue un simbolo           *)
          case ch of
           ',': begin k:=k+1; recid; if not b then bnod:=false
                end; (* se espera otro nodo sucesor  *)
           ':': ; (* posible terminacion *)
           '[':begin
                busubnod(false); (* posible subind. en suc. *)
                bnsub:=true; recid;  (* rec.lo sig. a ] es : o ,   *)
                if ch=',' then begin k:=k+1;recid; (*pos. sig.*)
                                if not b then bnod:=false

                               end
               end;  (* de procesar subindice; 15.2.2001 se agrego ; *)
           else bnod:=false;  (* si no es , : [] no es nodo *)
          end; (*del case*)
IF W THEN
WRITELN(' CARACTER QUE SIGUE A NOM CH ',CH,' PL^CON[K] Y SIG ', PL^.CON[K],
         PL^.CON[K+1]);
      end  (* del else no label ni lista variables locales*)
     else
     begin bloc:=true; k:=m; u:=0 end (*comienza lista de locales*)
   end   (* del then es id *)

  else (* no es id debe seguir  [ o ( o no es nodo *)
   begin
    case ch of
    '[':begin busubnod(true); (* posible sub. en principal *)
         bnsub:=true; recid;  (* recoge lo que sigue a ]  ( : o id *)
        end;
    '(':begin
         if bnsub (* si se proceso el subindice *)
          then
           begin warning('possible error en node definition');
            bnod:=false
           end
          else
           begin (* al nombre de nodo sigue ( (posible tipo) *)
            k:=k+1; recid;  (* recoger tipo *)
            (*delphi if (nom[1]>='A') and (nom[1]<='Z') and (k-m=1)*)
            if (k-m=1) and (nom[1]>='A') and (nom[1]<='Z') 
             then
              begin  (* ver si es tipo seguido de ) *)
               if nom[1] in ['G','L','I','D','E','R','C','A']
                then nodpos.tipo:=nom[1] else nodpos.tipo:='O';
      IF W THEN WRITELN('NODO TIPO ',NOM);
               recid; k:=k+1;  (* saltar posible ) *)
      IF W THEN BEGIN WRITELN('CH ',CH); READln(UT) END;
               if ch<>')' then bnod:=false; recid;(*ver que sig.a ) *)
IF W THEN WRITELN('CH Y PL^.CON[K] Y SIG ',CH,PL^.CON[K],PL^.CON[K+1]);
              end
             else bnod:=false
           end;
        end (* del caso (tipo) recogido lo que sigue a ) : o id *)
    else bnod:=false;
    end (*del case*)
   end;      (* de alternativa no id *)


end; (*del while*)


 if bnod then            (* si!! es nodo *)
  begin  nom:=nodpos.nom;
   verpar;  (*ver si es palabra reservada*)
   if bulinod(nodpos.nom) then error('duplicated node name');
   n:=n+1; new(pnoa);
   if pnof=nil then pnof:=pnoa else pnoan^.pns:=pnoa;
   pnoan:=pnoa;
   nodpos.il:=0; nodpos.el:=0; nodpos.subel:=0;
   nodpos.lb:=lb; nodpos.pl:=pl;
   if fi then u:=1; (* ajuste de posicion de sig. al ::  *)
   nodpos.nextl:=lb1; nodpos.separ:=k+u; (*linea y columna del :*)
   nodpos.nant:=0; nodpos.cnes:=' '; nodpos.pns:=nil; nodpos.apna:=nil;
   pnoa^:=nodpos;  (* pasar lo hallado a lista *)
IF W THEN BEGIN WRITELN('HALLADO NODO ',PNOA^.NOM,
        ' TIPO ',PNOA^.TIPO,' LIN ',LB1); READln(UT) END;

  end
 else
  begin   (* no es nodo deshacer la lista *)
   pn:=nodpos.apns; while pn<>nil do
   begin pna:=pn; pn:=pn^.pns; dispose(pna) end ;nodpos.apns:=nil;
   IF W THEN BEGIN WRITELN('NO FUE NODO');READln(UT) END;
   {Delphi 14.2.2001} if n=0 then warning('Not a Node');
  end;
1: IF W THEN WRITELN('TERMINA BUNOD');
bnsub:=false end; (* fin de subproc. bunod *)

(*d95*) var _nn: integer;
begin (******************** del procedimiento buside *)
 ctit:=true; (* no hay aun INIT *)
 numunt:=1; besunit:=false;
 pnof:=nil; (* apuntador a comienzo lista de nodos *)
 while ctit and (pl^.con[1]<>'$') do
  begin  k:=1;

  recid; (* recoge lo de comienzo de linea INIT MODULE o posible nodo*)

(* ******************** aqui busqueda de nodos ******************** *)
   if nom='INIT'
    then ctit:=false
    else if (nom='MODULE')   (*nueva unidad*)
          then begin lb:=lb+1; pl^.con[1]:=el; (*saltar y tachar linea*)
                pl:=pl^.pls;
                numunt:=numunt+1; besunit:=true;
               end

          else begin (* ver si es nombre seg.de [ :(  *)
                if b and (ch in [' ','[',':','(']  )  then
                   bunod; (*recoge datos del nodo com.1998*)
                lb:=lb+1; pl:=pl^.pls
               end;
IF W THEN WRITELN('VA A VER LA LINEA LB ',LB,' ',PL^.CON);
  end;
 if n=0 then error('no nodes found');

 {IF N>25 THEN BEGIN WRITELN('Too many nodes. Use profesional version');
 HALT end;
 IF NUMUNT>1 THEN
 BEGIN WRITELN('More than a unit. Use profesional version'); HALT end;
 }
(* FORMAR ARREGLO DE NODOS Puede hacerse porque la memoria dinamica
 queda compacta *)
getmem(nod, n*sizeof(node));   (*OJOOOOO*)
pnoa:=pnof;   (* apuntar a comienzo de lista de nodos *)
for _nn:=1 to n do
 begin
  nod^[_nn]:=pnoa^;  (*pasar elemento de lista a arreglo *)
IF W THEN WRITELN('PASA A ARREGLO NODO ',NOD^[NN].NOM);
  pnoa:=pnoa^.pns
 end;

(*hacer dispose de lista de nodos, pues ya se hizo el arreglo *)
 pnoa:=pnof;
 while pnoa<>nil do
  begin pnoan:=pnoa; pnoa:=pnoa^.pns; dispose(pnoan) end;

{IF W THEN IMPNOD;}

 if ctit then error('INIT missing or misplaced')
         else block[2]:=lb;
 (* buscar el DECL si lo hay despues del INIT                        *)
 ctit:=true;  (* no hay aun DECL *)
IF W THEN WRITELN('BUSCANDO DECL *************LB ',LB);
 while ctit and (pl^.con<>'$') do
  begin
IF W THEN WRITELN('LB  ',LB);
   k:=1; recid;
   if nom='DECL' then ctit:=false else begin lb:=lb+1; pl:=pl^.pls end
  end;
 if ctit then warning('no se halla bloque DECL');
 block[3]:=lb; (* posicion de DECL o END.*)
IF W THEN WRITELN('INIT ',BLOCK[2],' DECL O END. ',BLOCK[3]);
1: end; (* fin del procedure buside*)

(**********************************************************PRASM**)

(*********************************************************** PRINPUT*)
procedure prinput; (*procesar INPUT*)
var nfor1,nfor2,cfile,barc:st10; int,int1,ninv,k1:integer;
(**********************************************************RECTITTER*)
procedure rectitter; (*recoger titulo y terminar gen.proced.*)
begin
 inser(ren1,'&',cfile,ren1,0);
 inser(ren1,'#',barc,ren1,0);
 inser(ren1,'/',nfor1,ren1,0);
 inser(ren1,'.',nfor2,ren1,0);
  while pl^.con[k]<> ';' do begin ren1:=ren1+pl^.con[k]; k:=k+1 end;
  ren1:=ren1+''');';
tranlin(ptra,true);   k:=k+1; (*queda desp.de ;*)
end;
(*********************************************************RECFORIN*)
procedure recforin; (*poner var en esq.(ren1)  y recoger formatos
      o bien file,formatos*)

procedure rectitul;
begin if breport then begin cfile:='OUTF'; barc:='_bf' end;
 k:=m; nfor1:='-1'; nfor2:='-1'; rectitter
end;

procedure recformat;
 begin if breport then begin cfile:='outf'; barc:='_bf' end;
  nfor1:=nom;
  recid; if ch<>':' then error(': expected');k:=k+1;
  recid; (*recoge numero o titulo*)
  if not bnumer (*titulo; terminar*)
   then begin k:=m; nfor2:='-1'; rectitter end
   else (*segundo numero tiene que ser real con 2 formats*)
    begin if tipo='INTEGER' then error('incorrect format');
     nfor2:=nom;
     recid; if ch<>':' then error(': expected');k:=k+1;
     rectitter
    end
 end;  (*del else primer numero*)

procedure recfile;
begin if breport then error('file parameter in REPORT');
 cfile:=nom;
 recid; if ch<>':' then errca(':'); k:=k+1;
 recid; (*recoge numero de formato o titulo*)
 if bnumer then recformat else rectitul;
end;

begin     (*de recforin; comienza recolec.de parametros*)
 if ch<>':' then error(': expected');k:=k+1;
 recid; (*recoge file, numero o titulo*)
 if binput then  cfile:='INPUT'
            {d95 else cfile:='OUTPUT'; (*archivos de defecto*)}
            else cfile:='_ars'; (*archivos de defecto*)
 barc:='false';
 if not bnumer  (*file o titulo*)
  then
   begin
    busidar;
    if bva  (*si no es variable es titulo*)
     then (*debe ser FILE o sino es titulo*)
      if pva^.typ='TEXT'
       then begin barc:='true'; recfile end (*parametro de file true*)
       else rectitul    (*primero titulo*)
     else rectitul      (*primero titulo*)
   end
  else  recformat;      (*primero numero  *)
end;

(*d95*) var _i: integer;
begin   (*del PRINPUT*)
 busidar; 
 if bva then
 begin     (*es variable, no funcion*)
 nom2:=nom;  typel:=pva^.typel; ninv:=pva^.dim;
 recid; (*sigue : o [ *)
 if ch='[' then (*posible arreglo o elemento de arreglo*)
  begin  k1:=k;
   k:=k+1; recid; (*ver que sigue a [*)
   k:=k1;         (*reapuntar a [ *)
   if ch<>'.'
    then   (*deberia ser elemento de arreglo*)
    begin
     nom2:=nom2+'[';
      k:=k+1; ch:=',';
      for _i:=1 to ninv do
       begin  if ch<>',' then errca(',');
       (*d95*) i:=_i;
        recid; (*recoge subindice*)
        nom2:=nom2+nom;
        recid; (*recoge , o ] *)   nom2:=nom2+ch;
        k:=k+1;
       end;
     ninv:=0; tipo:=typel;
     recid; (*lo que sigue a ]  (debe ser : )*)
    end else k:=k1;
  end;
 case ninv of     (*ver cada numero de subindices variables*)
  0:begin
     if ch<>':' then errca(':');
     if (tipo='REAL')
      then if binput then ren1:=fosa[372] else ren1:=fosa[376]
       else
     if tipo='DOUBLE'
      then if binput then ren1:=fosa[411] else ren1:=fosa[376]
      else
     if (tipo='INTEGER')
      then if binput then ren1:=fosa[373] else ren1:=fosa[377]
       else
     if tipo='LONGINT'
       then if binput then ren1:=fosa[412] else ren1:=fosa[377]
       else
     if tipo='STR80'
       then if binput then ren1:=fosa[420] else ren1:=fosa[421]
       else error('incorrect type of variable');
     inser(ren1,'*',nom2,ren1,0); (*poner nombre var.en llamada a proc.*)
      recforin;
    end;
  1:begin
     if typel='REAL'
      then
       begin
        ren1:='_par:=addr('+pva^.nom+');' ; tranlin(ptra,true);
        if binput then ren1:=fosa[374] else ren1:=fosa[378]
       end
      else if typel='INTEGER' then
       begin
        ren1:='_pai:=addr('+pva^.nom+');' ; tranlin(ptra,true);
        if binput then ren1:=fosa[375] else ren1:=fosa[379]
       end
      else error('incorrect type of variable');
      recid; if ch<>'[' then error('[ expected'); k:=k+1;
      recid; val(nom,int,int1);
      if int1<>0 then error('number expected');
      inser(ren1,'@',nom,ren1,0);  (*primer subindice*)
      recid; if (ch<>'.') or (pl^.con[k+1]<>'.')
       then error('.. expected'); k:=k+2;
      recid; val(nom,int,int1);
       if int1<>0 then error('number expected');
      inser(ren1,'%',nom,ren1,0);   (*segundo subindice*)
      recid; if ch<>']' then error('] expected'); k:=k+1;
      recid;
      recforin;
    end;
  2:error('two subscript arrays for I/O not implemented yet');
  else error('variable with more than 3 subscripts in input');
 end;

 end
 else
  begin    (*es funcion*)
   repeat
    bc:=TRUE; butafun ;  (*busca en lista de fun.XY
              si esta en lista apunta pfu^ y pone bc=false*)
    if bc then error('variable or function name expected '+nom);
    pfu^.inti:=true;    (*marca para generar _intigraf*)
    recid;
    if b or ((ch<>',') and (ch<>';')) then error(' , or ; expected');
    if ch=',' then  k:=k+1;
    recid; (*recoje siguiente*)

   until not b and (ch=';');
   k:=k+1;
  end;
end;

(*********************************************************PRREPORT*)
procedure prreport; (*procesar REPORT*)
begin
end;
(*****************************************************PRENDREPORT*)
procedure prendreport; (*procesar ENDREPORT*)
begin
end;
(*********************************************************** PRCA *)
procedure prca; (* procesar un arreglo de constantes *)
label 1,2;

procedure receb(var cti:st10); (* verificar tipo y recoger string *)
begin                           (* de elementos de arreglo         *)
IF W THEN BEGIN WRITELN('VERIF TIPO DE CTI ',CTI); READLN(UT);END;
 if (cti='REAL') or (cti='INTEGER') or (cti='BYTE') or (cti='WORD')
  then begin if not bnumer then error('number expected')  end
   (*15/10/1998*)
  else
   if (cti='STRING')
    then
     begin
      if ch<>'''' then error('string  expected');
      recid;              (*recoge string mediante recstr (ug2)*)
      {if ch<>'''' then error('string expected');
      recstr; }
     end
    else
     if cti='CHAR'
      then
       begin if ch<>'''' then error('character expected'); {rechar;}
       end
      else error('type REAL or INTEGER or CHAR or STRING expected');
end;

procedure recidc;
 var ch1:char;
 begin

  recid; (* ver que sigue a ( debe ser ( ) ' o identif. *)

  if not b and ((ch='+') or (ch='-')) then  (*ver si com. por + o - *)
   begin ch1:=ch; k:=k+1; recid; nom:=ch1+nom end;
 end;

begin  (* del prca procesa arreglos de constantes *)
IF W THEN BEGIN WRITELN('PRCA: NOM ',NOM,'  CH ',CH);READln(UT) END;
 k:=k+1;
 recidc; (*recoger constante; puede tener + o - *)
 1:case ch of
    '(':begin prca; k:=k+1; (* elimina ) sigue ) o , *); recid end;
    ')':goto 2; (* salir de prca *)
    else (* viene una constante ya recogida o es ' *)
     begin
      if (ch<>'''') and not b then error('constant expected');
      bcr:=true;
      while bcr do
       begin
        receb(cti); (* recoger str. o verificar constante tipo l *)
IF W THEN READln(UT);
        recid; (* ver que sigue. Debe ser , o ) *)
        if ch=')'
         then bcr:=false  (* salir del while; si no debe ser , *)
         else begin k:=k+1; recidc end (* debe recoger const. y seguir *)
       end; (* del while bcr k esta en ) *)
     end
   end; (* del case *)
   if ch=',' then begin k:=k+1; recidc; goto 1 end;
2: IF W THEN WRITELN('SALIDA DE PRCA');
end; (* salida de prca *)


(*********************************************************** GEFRE *)
procedure gefre(i:integer);
(* gen.instr.de lib. recurso. de nodo i (parametro) *)
var ind:st10;
begin
if bnfree then ind:=nom2 else ind:='ino';
if nod^[i].sub>1 then nomr:=nod^[i].nom+'['+ind+']'
                  else nomr:=nod^[i].nom;
{inser(fosa[187],'*',nomr,ren1,0);tranlin(4,true); (*if 1 0 _use 1 0 *)
inser(fosa[188],'*',nomr,ren1,0);tranlin(4,false);(* si no _use=use *)
ren1:='_use:=use;'; tranlin(4,false); }
inser(fosa[89], '*',nomr,ren1,0);tranlin(4,false);(* aj free  *)
acesura(i);        (* estadistica anterior del u_rxx *)
inser(fosa[175],'*',nomr,ren1,0);tranlin(4,false);(* aj used *)
acesurp(164);   (* estadistica posterior del u_rxx *)
end;

(********************************************************** GLLC *)
procedure gllc; (* generar llamadas a nodos C antecesores *)
var k:integer; inc,inm:st10;
begin
(* buscar los C en lista de antecesores *)
pna:=nod^[k].apna;
while pna<>nil do
begin k:=pna^.num;
 if nod^[k].tipo='C' then
  begin inc:='-1';
   if nod^[k].sub>1 then    (* si tiene subindice     *)
    begin str(nod^[k].sub,inm);
     inser(fosa[275],'*',inm,ren1,0); tranlin(4,true); inc:='_jc'
    end;
   ren1:=nod^[k].nom+'('+inc+');'
  end; (* del if *)
 pna:=pna^.pns
end   (* del while *)
end;

(*********************************************************** FININGL *)
procedure finingl; (* fin de instruccion GLIDER con asociada *)
begin
 if not b and (ch=';')
 then ren1:=fosa[30]   (* end de la instr.G *)
 else if (nom<>'END') and (nom<>'ELSE')
 then error('illegaly ended GLIDER statement')
 else begin ki:=m-1; ren1:=fosa[30] end; (* end de la instr.G *)
 tranlin(ptra,true); ren1:=' '; tranlin(ptra,true);
 btran:=true
end;
(********************************************************* REINAP    *)
procedure reinap; (* recoger indice de apuntador *)
begin
  recid;
  if pva^.ind>1 then (* si hay subindice *)
  begin recid; if ch<>'[' then error('[ expected'); k:=k+1;
   recid; nomx:=nomx+'['+nom+']'; recid;
   if ch<>']' then error('] expected'); k:=k+1;
  end;
end;
(********************************************************* RECAP     *)
procedure recap; (* recoge lista y apuntador; deja en ren3 y nomx *)
begin
 busli(ren3); (* numero de nodo en i2, num. lista en ren3 *)
 recid; if ch<>',' then error(', expected'); k:=k+1;
 recid; (* recoger apuntador *)
 if nom='FIRST' then nomx:='_fl['+ren3+']'
 else
 if nom='LAST'  then nomx:='_ll['+ren3+']'
 else
 begin busidar;
  if tipo<>'GPOINTER' then error('GPOINTER variable expected '+nom);
  nomx:=nom;
  reinap; (* recoger indice de apuntador si lo hay *)
 end
end;
(**************************************************ACESURA ACESURP *)
procedure acesura(jn:integer);    (* actual.estad. used anterior  *)
var ind:st10;
begin
nom:='U_'+nod^[jn].nom;
IF W THEN WRITELN('BUSCAR EN ARBOL ',NOM);
busidar; (* buscar var U_ en arbol *)
IF W THEN WRITELN('ENCONTRADO EN ARBOL ',PVA^.NOM);
IF W THEN BEGIN
WRITELN('NUM.EST ',PVA^.NVL,'  INDICE ',PVA^.IND);READln(UT) END;

if nod^[jn].sub=1
 then begin str(pva^.nvl,invae); cindes:=invae end
 else
  begin
   if bnfree then ind:=nom2 else ind:='ino';
   str(pva^.nvl-1,invae); cindes:=invae+'+'+ind;
   nom:=nom+'['+ind+']';  (* indice del nombre del nodo *)
  end;
ren1:='_prsta('+cindes+','+nom+');' ; tranlin(ptra,true);

end;

procedure acesurp(esif:integer); (* actual.estad. used posterior *)
begin
ren1:='_prstp('+cindes+','+nom+');' ; tranlin(ptra,true);
end;

(********************************************************** BUSEL *)
procedure busel(i,jn:integer;var ren:cont;bsel:boolean);
 (* busca lista de entrada del nodo i (suces.) de reg.provenientes del
 jn (antec);
 se supone en NOM2 el indice actual del sucesor; salida en ren;
 si suc. es D le suma el prod.del indice del D o sea INO-1 por
  dim.del D1 *)

begin  str(nod^[i].sub,cindi);   (*valor maximo del subindice*)

 bulesu(jn,i); (*busca el de jn-->i *)

IF W THEN WRITELN('NBEL=',NBEL,'  NOM2=',NOM2);
 if (nom2='FREE') or (nom2='MIN') then (*formar el EL-1 *)
 str(nbel-1,ren3)        (*poner directamente retorno EL-1 en ren3*)
 else calel(nbel,nom2,ren);(* en ren el del suc.i del jn,nom2=sub*)
                      (* queda esnum=0 si ren es numerico *)
(* OJO si no es SELECT *)
 if bsel then
  begin nom3:='';(*proc. SELECT de nodo D, i es el D, jn el antecesor *)
   if (nod^[i].sub>1) and (nod^[jn].tipo<>'L') then
    begin nbel:=nbel-1; nom3:='ino' end;
   if nod^[jn].sub>1 then
    begin
     val(nom2,vind,esnum);
     if esnum=0
      then
       if nod^[jn].tipo='L' then nbel:=nbel-1+vind
                           else nbel:=nbel+(vind-1)*nod^[i].sub
      else
       if (nod^[i].sub=1) or (nod^[jn].tipo='L')
                           then begin nbel:=nbel-1; nom3:=nom3+nom2 end
                           else nom3:=nom3+'+('+nom2+'-1)*'+cindi
    end;
   str(nbel,ren2); ren2:=ren2+nom3;
  end
  else (* jn es el que envia, i es el sucesor *)
   if (nod^[i].tipo='D') and (nod^[jn].sub>1) (* y si es D y jn indice *)
    then ren:=ren+'+(ino-1)*'+cindi;
end;

(***********************************************************BUSELNL    *)
procedure buselnl(nant,nsuc:integer;inant,insuc:st10; var cind:cont;
                  dimsuc:integer);
(* pone en cind lista de entrada EL_NSUC[INSUC](NANT[INANT]) que es
si suc. no es tipo D : el-1+insuc;
si suc es tipo     D con antec.<>L  el-1+insuc+(inant-1)*dimsuc;
si suc es tipo     D con antec. =L  el-1+inant;                    *)
begin
bulesu(nant,nsuc); (* ver relac. antecesor sucesor; el a nbel  *)
if nod^[nsuc].tipo<>'D'
 then calel(nbel,insuc,cind)
 else (* es sucesor tipo D *)

  if nod^[nant].tipo<>'L' then
   begin calel(nbel,insuc,cind);
    if inant<>'1' then
     begin          (* hay subid. en antecesor *)
      val(inant,vind,esnum) ;
      if esnum=0 then begin vind:=vind-1; str(vind,inant) end
               else inant:='('+inant+'-1)' ;
      if dimsuc>1 then begin str(dimsuc,insuc); inant:=inant+'*'+insuc end;
      cind:=cind+inant
     end;
   end
   else calel(nbel,inant,cind)
end;


(************************************************************GELCASEUP **)
  procedure gelcaseup(i:integer);(* genera comienzo linea case up*** reg. i *)
   var en,en1:st10;
   begin (* poner en modpro linea case upvr si campos decl. o mess, abierta*)
    if nod^[i].dec or bmess then en:=' ' else en:='end;';
    if bmess and not bfield then en:=' ';

    if (not bn) and (nod^[i].dec=false) then en:='end;';

    inser(fosa[278],'*',nic,ren1,0); tranlin(3,false);
    inser(fosa[68]+en,'*',nic,ren1,0); tranlin(3,true);
IF W THEN BEGIN WRITELN('PONER EN LISTAS ELEM.DE CASE UP');
                READln(UT) END;
    (* poner en listas los de upvr uprvo upvro *)

    inser(fosa[279],'*',nic,ren1,0); (* preparar linea case uprv *)
    new(ptrx); ptrx^.pls:=nil; ptrx^.con:=ren1; (* lista para uprv *)
    if ptrf=nil then ptrf:=ptrx else ptrl^.pls:=ptrx; ptrl:=ptrx;
    inser(fosa[88]+en,'*',nic,ren1,0); (* preparar linea case uprv *)
    new(ptrx); ptrx^.pls:=nil; ptrx^.con:=ren1; (* lista para uprv *)
    ptrl^.pls:=ptrx; ptrl:=ptrx;

    inser(fosa[280],'*',nic,ren1,0); (* preparar linea case upvro *)
    new(ptro); ptro^.pls:=nil; ptro^.con:=ren1; (* lista para upvro *)
    if ptrof=nil then ptrof:=ptro else ptrol^.pls:=ptro; ptrol:=ptro;
    inser(fosa[189]+en,'*',nic,ren1,0); (* preparar linea case upvro *)
    new(ptro); ptro^.pls:=nil; ptro^.con:=ren1; (* lista para upvro *)
    ptrol^.pls:=ptro; ptrol:=ptro;

    inser(fosa[281],'*',nic,ren1,0); (* preparar linea case uprvo *)
    new(ptrxo); ptrxo^.pls:=nil; ptrxo^.con:=ren1; (* lista para uprvo *)
    if ptrfo=nil then ptrfo:=ptrxo else ptrlo^.pls:=ptrxo; ptrlo:=ptrxo;
    inser(fosa[190]+en,'*',nic,ren1,0); (* preparar linea case uprvo *)
    new(ptrxo); ptrxo^.pls:=nil; ptrxo^.con:=ren1; (* lista para uprvo *)
    ptrlo^.pls:=ptrxo; ptrlo:=ptrxo;
 end;
(********************************************************** BUSID *)
procedure busid; (* busca identificador hasta eof a partir de pos k *)
label 1;
 begin
 b:=false;
 while not b do        (* mientras no es buscar identificador       *)
   begin
    k:=k+1; recid;      (* recoger ident o eliminar caracter   *)
    if berr then goto 1;
  end;
1: end;

(******************************************************** BUSCHAR *)
procedure buschar(cht:char;var bch:boolean);
(* busca a partir de k el caracter cht, si lo halla devuelve bch
   true, elimina blancos, comentarios, cambia linea
   no recoge identificadores                                        *)
label 1;
 begin
  bch:=true; recid; if berr then goto 1;
  if (ch<>cht) or b then bch:=false; if b then k:=m ;
1:end;

(******************************************************** VERSICH *)
procedure versich(var bchar:boolean);
(* ve si lo que sigue es constante tipo caracter; si es deja true   *)
label 1;
begin
 buschar('''',bch);
 if bch then
  begin recid; if berr then goto 1;
   if b and (k=m+1) and (ch='''') then bchar:=true else bchar:=false
  end
  else bchar:=false;
1:end;

(******************************************************** BUSPOCO *)
procedure buspoco;  (* buscar el ; y recoger lo que sigue           *)
begin  IF W THEN WRITELN('ENTRA A BUSPOCO   PL^.CON[K] ',PL^.CON[K]);
 recid;  (* buscar el ; o el absolute con identificador*)
 if nom='ABSOLUTE' then
  begin
   recid; if b then recid else error('invalid expression after absolute')
  end;

 if (ch<>';') and (ch<>'=') or b then
  error('; or = expected after declaration');
 k:=k+1;             (* hubo un ; o = ir a buscar el siguiente      *)
 recid;
end;    (* fin de procedimiento buspoco  *)

(******************************************************** BUCLADE *)
procedure buclade; (* busca clase de declaracion en taclade *)
 begin
  r:=1; bcl:=true;
  while (nom<>taclade[r]) and (r<=14) do r:=r+1; if r=15 then bcl:=false;
  IF W THEN
    IF BCL THEN WRITELN('BUCLADE HALLO DECLARACION CLASE ',TACLADE[R])
           ELSE WRITELN('BUCLADE NO HALLO CLASE DE DECLARACION',NOM);
 end;

(*********************************************************VERPARE *)
procedure verpar; (*ver si es palabra reservada*)
begin
 bc:=true; butasep; if not bc then error('reserved word used as identifier');
 bc:=true; butainc; if not bc then error('reserved word used as identifier');
 bc:=true; butapro; if not bc then error('reserved word used as identifier');
 bc:=true; bufugli; if not bc then error('reserved word used as identifier');
 buclade;  if bcl then error('reserved word used as identifier');
 bulitip;  if not bc then error('reserved word used as identifier');
 if (nom='PROCEDURE') or (nom='PROGRAM') or (nom='FUNCTION') or (nom='IN')
        then error('reserved word used as identifier');
end;


end.