unit fung;
interface
uses Dialogs, Controls, graphics, tipos , venmenu, inpout, WDgraph; //Delphi
{variable y tipos en unit tipos}
{NUCLEO /abstraction}

procedure _afel(n,i:integer;p:byte;blk:boolean;t:real); (*agr.a fel ord. t *)
{procedure _error(s:_st80); La lleve a venmenu}
{procedure _verpsos; La lleve a venmenu}
procedure block  (n:integer; var b:boolean);
procedure deblock(n:integer; var b:boolean);
{procedure _encsal; (*encabezamiento de salida*) a venmenu  }
procedure _intime; (*intervalo de tiempo*)
procedure _inisinc; (*inicializar proceso busqueda sincronizados*)
procedure _ililisin;  (*eliminar ap. a mensaje sincronizado*)
procedure inisem;
procedure _leerenc(var _ardbase:file);   (*leer encab. de archivo DBASE*)
procedure _copystdb; (*copia struc.DBASE _ardbase a _ardbaseu; DBUPDATE*)
function rnd(i:integer):real; (*numeros aleatorios semilla i *)
function expo(v:real;i:integer):real; (*distr.exponencial*)
function unif(vi,vs:real;i:integer):real;
function unifi(a,b:integer;i:integer):integer;
function tria(a,b,c:real;i:integer):real;
function norm(vm,d:real; i:integer):real; (* numero de dist. normal *)
function gauss(vm,d:real;i:integer):real; (* numero positivo de dist.normal *)
function erlg(v:real;k,i:integer):real; (* Erlang suma k exp. de media v *)
function weibull(e,f:real;i:integer):real; (*Weisbull escala e, forma f*)
function Poisson(m:real;i:integer):integer; (*Poisson*)
function lognorm(m,s:real;i:integer):real;(*lognormal media m, par. s *)
function gamma(m,d:real;i:integer):real;(*funcion gama*)
function beta(a,b:real;i:integer):real;(*funcion beta*)
function min(x,y:real):real;
function max(x,y:real):real;
function mini(x,y:integer):integer;
function maxi(x,y:integer):integer;
function ber(p:real;i:integer):boolean; (* Bernoulli true si rnd(i)<p *)
function modul(x,m:real):real;

IMPLEMENTATION

procedure _afel(n,i:integer;p:byte;blk:boolean;t:real); (*agr.a fel ord.segun t *)
begin
if _bt then begin
              {writeln('ADD TO FEL EV ',N,' IEV ',I,' TIME ',T:10:3);
              if _bftr then} writeln(_ftra,'ADD TO FEL EV ',N,' IEV ',I,
                 ' TIME ',T:10:3);
            {dp _ch:=readkey  inpout._WinPause;} {dp}
            end;

 new(_pf); _pf^.n:=n; _pf^.i:=i; _pf^.t:=t; _pf^.evp:=p;
 if blk then _pf^.su:=TRUE else _pf^.su:=FALSE;_PF^.P:=NIL;
 if _ff=nil then begin _ff:=_pf; _pf^.p:=nil end
  else
  begin _ps:=_ff; _bo:=true;
   while (_ps<>nil) and _bo do
    if t<_ps^.t then _bo:=false
                else begin _py:=_ps; _ps:=_ps^.p end;
   _pf^.p:=_ps;
   if _ps=_ff then _ff:=_pf else _py^.p:=_pf
  end;
end;

procedure block(n:integer;var b:boolean); (*suspende evento n *)
var pfa:_pfel;
begin
b:=true; pfa:=_ff;
 while pfa<>nil do
  begin
   if (pfa^.su=false) and (pfa^.n=n) then pfa^.su:=true;
   pfa:=pfa^.p;
  end
end;

procedure deblock(n:integer; var b:boolean);
var pfa:_pfel;
begin
if b then
 begin
  b:=false; pfa:=_ff;
   while pfa<>nil do
    begin
     if (pfa^.su=true) and (pfa^.n=n) then
      begin pfa^.su:=false; {if pfa^.t<time then pfa^.t:=time}  end;
     pfa:=pfa^.p;
    end
 end
end;

procedure _intime; (*calcula intervalo de tiempo*)
var dh,st,s1,s2,lhoi,lmii,lsei,ldei,lhof,lmif,lsef,ldef:longint;
begin
lhoi:=_hoi;lmii:=_mii;lsei:=_sei;ldei:=_dei;
lhof:=_hof;lmif:=_mif;lsef:=_sef;ldef:=_def;
dh:=lhof-lhoi; if dh<0 then dh:=dh+24;
{16.12.2003 Son miliseconds, no centesimas
st:=dh*360000+(lmif-lmii)*6000+(lsef-lsei)*100+(ldef-ldei);
_dhor:=st div 360000;
s1:=st-_dhor*360000;
_dmi:=s1 div 6000;
s2:=s1-_dmi*6000;
_dse:=s2 div 100;
_dde:=s2-_dse*100;
 fin 16.12.2003}
st:=dh*3600000+(lmif-lmii)*60000+(lsef-lsei)*1000+(ldef-ldei);
_dhor:=st div 3600000;
s1:=st-_dhor*3600000;
_dmi:=s1 div 60000;
s2:=s1-_dmi*60000;
_dse:=s2 div 1000;
_dde:=s2-_dse*1000;
end;

procedure _inisinc; (*inicializar proceso busqueda sincronizados*)
begin
 _pc:=_fs; _sf:=false; _bs:=false; sync:=true; _aas:=true; _plas:=_pc^.p1;
end;

procedure _ililisin;  (*eliminar ap. a mensaje sincronizado*)
begin
_as:=_pc; _pc:=_pc^.p2; dispose(_as);
end;

function rnd(i:integer):real; (*numeros aleatorios semilla i *)
var r:longint;
begin
  r:=rn[i];
  r:=r*65539;
  if r<0 then r:=r+2147483647+1; rn[i]:=r;
  rnd:=r/2147483647;
end;

procedure inisem;
begin
 rn[1]:=29999;rn[2]:=63115;rn[3]:=37357;rn[4]:=68803;rn[5]:=23565;
 rn[6]:=87457;rn[7]:=43731;rn[8]:=79369;rn[9]:=39819;rn[10]:=52341;
end;

procedure _leerenc(var _ardbase:file);   (*leer encab. de archivo DBASE*)
var numdesc,i,j:integer; buff:array[1..180] of char;
begin
(*Lectura de los registros de informacion *)
reset(_ardbase,1); (*apuntar al primero y poner de largo 1*)

(*lee de archivo descr., en area _ledbase, 32 registros de largo 1
  en resul quedan la cantidad realmente leida*)
blockread(_ardbase,_ledbase,32{,_resul});
_lonreg:=_ledbase.byrec;
 numdesc:=((_ledbase.bytenc-1) div 32) -1; (*numero de descriptores de campos*)

 for i:=1 to numdesc do
  begin
   blockread(_ardbase,_ledbase,32{,_resul});  (*leer descriptor de campo*)
   _pdesc:=addr(_ledbase);                  (*aputador a lo leido  ? *)
   _nomdbase:='';
   for j:=1 to 11 do _nomdbase:=_nomdbase+_pdesc^.nomb[j]; (*recoger nombre*)
  end;

blockread(_ardbase,buff,2{,_resul}); (*quitar fin reg y linefeed*)
end;


procedure _copystdb; (*copia struc.DBASE _ardbase a _ardbaseu; DBUPDATE*)
var numdesc,i:word; buff:array[1..128] of char;
begin
blockread (_ardbase ,_ledbase,32{,_resul}); (*leer desc.de registro*)
blockwrite(_ardbaseu,_ledbase,32{,_resul}); (*escr desc.de registro*)
_lonreg:=_ledbase.byrec;
 numdesc:=((_ledbase.bytenc-1) div 32) -1; (*numero de desc. de campos*)
 for i:=1 to numdesc do
  begin
   blockread (_ardbase ,_ledbase,32{,_resul});  (*leer descriptor de campo*)
   blockwrite(_ardbaseu,_ledbase,32{,_resul});  (*escr descriptor de campo*)
  end;
blockread (_ardbase ,buff,2{,_resul}); (*quitar fin reg y linefeed*)
blockwrite(_ardbaseu,buff,2{,_resul}); (*poner  fin reg y linefeed*)
end;

(*****************************************************************)

(*funciones aleatorias y aritmeticas*)
function expo(v:real;i:integer):real;
 begin
  if v<0 then _error('negative parameter in EXPO');
  expo:=-v*ln(rnd(i))
 end;

function unif(vi,vs:real;i:integer):real;
begin
  if vi>vs then _error('parameters in UNIF not in order');
  unif:=vi+(vs-vi)*rnd(i)
end;

function unifi(a,b:integer;i:integer):integer;
var y,z:real;
begin
  if b<a then _error('parameters in UNIFI not in order');
z:=b-a+1;y:=a;unifi:=trunc(y+rnd(i)*z)
end;

function tria(a,b,c:real;i:integer):real; var r,ca,ba,cb:real;
ch:char;
begin r:=rnd(i); ca:=c-a; ba:=b-a; cb:=c-b;
 if(ba<=0) or (cb<=0) then
  _error('parameters of TRIA not in order');
  if r<ba/ca then tria:=a+sqrt(r*ba*ca)
             else tria:=c-sqrt(cb*ca*(1-r))
 end;

function norm(vm,d:real; i:integer):real; (* numero de dist. normal *)
var u,v,x,z:real;
begin
 if d<0 then _error('deviation of GAUSS or NORM negative');

repeat   (*metodo de la relacion (Ripley:Stocasting Simulation)*)
 u:=rnd(i); v:=0.8578*(2*rnd(i)-1); x:=v/u; z:=0.25*x*x;
until (z<1-u) or ( (z<=0.259/u+0.35) and (z<=-ln(u)) );
norm:=d*x+vm;
end;


function gauss(vm,d:real;i:integer):real; (* numero positivo de dist.normal *)
var j:integer;s,v:real;
begin
repeat
v:=norm(vm,d,i);
until v>=0;  gauss:=v;
end;

function erlg(v:real;k,i:integer):real; (* erlang suma k exp. de media v *)
var p:real; j:integer;
begin
 if (v<0) or (k<=0) then _error('parameters in ERLG not positive');
{ p:=1.0;
 for j:=1 to k do p:=p*rnd(i);
 erlg:=-ln(p)*v }
 p:=0; for j:=1 to k do p:=p-v*ln(rnd(i)); erlg:=p;
end;

function weibull(e,f:real;i:integer):real; (*Weisbull escala e, forma f*)
(*para tasa de fallas a*t**b poner e=b+1; f=(e/a)**(1/e)
  donde t es el tiempo y ** significa "elevado a"      *)
begin
  if (e<0) or (f<=0) then _error('parameters in WEIBULL not positive');
  weibull:=(1/f*ln((-e*ln(rnd(i)))));
end;

function Poisson(m:real;i:integer):integer; (*Poisson*)
(*se toman productos de n numeros r hasta que su producto
  se haga menor que exp(-media)  *)
var k:integer; p,h:real;
begin
 if (m<0) then _error('parameter in POISSON not positive');
 h:=exp(-m);
 k:=0; p:=rnd(i); while p>=h do begin p:=p*rnd(i); k:=k+1 end;
 Poisson:=k;
end;

function lognorm(m,s:real;i:integer):real;(*lognormal con media m
  y parametro de forma s. Se toma l:=m*exp(z) siendo z de
  distribucion normal media 0 y desviacion s.
  N.A.J. Hastings and J.B. Peacock. Statistical  Distributions.
  John Wiley & Sons 1974.*)
begin
 if s<=0 then _error('parameter of LOGNORM negative');
 lognorm:=m*exp(norm(0,s,i));
end;

function gamma(m,d:real;i:integer):real;(*funcion gama*)
(*"suma" de a exponenciales de media b*)
(* b=desv*desv/media  a=(media* media)/(desv*desv)  *)

var u1,u2,b1,p,b,a,GAMM:real; a1,j:integer;
begin    (*metodo de Fishman, Johnk y Tadikamalla*)
 b:=d*d/m; a:=m*m/(d*d);
 if (a<=0) then _error('negative parameter in GAMMA ');
  if (a>0) and (a<1)
   then begin
         repeat
          u1:=exp(ln(rnd(i))/a); u2:=exp(ln(rnd(i))/(1-a));
         until u1+u2<=1;
         gamm:=u1/(u1+u2)*(-ln(rnd(i)))*b
        end
   else
    if (a>=1) and (a<5) then
     begin
       a1:=round(int(a)); b1:=a-a1;
       repeat
        p:=1; for j:=1 to a1 do p:=p*rnd(i);
        u1:=a/a1*(-ln(p))
       until rnd(i)<=exp(b1*ln(u1/a))*exp(-b1*(u1/a-1));
       gamm:=u1*b
     end
    else     (*es a>=5 *)
     begin   j:=round(int(a));
      if rnd(1)>a-int(a) then gamm:=erlg(b,j,i)
                         else gamm:=erlg(b,j+1,i);
   end;
   GAMMA:=GAMM;
end;

function beta(a,b:real;i:integer):real;(*funcion beta*)
var g1:real;
begin
 if (a<=0) or (b<=0) then _error('negative parameter in GAMMA ');
 g1:=gamma(1,a,i);
 beta:=g1/(g1+gamma(1,b,i))
end;

function ber(p:real;i:integer):boolean; (* Bernoulli true si rnd(i)<p *)
begin
 if (p<0.0) or (p>1.0) then _error('argument out of range in BER');
 if rnd(i)<p then ber:=true else ber:=false
end;

function min(x,y:real):real;
begin if x<=y then min:=x else min:=y end;

function max(x,y:real):real;
begin if x>=y then max:=x else max:=y end;

function mini(x,y:integer):integer;
begin if x<=y then mini:=x else mini:=y end;

function maxi(x,y:integer):integer;
begin if x>=y then maxi:=x else maxi:=y end;

function modul(x,m:real):real;
begin
 if (m=0) then _error('null module in MODUL');
 modul:=x-int(x/m)*m end;
end.