unit ppgraph;
interface
{multg uses Graphics, tipos, venmenu, wdgraph, Forms, Classes, Dialogs;}
uses Graphics, tipos, venmenu, wdgraph, inpout, Forms, Classes, Dialogs;
{OJO: Delphi Si se pone unit SysUtils (IntToStr,...) hay alguna funcion time
      que se superpone a la variable time de glider}
(*constantes de menues de entrada/salida ejecucion y estadisticas*)
const //dELPHI6 28.1.2002 _nume:string[7]='       ';
      escax: real=0.9; {GL2000}
      escay: real=0.7;  {ajuste de tamano ventana}
      _NmaxGraphics=100;

type
      _pTVarCoords = ^_TVarCoords;
      _TVarCoords = array[1..15] of real; {max-min array[1..2,1..14] of integer;}
                    {como _arrev, pero en 0 se almacena el ri=time}
      TDatosGrafico = class(TObject)  {multag 30.11.2000}
                      _tg:char; nv:integer; col:TColor;
                      _titul: string;  _nomv:_arrnv;
                      _minv,_maxv:_arrev; colv:_arrcv;
                      linewidth: array[1..15] of integer; {Delphi 3.4.2001}
                      PorGgraphic: boolean;
            minvN,maxvN: _arrev;
            NuevaEscala, Cerrando, Refrescando: boolean;
                      _fgr1,_fgr2:_arrfo;  _x:_arrev;
                      _bpg,_bgr,_gr: boolean;
            suVentana: byte;
                      _grm,_xmax,_ymax,_xmin,_ymin,_kgr,_dx,_dy,
                      _linx,_coly,_ii, _paso:integer;
                      _jgr,_lgr,jgr,lgr:array[1..15] of integer;  {max-min}
            pp_buff: string;
            errcod, i, j: integer;
                      panmaxx, panmaxy: integer; {Para ajuste de tamano grafico}
            _UEvent: EventStructure;
            {multig} _ListaPuntos: TList;

      procedure _graph{(tg:char; nv:integer; col:TColor;
                       titul: string; var nomv:_arrnv;
                        var minv,maxv:_arrev;var colv:_arrcv;
                        var f1,f2:_arrfo; var x:_arrev)};
      procedure Refrescador;   {6.03.2001}
      end;

{multg 2001}
procedure CreaGraficos;
procedure CreaUnGrafico;
procedure CerrarGraficos;

var {multig 30.11.00}
     _maxGraphics: word;
     _Grafico: array[1.._NmaxGraphics] of TDatosGrafico;
     _nume:string[7];  //DELPHI6 28.1.2002

implementation

{multg 2001}
procedure CreaGraficos;
var _i,_j: byte;
begin
  for _j:=1 to _maxGraphics do
  begin
    if not _Comenzando then begin
       if (_Grafico[_j]<>nil) and _Grafico[_j]._bgr then
       begin
        with _Grafico[_j] do begin
         _bgr:=false;SelectWindow(suVentana);
         Cerrando:=true;
         if not Grafico.Active then Grafico.SetFocus;
         _bpg:=true; Cerrando:=true; _graph; (* *)
         inpout._WinPause; CloseWindow;
        end;
       _Grafico[_j].Free;
      end;
    end; {not _Comenzando}
    _Grafico[_j]:=TDatosGrafico.Create;
with _Grafico[_j] do begin _bgr:=false;_gr:=true;_bpg:=true;
    NuevaEscala:=false; Cerrando:=false; Refrescando:=false;{max-min}
    PorGgraphic:=false;
    for _i:=1 to 15 do linewidth[_i]:=1;
end;
end;
if _Comenzando then _Comenzando:=false;
end;

procedure CreaUnGrafico;
begin
  if _maxGraphics = _NmaxGraphics then
     MessageDlg('Too many graphics',mtError,[mbOK],0)
  else
  begin
    Inc(_maxGraphics);
    _Grafico[_maxGraphics]:=TDatosGrafico.Create;
    with _Grafico[_maxGraphics] do begin
         _bgr:=false;_gr:=true;_bpg:=true;
         NuevaEscala:=false; Cerrando:=false; Refrescando:=false;{max-min}
    end;
  end;
end;

{procedure RefrescaGrafico;
var _kk: byte;
begin
for _kk:=_maxGraphics downto 1 do
     if (_Grafico[_kk]<>nil) and _Grafico[_kk]._bgr then
     with _Grafico[_kk] do
     if Grafico.NeedToRefresh then begin
          SelectWindow(suVentana);
          if not Grafico.Active then begin
              Grafico.SetFocus;_bpg:=true; _graph;
          end;
     end;
end; }

procedure CerrarGraficos;
var _kk, j: byte; PrimerGrafico: boolean;
begin
PrimerGrafico:=true;
for _kk:=_maxGraphics downto 1 do
    if (_Grafico[_kk]<>nil) then begin
     if (_Grafico[_kk]._bgr) then begin
       if PrimerGrafico then
       begin
         PrimerGrafico:=false;
         _WinMensaje('Closing Graphics');
         for j:=1 to _kk-1 do
             if (_Grafico[j]<>nil) and _Grafico[j]._bgr then
                aGrafico[_Grafico[j].suVentana].Enabled:=false;
       end
       else aGrafico[_Grafico[_kk].suVentana].Enabled:=true;
       with _Grafico[_kk] do begin
         _bgr:=false;SelectWindow(suVentana);
         Cerrando:=true;
         if not Grafico.Active then Grafico.SetFocus;
         _bpg:=true; Cerrando:=true; _graph; (* *)
         inpout._WinPause; CloseWindow;
       end;
     end;
     _Grafico[_kk].Free; _Grafico[_kk]:=nil;
    end;
end;
{fin multg}

procedure TDatosGrafico.Refrescador;
begin _bpg:=true; if not Cerrando and not _Comenzando then
                  begin Refrescando:=true; _graph; end;
end;

procedure TDatosGrafico._graph{(tg:char; nv:integer; col:TColor;
                           titul: string; var nomv:_arrnv;
                           var minv,maxv:_arrev;var colv:_arrcv;
                           var f1,f2:_arrfo; var x:_arrev)};
var i,j,ptext,{xin,yin,}kx,ky,ks,panmaxy1, usedpos:integer;
nume:string[12]; nom:string[12];
    ri:real;
    n:array[1..2] of integer;
    n2: integer;
    _pVarCoords: _pTVarCoords;
begin

{xin:=60; yin:=60; ?}
if _bpg then                   (*inicializacion del grafico*)
 begin _bpg:=false; _bgr:=true;
  { _dirbgi:='';
   if paramcount=_posparmbgi then _dirbgi:=paramstr(_posparmbgi); }
   if  _gr then
   {multg 1.12.2000} begin _gr:=false;
   {Delphi 19.2.2001} if _windowsize then
      suVentana:=initgraph(WindowWidth,WindowHeight,_titul) else
      begin {19.2.2001}
   {d95} if (_tg='T') and (_maxv[1]>100) then
            {GL2000 initgraph(700,400,title)}
            suVentana:=initgraph(Screen.Width,Screen.Height div 2{400},_titul)
         else suVentana:=initgraph(Screen.Width div 2-10{500},
                                   Screen.Height div 2-10{400},_titul);
      end; {19.2.2001}
         _ListaPuntos:=TList.Create;
         _ListaPuntos.Capacity:=100000;
         {inicializar min y max de escala por si hay cambiosmin-max 2001}
         for i:=1 to nv do begin           //Delphi 31.5.2001 antes desde 2
             if _minv[i]=_maxv[i] then     //Delphi 31.5.2001 comienza
             begin
               if _minv[i]=0 then _minv[i]:=0.1;
               if _minv[i]<0 then begin _minv[i]:=_minv[i]*2;
                                        _maxv[i]:=_minv[i]*0.5;
                                  end
               else               begin _minv[i]:=_minv[i]*0.5;
                                        _maxv[i]:=_minv[i]*2;
                                  end;
               MessageDlg('Minimum=Maximum. Graphic Scale was changed ',
                          mtWarning,[mbOK],0);
             end;
             minvN[i]:=_minv[i];  maxvN[i]:=_maxv[i]; end;
         aGrafico[suVentana].Refresher:=Refrescador; {6.03.2001}
   end;
   {max-min}
   if Cerrando and NuevaEscala then
   begin
     MessageDlg('Graphic Scale was changed ',mtWarning,[mbOK],0);
     for i:=2 to nv do begin
         _minv[i]:=minvN[i]; _maxv[i]:=maxvN[i]; end;
   end;
   {multg 30.11.2000}     SelectWindow(suVentana);
   setbkcolor(col); cleardevice;  {Delphi se cambio el orden}
   ptext:={D 15} 25; _kgr:=1;
   panmaxx:=round(getmaxx*escax);
   panmaxy:=round(getmaxy*escay);
                                (*incorporar los if !!!!!!*)
 (*posicion de los ejes el X en el cero de var2, el Y en el de var1*)
 if _minv[2]>0 then kx:=0 else kx:=1; (*si comienza con valor positivo*)
 if _minv[1]>0 then ky:=0 else ky:=1; (*ponerlo en el extremo (o casi?)*)
 (*Delphi 16.5.2001
 _linx:=round(panmaxy*(1+kx*_minv[2]/(_maxv[2]-_minv[2])){+20}-20);*)
 _linx:=round(panmaxy*(1+kx*_minv[2]/(_maxv[2]-_minv[2]))-(1-kx)*20{+20});
 {_coly:=round(panmaxx*( -ky*minv[1]/(maxv[1]-minv[1]))+ 55);}
 _coly:=75;

 {d95}
 if _tg='T' then
 begin
   {GL2000}
   _dx:=round((panmaxx-_coly)/100) {15};
   if _dx<15 then _dx:=15; {GL2000 fin}
   {GL2000 _paso:=round(maxv[1]/(panmaxx-_coly));
   if _paso = 0 then _paso:=1; }
   (*n[2]:=round((panmaxx{-_coly})/_dx);*)
   {GL2000}
   n[2]:=round((panmaxx-_coly)/_dx);
   if _maxv[1]>n[2] then _paso:=round(_maxv[1]/n[2])else _paso:=1;  {GL2000 fin}
   _xmin:=_coly; _xmax:=_coly + n[2]*_dx;
   n2:=n[2];
 end
 else
 begin
   _dx:=panmaxx div 12;
   {Delphi 22.3.2001} if _minv[1] >= 0 then n[2]:=0 else
   n[2]:=round(-_minv[1]/(_maxv[1]-_minv[1])*10);  {Delphi}
   if (n[2]=0) and (_minv[1]<0) then n[2]:=1;
   {d95} n2:=10;
   (*limites del grafico  en x *)
   _xmin:=_coly{-n[2]*_dx+_dx};  {Delphi}; _xmax:=_coly+(10{-n[2]})*_dx; //D
 end;
 _dy:=panmaxy div 12;                  (* o 13?? *)

  (*numero de cuadros a cada lado de los ejes: n1,n2 negat. *)
  {Delphi 22.3.2001} if _minv[2] >= 0 then n[1]:=0 else
   n[1]:=round(-_minv[2]/(_maxv[2]-_minv[2])*10);
{d95 arriba   n[2]:=round(-minv[1]/(maxv[1]-minv[1])*10); }
   if (n[1]=0) and (_minv[2]<0) then n[1]:=1;
{d95 arriba   if (n[2]=0) and (minv[1]<0) then n[2]:=1;}

(*limites del grafico y*)

  _ymin:=_linx+n[1]*_dy{+_dy}; {Delphi} _ymax:=_linx-(10-n[1])*_dy;
  setlinestyle({solidln}psSolid,0,{thickwidth} 2);
  setcolor(colv[1]);
  line(_xmin,_linx,_xmax,_linx);  (*eje TIME o X *)
  setcolor(colv[2]);
  line(_coly,_ymin,_coly,_ymax);  (*eje variable 1*)

  SetTextJustify(CenterText,TopText);
  SetTextStyle(ArialFont,VertDir,SmallFont);

{d95
  if tg='T' then
  begin                        (*si es tipo T ,poner*)
   ri:=time;
   str(ri:f1[1]:f2[1],nume);   (*valor inicial eje horizontal*)
   setcolor(colv[1]);
   outtextxy(_coly,_ymin+40,nume);
  end;
}
  setlinestyle({dottedln}psDot,0,{normwidth} 1);
  (*rayas verticales y valores X en graf. X*)
   for i:=0 to n2 do    {Delphi 22.3.2001}
   begin
    setcolor({DARKGRAY} clDkGray);
    line(_xmin+_dx*i,_ymin,_xmin+_dx*i,_ymax);
    if _tg='X' then
     begin
      setcolor(colv[1]);
      {if i=n[2] then ri:=0 else} ri:=_minv[1]+(_maxv[1]-_minv[1])/10*i;
      str(ri:_fgr1[1]:_fgr2[1], nume);
      {outtextxy(_xmin+_dx*i-40,_ymin+10,nume);}
      outtextxy(_coly + i*_dx,_ymin+40,nume);
     end
     else {d95 tg='T'} begin
       str(round(i*{GL2000_dx*}_paso):_fgr1[1],nume);   (*valor inicial eje horizontal*)
       setcolor(colv[1]);
       outtextxy(_coly + i*_dx,_ymin+40,nume);
     end;
   end;

   {SetTextJustify(CenterText,TopText);}
   SetTextStyle(ArialFont,HorizDir,SmallFont);

  for i:=0 to 10 do     (*rayas horizontales y valores Y *)
   begin
    setcolor({DARKGRAY} clDkGray);
    line(_xmin,_ymin-_dy*i,_xmax,_ymin-_dy*i);
    setcolor(colv[2]);
    str(_minv[2]+(_maxv[2]-_minv[2])/10*i:_fgr1[1]:_fgr2[1], nume);
    outtextxy(_coly-54,_ymin-_dy*i-3,nume);
   end;

  setlinestyle({solidln} psSolid,0,{normwidth} 1);

  if _tg='T' then j:=2 else j:=1;
  panmaxy1:=panmaxy + 50 {40 }{22};
  moveto(ptext,panmaxy1);
  settextjustify(lefttext,toptext);
  usedpos:=0;
  for i:=j to nv do   (*poner nombres y escalas de variables*)
   begin setcolor(colv[i]);  nom:=_nomv[i]{d} + ' ';
    outtext(nom+' ');
    str(_minv[i]:_fgr1[i]:_fgr2[i],nume);
    usedpos:=usedpos+length(nom+nume)+1;
    ks:=1; while nume[ks]=' ' do ks:=ks+1; delete(nume,1,ks-1);
    outtext(nume);
    str(_maxv[i]:_fgr1[i]:_fgr2[i],nume);
    ks:=1; while nume[ks]=' ' do ks:=ks+1; delete(nume,1,ks-1);
    outtext(':'+nume+' ');
    usedpos:=usedpos + length(nume) +2;
    {Delphi 3.4.2001 if usedpos > 80 then}
    if usedpos*TextWidth('T') > panmaxx-ptext then
    begin usedpos:=0; panmaxy1:=panmaxy1+20; moveto(ptext,panmaxy1); end;
   end;
    setcolor(colv[1]); outtextxy(1,1,_titul);
   (*poner puntos iniciales;  valor de abscisa*)
  (*if tg='T'
   then begin
          {d95 El titulo se le puso a la ventana al crearla}
          _jgr[1]:=_coly;
        end; *) {max-min, no hacia falta}
{multg 5.12.2000}
  if Refrescando or Cerrando {or aGrafico[suVentana].NeedToRefresh} then
  begin if Refrescando then Refrescando:=false;
        {if aGrafico[suVentana].NeedToRefresh
        then aGrafico[suVentana].NeedToRefresh:=false;}
  if _ListaPuntos.Count > 0 then
  begin
    SelectWindow(suVentana);
    for j:=1 to _ListaPuntos.Count-1 do begin
     for i:=2 to nv do
     begin
       setcolor(colv[i]); setlinestyle(psSolid,0,linewidth[i]);
       lgr[i]:=round(_ymin-(_pTVarCoords(_ListaPuntos.Items[j-1])^[i]-_minv[i])
             *10*_dy/(_maxv[i]-_minv[i]));
       if _tg='T' then begin
                      ri:=_pTVarCoords(_ListaPuntos.Items[j-1])^[1];
                      jgr[i]:=round(ri/_paso*_dx {GL2000} ) + _coly;
                      end
       else jgr[i]:=round(_coly+(_pTVarCoords(_ListaPuntos.Items[j-1])^[1]
            -_minv[1])*10*_dx/(_maxv[1]-_minv[1]));
       moveto(jgr[i],lgr[i]);
       lgr[i]:=round(_ymin-(_pTVarCoords(_ListaPuntos.Items[j])^[i]-_minv[i])
             *10*_dy/(_maxv[i]-_minv[i]));
       if _tg='T' then begin
                      ri:=_pTVarCoords(_ListaPuntos.Items[j])^[1];
                      jgr[i]:=round(ri/_paso*_dx {GL2000} ) + _coly;
                     end
      else jgr[i]:=round(_coly+(_pTVarCoords(_ListaPuntos.Items[j])^[1]
           -_minv[1])*10*_dx/(_maxv[1]-_minv[1]));
       lineto(jgr[i],lgr[i]);
    end; {for i}
  end; {for j}
  end; {ListaPuntos.Count}
  {if aGrafico[suVentana].NeedToRefresh
        then aGrafico[suVentana].NeedToRefresh:=false;}
  end {Refrescando} else
  begin
  for i:=2 to nv do
   begin
{D16.5.2001_lgr[i]:=round(_linx-(_x[i]-_minv[i])*10*_dy/(_maxv[i]-_minv[i]));}
    _lgr[i]:=round(_ymin-(_x[i]-_minv[i])*10*_dy/(_maxv[i]-_minv[i]));
    if _tg='T'
     then _jgr[i]:=round(time/_paso*_dx {GL2000} )+_coly
     else _jgr[i]:=round(_coly+(_x[1]-_minv[1])*10*_dx/(_maxv[1]-_minv[1]));
    putpixel(_jgr[i],_lgr[i],colv[i]);
   end;

{multag 5.12.2000} New(_pVarCoords);
                   for i:=2 to nv do
                       _pVarCoords^[i]:=_x[i];
                       if _tg='T' then _pVarCoords^[1]:=time
                                 else _pVarCoords^[1]:=_x[1];
                       {_pVarCoords^[2,i-1]:=_lgr[i]; }
                   _ListaPuntos.Add(_pVarCoords);
   end;
 end        (*fin de arranque del grafico*)

 else
 begin      (*para los puntos siguientes al arranque*)
 {multg 1.12.2000} SelectWindow(suVentana);
 if _tg='T' then begin
  (*cartelito de la hora *)
   {AQUI problema con el fondo blanco
         setcolor(BLACK); outtextxy(getmaxx-110,20,_nume); }
   setcolor({clBlack} col); outtextxy(_xmax,{panmaxx+40,-60,20} 10,_nume);
   str(time:_fgr1[1]:_fgr2[1],_nume);
   {setcolor(WHITE); outtextxy(getmaxx-110,20,_nume); }
 setcolor({clWhite}colv[1]); outtextxy(_xmax,{panmaxx+40,-60,}10,_nume);
 {AQUI ver si esta bien este}
 end;
  for i:=2 to nv do
   begin
    setcolor(colv[i]); setlinestyle(psSolid,0,linewidth[i]);
    {multg 6.12.2000}
    (*if _ListaPuntos.Count > 0 then
    moveto(_pTVarCoords(_ListaPuntos.Items[_ListaPuntos.Count-1])^[1,i-1],
           _pTVarCoords(_ListaPuntos.Items[_ListaPuntos.Count-1])^[2,i-1])
    else {multg fin 6.12.2000} *)
    moveto(_jgr[i],_lgr[i]);
    if _tg='T'
     then {_jgr[i]:=_jgr[i]+1}    (*incremento eje horizontal*)
     {d95} begin
        ri:=time;
        _jgr[i]:=round(ri/_paso*_dx {GL2000} ) + _coly;
        {str(ri:f1[1]:f2[1],nume);}
     end
     else _jgr[i]:=round(_coly+(_x[1]-_minv[1])*10*_dx/(_maxv[1]-_minv[1]));
{D 16.5.2001 _lgr[i]:=round(_linx-(_x[i]-_minv[i])*10*_dy/(_maxv[i]-_minv[i]));}
    _lgr[i]:=round(_ymin-(_x[i]-_minv[i])*10*_dy/(_maxv[i]-_minv[i]));
    lineto(_jgr[i],_lgr[i]);
{max-min variable Delphi 8.01.2001}
    if _x[i] < minvN[i] then begin {_bpg:=true;}
                             if _x[i] > 0 then minvN[i]:=_x[i]*0.8
                                          else minvN[i]:=_x[i]*1.2;
                             NuevaEscala:=true;
                             {_ListaPuntos.Clear;
                             MessageDlg('Changing Scale', mtWarning,[mbOk],0);}
                         end;
    if _x[i] > maxvN[i] then begin {_bpg:=true;}
                             if _x[i] > 0 then maxvN[i]:=_x[i]*1.8
                                          else maxvN[i]:=_x[i]*0.8;
                             NuevaEscala:=true;
                             {_ListaPuntos.Clear;
                             MessageDlg('Changing Scale', mtWarning,[mbOk],0);}
                           end;

{max-min variable Delphi fin 8.01.2001}
{d95
    if (tg='T') and (_jgr[2]=_kgr*_dx+_xmin-2) and (i=2)
     then
      begin str(x[1]:f1[1]:f2[1],nume); setcolor(colv[1]);
        SetTextStyle(ArialFont,VertDir,SmallFont);
        outtextxy(_jgr[2],_ymin+40,nume);
        SetTextStyle(ArialFont,HorizDir,SmallFont);
       _kgr:=_kgr+1
      end; }
   end;
{multag 5.12.2000} New(_pVarCoords);
                   for i:=2 to nv do _pVarCoords^[i]:=_x[i];
                   if _tg='T' then _pVarCoords^[1]:=time
                             else _pVarCoords^[1]:=_x[1];
                   _ListaPuntos.Add(_pVarCoords);
                   {aGrafico[suVentana].AbriendoResize:=false;}

   {d95 if tg='T' then _jgr[1]:=_jgr[1]+1;  }

   (*parada de fin de pantalla*)
   (*if (tg='T') and (_jgr[1]+1>=_xmax)
    then begin _bpg:=true; {_ch:=' ';
      while _ch<>'C' do
       begin
        DELAY(10.0/(24*3600)); _CH:='C';
       end;}
    repeat
      NextEvent(_UEvent);
    until  _UEvent.EventType = EventKey {GL2000 <> NoneEvent} ;
    _gr:=false end;*)

    {multg 1.12.2000 if aGrafico[suVentana].NeedToRefresh then
    begin  _bpg:=true; end; }

 end
end;

begin   //Delphi6 28.2.2002
  _nume:='       ';  //Delphi6 28.2.2002
end.